!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        module module_fltbnds
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
include 'kind.inc'
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
real(kind=kfpt),parameter:: &
 pi=3.141592653589793238462643383279502884197169399375105820 &
,pih=pi/2. &
,tpi=pi+pi &
,dtr=pi/180.
!-----------------------------------------------------------------------
                        contains
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine prefft &
(im,jm &
,dlmd,dphd,sbd &
,khfilt,kvfilt &
,hfilt,vfilt &
,wfftrh,nfftrh,wfftrw,nfftrw)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
logical(kind=klog):: &
 first

real(kind=kfpt),parameter:: &
 cfilt=1. &
,cxnc=0.00 &
,rwind=1./3. !2. !2.6 !3.

integer(kind=kint),dimension(1:15):: &
 nfftrh &
,nfftrw 

real(kind=kfpt),dimension(1:2*(im-3)):: &
 wfftrh &
,wfftrw

integer(kind=kint),dimension(1:jm):: &
 khfilt &
,kvfilt

real(kind=kfpt),dimension(1:im,1:jm):: &
 hfilt &
,vfilt
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      icycle=im-3
      rcycle=1./icycle
!                                                      
      dlm=dlmd*dtr                                                      
      dph=dphd*dtr
      sb=sbd*dtr
      sbw=sb-dph*0.5
!
      cpf=dph/dlm !* 0.71
!-------------filter on h rows------------------------------------------
      do j=3,jm-2
        tph=float(j-2)*dph+sb
        cph=cos(tph)
        rcph=(cph/cpf)
        ks=icycle
        nsmud=0
        khfilt(1)=icycle+1
        if(rcph.lt.cfilt) then
          khfilt(j)=icycle
          hfilt(1,j)=rcycle
          first=.true.
          do k=2,icycle-1,2
            x=k*dlm*0.25
            xl=min(x/rcph*cfilt,pih)
            sxl=sin(xl)+sin(2.*xl)/2.*rwind          
            if(rcph/sxl.gt.cfilt) then
              flt=rcycle
              ks=k
            else
!--filter definition----------------------------------------------------
                cx=cos(x)
                if(abs(cx).lt.1.e-7) first=.false.
                if(first) then
                  nnew=(log(sxl/(xl*(1.+rwind)))/log(cx)+0.5)
                  if(nnew.gt.nsmud) nsmud=nnew
                  if(mod(nsmud,2).gt.0) nsmud=nsmud+1
                  if(xl.eq.pih) first=.false.
                endif
!-----------------------------------------------------------------------
              cxn=cx**nsmud
              if(cxn.lt.cxnc) then
                khfilt(j)=k-1
                do k2=k,icycle+1
                  hfilt(k,j)=0.
                enddo
                go to 100
              endif
              flt=min(cxn*rcycle,rcycle)
            endif
            hfilt(k  ,j)=flt
            hfilt(k+1,j)=flt
!
!            if(j.lt.10) &
!            print*,'hfilt ',j,k,nsmud,hfilt(k,j),hfilt(k+1,j)
!
          enddo
          x=icycle*dlm*0.25
          xl=min(x/rcph*cfilt,pih)
          sxl=sin(xl)+sin(2.*xl)/2.*rwind          
          if(rcph/sxl.gt.cfilt) then
            flt=rcycle
            ks=k
          else
!--filter definition----------------------------------------------------
                cx=cos(x)
                if(abs(cx).lt.1.e-7) first=.false.
                if(first) then
                  nnew=(log(sxl/(xl*(1.+rwind)))/log(cx)+0.5)
                  if(nnew.gt.nsmud) nsmud=nnew
                  if(mod(nsmud,2).gt.0) nsmud=nsmud+1
                  if(xl.eq.pih) first=.false.
                endif
!-----------------------------------------------------------------------
              cxn=cx**nsmud
              if(cxn.lt.cxnc) then
              khfilt(j)=icycle
            else
              cxn=0.
            endif
            flt=min(cxn*rcycle,rcycle)
          endif
          hfilt(icycle,j)=flt
        else
          khfilt(j)=icycle+1
          do k=1,icycle
            hfilt(k  ,j)=rcycle
          enddo
        endif
 100  continue
!      if(ks.gt.khfilt(j)) ks=0
!      print*,j,ks,nsmud,khfilt(j)
      enddo
      khfilt(1)=khfilt(3)
      khfilt(2)=1
      khfilt(jm-1)=1
      khfilt(jm  )=khfilt(jm-2)
          do k=1,icycle
      hfilt(k,1)=hfilt(k,3)
      hfilt(k,2)=0.
      hfilt(k,jm-1)=0.
      hfilt(k,jm  )=hfilt(k,jm-2)
          enddo
      hfilt(1,2)=1.
      hfilt(1,jm-1)=1.
!-------------filter on v rows------------------------------------------
      do j=2,jm-2
        tph=float(j-1)*dph+sbw
        cph=cos(tph)
        rcph=(cph/cpf)
        ks=icycle
        nsmud=0
        kvfilt(j)=icycle+1
        if(rcph.lt.cfilt) then
          kvfilt(j)=icycle
          vfilt(1,j)=rcycle
          first=.true.
          do k=2,icycle-1,2
            x=k*dlm*0.25
            xl=min(x/rcph*cfilt,pih)
            sxl=sin(xl)+sin(2.*xl)/2.*rwind          
            if(rcph/sxl.gt.cfilt) then
              flt=rcycle
              ks=k
            else
!--filter definition----------------------------------------------------
                cx=cos(x)
                if(abs(cx).lt.1.e-7) first=.false.
                if(first) then
                  nnew=(log(sxl/(xl*(1.+rwind)))/log(cx)+0.5)
                  if(nnew.gt.nsmud) nsmud=nnew
                  if(mod(nsmud,2).gt.0) nsmud=nsmud+1
                  if(xl.eq.pih) first=.false.
                endif
!-----------------------------------------------------------------------
              cxn=cx**nsmud
              if(cxn.lt.cxnc) then
                kvfilt(j)=k-1
                do k2=k+1,icycle+1
                  vfilt(k,j)=0.
                enddo
                go to 200
              endif
              flt=min(cxn*rcycle,rcycle)
            endif
            vfilt(k  ,j)=flt
            vfilt(k+1,j)=flt
!
!            if(j.lt.10) &
!            print*,'vfilt ',j,k,nsmud,vfilt(k,j),vfilt(k+1,j)
!
          enddo
          x=icycle*dlm*0.25
          xl=min(x/rcph*cfilt,pih)
          sxl=sin(xl)+sin(2.*xl)/2.*rwind          
          if(rcph/sxl.gt.cfilt) then
            flt=rcycle
            ks=k
          else
!--filter definition----------------------------------------------------
                cx=cos(x)
                if(abs(cx).lt.1.e-7) first=.false.
                if(first) then
                  nnew=(log(sxl/(xl*(1.+rwind)))/log(cx)+0.5)
                  if(nnew.gt.nsmud) nsmud=nnew
                  if(mod(nsmud,2).gt.0) nsmud=nsmud+1
                  if(xl.eq.pih) first=.false.
                endif
!-----------------------------------------------------------------------
              cxn=cx**nsmud
              if(cxn.lt.cxnc) then
              kvfilt(j)=icycle
            else
              cxn=0.
            endif
            flt=min(cxn*rcycle,rcycle)
          endif
          vfilt(icycle,j)=flt
        else
          kvfilt(j)=icycle+1
          do k=1,icycle
            vfilt(k  ,j)=rcycle
          enddo
        endif
 200  continue
      if(ks.gt.kvfilt(j)) ks=0
!      print*,j,ks,nsmud,kvfilt(j)
      enddo
      kvfilt(1)=kvfilt(2)
      kvfilt(jm-1)=kvfilt(jm-2)
          do k=1,icycle
      vfilt(k,1)=vfilt(k,2)
      vfilt(k,jm-1)=vfilt(k,jm-2)
          enddo
      call rffti(icycle,wfftrh,nfftrh)
      call rffti(icycle,wfftrw,nfftrw)
!-----------------------------------------------------------------------
                        endsubroutine prefft
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine fftfh2 &
(im,jm &
,khfilt &
,hfilt &
,h2 &
,wfftrh,nfftrh)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
integer(kind=kint),dimension(1:15),intent(in):: &
 nfftrh

integer(kind=kint),dimension(1:jm),intent(in):: &
 khfilt(jm)

real(kind=kfpt),dimension(1:im,1:jm),intent(in):: &
 hfilt

real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 h2

real(kind=kfpt),dimension(1:im-3):: &
 buff

real(kind=kfpt),dimension(1:2*(im-3)):: &
 wfftrh  
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      icycle=im-3
      rcycle=1./icycle
!-----------------------------------------------------------------------
      as=0.
      an=0.
      do i=2,im-2
        as=h2(i,2   )+as
        an=h2(i,jm-1)+an
      enddo
      as=as*rcycle
      an=an*rcycle
      do i=1,im
        h2(i,2   )=as
        h2(i,jm-1)=an
      enddo
!-----------------------------------------------------------------------
      do j=3,jm-2
!-----------------------------------------------------------------------
        if(khfilt(j).le.icycle) then
!-----------------------------------------------------------------------
          do i=2,im-2
            buff(i-1)=h2(i,j)
          enddo
!
          call rfftf(icycle,buff,wfftrh,nfftrh)
!
          do i=1,khfilt(j)
            buff(i)=buff(i)*hfilt(i,j)
          enddo
          do i=khfilt(j)+1,icycle
            buff(i)=0.
          enddo
!
          call rfftb(icycle,buff,wfftrh,nfftrh)
!
          do i=2,im-2
            h2(i,j)=buff(i-1)
          enddo
          h2(im-1,j)=buff(1)
!-----------------------------------------------------------------------
        endif
!-----------------------------------------------------------------------
      enddo
!-----------------------------------------------------------------------
                        endsubroutine fftfh2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine fftfhn &
(im,jm,km &
,khfilt &
,hfilt &
,hn &
,wfftrh,nfftrh)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
integer(kind=kint),dimension(1:15),intent(in):: &
 nfftrh

integer(kind=kint),dimension(1:jm),intent(in):: &
 khfilt(jm)

real(kind=kfpt),dimension(1:im,1:jm),intent(in):: &
 hfilt

real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn

real(kind=kfpt),dimension(1:im-3):: &
 buff

real(kind=kfpt),dimension(1:2*(im-3)):: &
 wfftrh  
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      icycle=im-3
      rcycle=1./icycle
!-----------------------------------------------------------------------
      do l=1,km
        as=0.
        an=0.
        do i=2,im-2
          as=hn(i,2   ,l)+as
          an=hn(i,jm-1,l)+an
        enddo
        as=as*rcycle
        an=an*rcycle
        do i=1,im
          hn(i,2   ,l)=as
          hn(i,jm-1,l)=an
        enddo
      enddo
!-----------------------------------------------------------------------
      do l=1,km
!-----------------------------------------------------------------------
        do j=3,jm-2
!-----------------------------------------------------------------------
          if(khfilt(j).le.icycle) then
!-----------------------------------------------------------------------
            do i=2,im-2
              buff(i-1)=hn(i,j,l)
            enddo
!
            call rfftf(icycle,buff,wfftrh,nfftrh)
!
            do i=1,khfilt(j)
              buff(i)=buff(i)*hfilt(i,j)
            enddo
            do i=khfilt(j)+1,icycle
              buff(i)=0.
            enddo
!
            call rfftb(icycle,buff,wfftrh,nfftrh)
!
            do i=2,im-2
              hn(i,j,l)=buff(i-1)
            enddo
            hn(im-1,j,l)=buff(1)
!-----------------------------------------------------------------------
          endif
!-----------------------------------------------------------------------
        enddo
!-----------------------------------------------------------------------
      enddo
!-----------------------------------------------------------------------
                        endsubroutine fftfhn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine fftfwn &
(im,jm,km &
,kvfilt &
,vfilt &
,wn &
,wfftrw,nfftrw)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
integer(kind=kint),dimension(1:15),intent(in):: &
 nfftrw

integer(kind=kint),dimension(1:jm),intent(in):: &
 kvfilt(jm)

real(kind=kfpt),dimension(1:im,1:jm),intent(in):: &
 vfilt

real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 wn

real(kind=kfpt),dimension(1:im-3):: &
 buff

real(kind=kfpt),dimension(1:2*(im-3)):: &
 wfftrw
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      icycle=im-3
      rcycle=1./icycle
!-----------------------------------------------------------------------
      do l=1,km
!-----------------------------------------------------------------------
        do j=2,jm-2
!-----------------------------------------------------------------------
          if(kvfilt(j).le.icycle) then
!-----------------------------------------------------------------------
            do i=2,im-2
              buff(i-1)=wn(i,j,l)
            enddo
!
            call rfftf(icycle,buff,wfftrw,nfftrw)
!
            do i=1,kvfilt(j)
              buff(i)=buff(i)*vfilt(i,j)
            enddo
            do i=kvfilt(j)+1,icycle
              buff(i)=0.
            enddo
!
            call rfftb(icycle,buff,wfftrw,nfftrw)
!
            do i=2,im-2
              wn(i,j,l)=buff(i-1)
            enddo
            wn(im-1,j,l)=buff(1)
!-----------------------------------------------------------------------
          endif
!-----------------------------------------------------------------------
        enddo
!-----------------------------------------------------------------------
      enddo
!-----------------------------------------------------------------------
                        endsubroutine fftfwn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!    subroutine rffti(n,wsave,nsave)                                                 
!                                                                              
!     SUBROUTINE RFFTI INITIALIZES THE ARRAY WSAVE WHICH IS USED IN             
!     BOTH RFFTF AND RFFTB. THE PRIME FACTORIZATION OF N TOGETHER WITH          
!     A TABULATION OF THE TRIGONOMETRIC FUNCTIONS ARE COMPUTED AND              
!     STORED IN WSAVE.                                                          
!                                                                               
!     INPUT PARAMETER                                                           
!                                                                               
!     N       THE LENGTH OF THE SEQUENCE TO BE TRANSFORMED.                     
!                                                                               
!     OUTPUT PARAMETER                                                          
!                                                                               
!     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.           
!             THE SAME WORK ARRAY CAN BE USED FOR BOTH RFFTF AND RFFTB          
!             AS LONG AS N REMAINS UNCHANGED. DIFFERENT WSAVE ARRAYS            
!             ARE REQUIRED FOR DIFFERENT VALUES OF N. THE CONTENTS OF           
!             WSAVE MUST NOT BE CHANGED BETWEEN CALLS OF RFFTF OR RFFTB.        
!                                                                               
      subroutine rffti (n,wsave,nsave)                                                
      dimension wsave(*),nsave(*)                                                  
!                                                                               
      if (n .eq. 1) return                                                      
      call rffti1 (n,wsave(n+1),nsave)                                   
      return                                                                    
                        endsubroutine rffti                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RFFTI1 (N,WA,IFAC)                                             
      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)                          
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/                         
      NL = N                                                                    
      NF = 0                                                                    
      J = 0                                                                     
  101 J = J+1                                                                   
      if(j.le.4) then
        ntry=ntryh(j)
      else
        ntry=ntry+2
      endif                                                             
  104 NQ = NL/NTRY                                                              
      NR = NL-NTRY*NQ                                                           
      if(nr.ne.0) go to 101
      nf=nf+1                                                       
      IFAC(NF+2) = NTRY                                                         
      NL = NQ                                                                   
      IF (NTRY .NE. 2) GO TO 107                                                
      IF (NF .EQ. 1) GO TO 107                                                  
      DO 106 I=2,NF                                                             
         IB = NF-I+2                                                            
         IFAC(IB+2) = IFAC(IB+1)                                                
  106 CONTINUE                                                                  
      IFAC(3) = 2                                                               
  107 IF (NL .NE. 1) GO TO 104                                                  
      IFAC(1) = N                                                               
      IFAC(2) = NF                                                              
!      TPI = 2.0*3.141592653589793238462643383279502884197169399375105820                                                     
      ARGH = TPI/FLOAT(N)                                                       
      IS = 0                                                                    
      NFM1 = NF-1                                                               
      L1 = 1                                                                    
      IF (NFM1 .EQ. 0) RETURN                                                   
      DO 110 K1=1,NFM1                                                          
         IP = IFAC(K1+2)                                                        
         LD = 0                                                                 
         L2 = L1*IP                                                             
         IDO = N/L2                                                             
         IPM = IP-1                                                             
         DO 109 J=1,IPM                                                         
            LD = LD+L1                                                          
            I = IS                                                              
            ARGLD = FLOAT(LD)*ARGH                                              
            FI = 0.                                                             
            DO 108 II=3,IDO,2                                                   
               I = I+2                                                          
               FI = FI+1.                                                       
               ARG = FI*ARGLD                                                   
               WA(I-1) = COS(ARG)                                               
               WA(I) = SIN(ARG)                                                 
  108       CONTINUE                                                            
            IS = IS+IDO                                                         
  109    CONTINUE                                                               
         L1 = L2                                                                
  110 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!     subroutine rfftf(n,r,wsave,nsave)                                               
!                                                                               
!     SUBROUTINE RFFTF COMPUTES THE FOURIER COEFFICIENTS OF A REAL              
!     PERODI! SEQUENCE (FOURIER ANALYSIS). THE TRANSFORM IS DEFINED             
!     BELOW AT OUTPUT PARAMETER R.                                              
!                                                                               
!     INPUT PARAMETERS                                                          
!                                                                               
!     N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD          
!             IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.            
!             N MAY CHANGE SO LONG AS DIFFERENT WORK ARRAYS ARE PROVIDED        
!                                                                               
!     R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE              
!             TO BE TRANSFORMED                                                 
!                                                                               
!     WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.           
!             IN THE PROGRAM THAT CALLS RFFTF. THE WSAVE ARRAY MUST BE          
!             INITIALIZED BY CALLING SUBROUTINE RFFTI(N,WSAVE) AND A            
!             DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT             
!             VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE               
!             REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT           
!             TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.                 
!             THE SAME WSAVE ARRAY CAN BE USED BY RFFTF AND RFFTB.              
!                                                                               
!                                                                               
!     OUTPUT PARAMETERS                                                         
!                                                                               
!     R       R(1) = THE SUM FROM I=1 TO I=N OF R(I)                            
!                                                                               
!             IF N IS EVEN SET L =N/2   , IF N IS ODD SET L = (N+1)/2           
!                                                                               
!               THEN FOR K = 2,...,L                                            
!                                                                               
!                  R(2*K-2) = THE SUM FROM I = 1 TO I = N OF                    
!                                                                               
!                       R(I)*COS((K-1)*(I-1)*2*PI/N)                            
!                                                                               
!                  R(2*K-1) = THE SUM FROM I = 1 TO I = N OF                    
!                                                                               
!                      -R(I)*SIN((K-1)*(I-1)*2*PI/N)                            
!                                                                               
!             IF N IS EVEN                                                      
!                                                                               
!                  R(N) = THE SUM FROM I = 1 TO I = N OF                        
!                                                                               
!                       (-1)**(I-1)*R(I)                                        
!                                                                               
!      *****  NOTE                                                              
!                  THIS TRANSFORM IS UNNORMALIZED SINCE A CALL OF RFFTF         
!                  FOLLOWED BY A CALL OF RFFTB WILL MULTIPLY THE INPUT          
!                  SEQUENCE BY N.                                               
!                                                                               
!     WSAVE   CONTAINS RESULTS WHICH MUST NOT BE DESTROYED BETWEEN              
!             CALLS OF RFFTF OR RFFTB.                                          
!                                                                               
      subroutine rfftf (n,r,wsave,nsave)                                              
      dimension r(*),wsave(*),nsave(*)                                      
!                                                                               
      if (n .eq. 1) return                                                      
      call rfftf1 (n,r,wsave,wsave(n+1),nsave)                           
      return                                                                    
                        endsubroutine rfftf                                                                     
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RFFTF1 (N,C,CH,WA,IFAC)                                        
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)               
      NF = IFAC(2)                                                              
      NA = 1                                                                    
      L2 = N                                                                    
      IW = N                                                                    
      DO 111 K1=1,NF                                                            
         KH = NF-K1                                                             
         IP = IFAC(KH+3)                                                        
         L1 = L2/IP                                                             
         IDO = N/L2                                                             
         IDL1 = IDO*L1                                                          
         IW = IW-(IP-1)*IDO                                                     
         NA = 1-NA                                                              
         IF (IP .NE. 4) GO TO 102                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IF (NA .NE. 0) GO TO 101                                               
         CALL RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))                        
         GO TO 110                                                              
  101    CALL RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))                        
         GO TO 110                                                              
  102    IF (IP .NE. 2) GO TO 104                                               
         IF (NA .NE. 0) GO TO 103                                               
         CALL RADF2 (IDO,L1,C,CH,WA(IW))                                        
         GO TO 110                                                              
  103    CALL RADF2 (IDO,L1,CH,C,WA(IW))                                        
         GO TO 110                                                              
  104    IF (IP .NE. 3) GO TO 106                                               
         IX2 = IW+IDO                                                           
         IF (NA .NE. 0) GO TO 105                                               
         CALL RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))                                
         GO TO 110                                                              
  105    CALL RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))                                
         GO TO 110                                                              
  106    IF (IP .NE. 5) GO TO 108                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IX4 = IX3+IDO                                                          
         IF (NA .NE. 0) GO TO 107                                               
         CALL RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
         GO TO 110                                                              
  107    CALL RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
         GO TO 110                                                              
  108    IF (IDO .EQ. 1) NA = 1-NA                                              
         IF (NA .NE. 0) GO TO 109                                               
         CALL RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))                         
         NA = 1                                                                 
         GO TO 110                                                              
  109    CALL RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))                        
         NA = 0                                                                 
  110    L2 = L1                                                                
  111 CONTINUE                                                                  
      IF (NA .EQ. 1) RETURN                                                     
      DO 112 I=1,N                                                              
         C(I) = CH(I)                                                           
  112 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADF2 (IDO,L1,CC,CH,WA1)                                       
      DIMENSION       CH(IDO,2,L1)           ,CC(IDO,L1,2)           , &        
                      WA1(*)                                                    
      DO 101 K=1,L1                                                             
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)                                        
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)                                      
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            CH(I,1,K) = CC(I,K,1)+TI2                                           
            CH(IC,2,K) = TI2-CC(I,K,1)                                          
            CH(I-1,1,K) = CC(I-1,K,1)+TR2                                       
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2                                      
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 DO 106 K=1,L1                                                             
         CH(1,2,K) = -CC(IDO,K,2)                                               
         CH(IDO,1,K) = CC(IDO,K,1)                                              
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      endsubroutine                                                                      
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADF3 (IDO,L1,CC,CH,WA1,WA2)                                   
      DIMENSION       CH(IDO,3,L1)           ,CC(IDO,L1,3)           , &          
                      WA1(*)     ,WA2(*)                                        
      DATA TAUR,TAUI /-.5,.866025403784439/                                     
      DO 101 K=1,L1                                                             
         CR2 = CC(1,K,2)+CC(1,K,3)                                              
         CH(1,1,K) = CC(1,K,1)+CR2                                              
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))                                 
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2                                       
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)                       
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)                       
            CR2 = DR2+DR3                                                       
            CI2 = DI2+DI3                                                       
            CH(I-1,1,K) = CC(I-1,K,1)+CR2                                       
            CH(I,1,K) = CC(I,K,1)+CI2                                           
            TR2 = CC(I-1,K,1)+TAUR*CR2                                          
            TI2 = CC(I,K,1)+TAUR*CI2                                            
            TR3 = TAUI*(DI2-DI3)                                                
            TI3 = TAUI*(DR3-DR2)                                                
            CH(I-1,3,K) = TR2+TR3                                               
            CH(IC-1,2,K) = TR2-TR3                                              
            CH(I,3,K) = TI2+TI3                                                 
            CH(IC,2,K) = TI3-TI2                                                
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)                               
      DIMENSION       CC(IDO,L1,4)           ,CH(IDO,4,L1)           , &         
                      WA1(*)     ,WA2(*)     ,WA3(*)                            
      DATA HSQT2 /.7071067811865475/                                            
      DO 101 K=1,L1                                                             
         TR1 = CC(1,K,2)+CC(1,K,4)                                              
         TR2 = CC(1,K,1)+CC(1,K,3)                                              
         CH(1,1,K) = TR1+TR2                                                    
         CH(IDO,4,K) = TR2-TR1                                                  
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)                                      
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)                                        
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)                       
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)                       
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)                       
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)                       
            TR1 = CR2+CR4                                                       
            TR4 = CR4-CR2                                                       
            TI1 = CI2+CI4                                                       
            TI4 = CI2-CI4                                                       
            TI2 = CC(I,K,1)+CI3                                                 
            TI3 = CC(I,K,1)-CI3                                                 
            TR2 = CC(I-1,K,1)+CR3                                               
            TR3 = CC(I-1,K,1)-CR3                                               
            CH(I-1,1,K) = TR1+TR2                                               
            CH(IC-1,4,K) = TR2-TR1                                              
            CH(I,1,K) = TI1+TI2                                                 
            CH(IC,4,K) = TI1-TI2                                                
            CH(I-1,3,K) = TI4+TR3                                               
            CH(IC-1,2,K) = TR3-TI4                                              
            CH(I,3,K) = TR4+TI3                                                 
            CH(IC,2,K) = TR4-TI3                                                
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 CONTINUE                                                                  
      DO 106 K=1,L1                                                             
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))                                 
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))                                  
         CH(IDO,1,K) = TR1+CC(IDO,K,1)                                          
         CH(IDO,3,K) = CC(IDO,K,1)-TR1                                          
         CH(1,2,K) = TI1-CC(IDO,K,3)                                            
         CH(1,4,K) = TI1+CC(IDO,K,3)                                            
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)                           
      DIMENSION       CC(IDO,L1,5)           ,CH(IDO,5,L1)           , &          
                      WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)                
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154, &             
      -.809016994374947,.587785252292473/                                       
      DO 101 K=1,L1                                                             
         CR2 = CC(1,K,5)+CC(1,K,2)                                              
         CI5 = CC(1,K,5)-CC(1,K,2)                                              
         CR3 = CC(1,K,4)+CC(1,K,3)                                              
         CI4 = CC(1,K,4)-CC(1,K,3)                                              
         CH(1,1,K) = CC(1,K,1)+CR2+CR3                                          
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3                              
         CH(1,3,K) = TI11*CI5+TI12*CI4                                          
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3                              
         CH(1,5,K) = TI12*CI5-TI11*CI4                                          
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)                       
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)                       
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)                       
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)                       
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)                       
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)                       
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)                       
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)                       
            CR2 = DR2+DR5                                                       
            CI5 = DR5-DR2                                                       
            CR5 = DI2-DI5                                                       
            CI2 = DI2+DI5                                                       
            CR3 = DR3+DR4                                                       
            CI4 = DR4-DR3                                                       
            CR4 = DI3-DI4                                                       
            CI3 = DI3+DI4                                                       
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3                                   
            CH(I,1,K) = CC(I,K,1)+CI2+CI3                                       
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3                                 
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3                                   
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3                                 
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3                                   
            TR5 = TI11*CR5+TI12*CR4                                             
            TI5 = TI11*CI5+TI12*CI4                                             
            TR4 = TI12*CR5-TI11*CR4                                             
            TI4 = TI12*CI5-TI11*CI4                                             
            CH(I-1,3,K) = TR2+TR5                                               
            CH(IC-1,2,K) = TR2-TR5                                              
            CH(I,3,K) = TI2+TI5                                                 
            CH(IC,2,K) = TI5-TI2                                                
            CH(I-1,5,K) = TR3+TR4                                               
            CH(IC-1,4,K) = TR3-TR4                                              
            CH(I,5,K) = TI3+TI4                                                 
            CH(IC,4,K) = TI4-TI3                                                
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)                      
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          , &          
                      C1(IDO,L1,IP)          ,C2(IDL1,IP), &                    
                      CH2(IDL1,IP)           ,WA(*)                             
!      TPI = 2.0*3.141592653589793238462643383279502884197169399375105820                                                     
      ARG = TPI/FLOAT(IP)                                                       
      DCP = COS(ARG)                                                            
      DSP = SIN(ARG)                                                            
      IPPH = (IP+1)/2                                                           
      IPP2 = IP+2                                                               
      IDP2 = IDO+2                                                              
      NBD = (IDO-1)/2                                                           
      IF (IDO .EQ. 1) GO TO 119                                                 
      DO 101 IK=1,IDL1                                                          
         CH2(IK,1) = C2(IK,1)                                                   
  101 CONTINUE                                                                  
      DO 103 J=2,IP                                                             
         DO 102 K=1,L1                                                          
            CH(1,K,J) = C1(1,K,J)                                               
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      IF (NBD .GT. L1) GO TO 107                                                
      IS = -IDO                                                                 
      DO 106 J=2,IP                                                             
         IS = IS+IDO                                                            
         IDIJ = IS                                                              
         DO 105 I=3,IDO,2                                                       
            IDIJ = IDIJ+2                                                       
            DO 104 K=1,L1                                                       
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)          
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)            
  104       CONTINUE                                                            
  105    CONTINUE                                                               
  106 CONTINUE                                                                  
      GO TO 111                                                                 
  107 IS = -IDO                                                                 
      DO 110 J=2,IP                                                             
         IS = IS+IDO                                                            
         DO 109 K=1,L1                                                          
            IDIJ = IS                                                           
            DO 108 I=3,IDO,2                                                    
               IDIJ = IDIJ+2                                                    
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)          
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)            
  108       CONTINUE                                                            
  109    CONTINUE                                                               
  110 CONTINUE                                                                  
  111 IF (NBD .LT. L1) GO TO 115                                                
      DO 114 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 113 K=1,L1                                                          
            DO 112 I=3,IDO,2                                                    
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)                           
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)                              
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)                                 
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)                            
  112       CONTINUE                                                            
  113    CONTINUE                                                               
  114 CONTINUE                                                                  
      GO TO 121                                                                 
  115 DO 118 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 117 I=3,IDO,2                                                       
            DO 116 K=1,L1                                                       
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)                           
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)                              
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)                                 
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)                            
  116       CONTINUE                                                            
  117    CONTINUE                                                               
  118 CONTINUE                                                                  
      GO TO 121                                                                 
  119 DO 120 IK=1,IDL1                                                          
         C2(IK,1) = CH2(IK,1)                                                   
  120 CONTINUE                                                                  
  121 DO 123 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 122 K=1,L1                                                          
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)                                    
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)                                   
  122    CONTINUE                                                               
  123 CONTINUE                                                                  
!                                                                               
      AR1 = 1.                                                                  
      AI1 = 0.                                                                  
      DO 127 L=2,IPPH                                                           
         LC = IPP2-L                                                            
         AR1H = DCP*AR1-DSP*AI1                                                 
         AI1 = DCP*AI1+DSP*AR1                                                  
         AR1 = AR1H                                                             
         DO 124 IK=1,IDL1                                                       
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)                                   
            CH2(IK,LC) = AI1*C2(IK,IP)                                          
  124    CONTINUE                                                               
         DC2 = AR1                                                              
         DS2 = AI1                                                              
         AR2 = AR1                                                              
         AI2 = AI1                                                              
         DO 126 J=3,IPPH                                                        
            JC = IPP2-J                                                         
            AR2H = DC2*AR2-DS2*AI2                                              
            AI2 = DC2*AI2+DS2*AR2                                               
            AR2 = AR2H                                                          
            DO 125 IK=1,IDL1                                                    
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)                               
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)                            
  125       CONTINUE                                                            
  126    CONTINUE                                                               
  127 CONTINUE                                                                  
      DO 129 J=2,IPPH                                                           
         DO 128 IK=1,IDL1                                                       
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)                                      
  128    CONTINUE                                                               
  129 CONTINUE                                                                  
!                                                                               
      IF (IDO .LT. L1) GO TO 132                                                
      DO 131 K=1,L1                                                             
         DO 130 I=1,IDO                                                         
            CC(I,1,K) = CH(I,K,1)                                               
  130    CONTINUE                                                               
  131 CONTINUE                                                                  
      GO TO 135                                                                 
  132 DO 134 I=1,IDO                                                            
         DO 133 K=1,L1                                                          
            CC(I,1,K) = CH(I,K,1)                                               
  133    CONTINUE                                                               
  134 CONTINUE                                                                  
  135 DO 137 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 136 K=1,L1                                                          
            CC(IDO,J2-2,K) = CH(1,K,J)                                          
            CC(1,J2-1,K) = CH(1,K,JC)                                           
  136    CONTINUE                                                               
  137 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IF (NBD .LT. L1) GO TO 141                                                
      DO 140 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 139 K=1,L1                                                          
            DO 138 I=3,IDO,2                                                    
               IC = IDP2-I                                                      
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)                        
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)                       
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)                              
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)                             
  138       CONTINUE                                                            
  139    CONTINUE                                                               
  140 CONTINUE                                                                  
      RETURN                                                                    
  141 DO 144 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 143 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DO 142 K=1,L1                                                       
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)                        
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)                       
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)                              
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)                             
  142       CONTINUE                                                            
  143    CONTINUE                                                               
  144 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                                                                                              
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!    subroutine rfftb(n,r,wsave,nsave)                                               
!                                                                              
!    SUBROUTINE RFFTB COMPUTES THE REAL PERODIC SEQUENCE FROM ITS              
!    FOURIER COEFFICIENTS (FOURIER SYNTHESIS). THE TRANSFORM IS DEFINED        
!    BELOW AT OUTPUT PARAMETER R.                                              
!                                                                              
!    INPUT PARAMETERS                                                          
!                                                                              
!    N       THE LENGTH OF THE ARRAY R TO BE TRANSFORMED.  THE METHOD          
!            IS MOST EFFICIENT WHEN N IS A PRODUCT OF SMALL PRIMES.            
!            N MAY CHANGE SO LONG AS DIFFERENT WORK ARRAYS ARE PROVIDED        
!                                                                              
!    R       A REAL ARRAY OF LENGTH N WHICH CONTAINS THE SEQUENCE              
!            TO BE TRANSFORMED                                                 
!                                                                              
!    WSAVE   A WORK ARRAY WHICH MUST BE DIMENSIONED AT LEAST 2*N+15.           
!            IN THE PROGRAM THAT CALLS RFFTB. THE WSAVE ARRAY MUST BE          
!            INITIALIZED BY CALLING SUBROUTINE RFFTI(N,WSAVE) AND A            
!            DIFFERENT WSAVE ARRAY MUST BE USED FOR EACH DIFFERENT             
!            VALUE OF N. THIS INITIALIZATION DOES NOT HAVE TO BE               
!            REPEATED SO LONG AS N REMAINS UNCHANGED THUS SUBSEQUENT           
!            TRANSFORMS CAN BE OBTAINED FASTER THAN THE FIRST.                 
!            THE SAME WSAVE ARRAY CAN BE USED BY RFFTF AND RFFTB.              
!                                                                              
!                                                                              
!    OUTPUT PARAMETERS                                                         
!                                                                              
!    R       FOR N EVEN AND FOR I = 1,...,N                                    
!                                                                              
!                 R(I) = R(1)+(-1)**(I-1)*R(N)                                 
!                                                                              
!                      PLUS THE SUM FROM K=2 TO K=N/2 OF                       
!                                                                              
!                       2.*R(2*K-2)*COS((K-1)*(I-1)*2*PI/N)                    
!                                                                              
!                      -2.*R(2*K-1)*SIN((K-1)*(I-1)*2*PI/N)                    
!                                                                              
!            FOR N ODD AND FOR I = 1,...,N                                     
!                                                                              
!                 R(I) = R(1) PLUS THE SUM FROM K=2 TO K=(N+1)/2 OF            
!                                                                              
!                      2.*R(2*K-2)*COS((K-1)*(I-1)*2*PI/N)                     
!                                                                              
!                     -2.*R(2*K-1)*SIN((K-1)*(I-1)*2*PI/N)                     
!                                                                              
!     *****  NOTE                                                              
!                 THIS TRANSFORM IS UNNORMALIZED SINCE A CALL OF RFFTF         
!                 FOLLOWED BY A CALL OF RFFTB WILL MULTIPLY THE INPUT          
!                 SEQUENCE BY N.                                               
!                                                                              
!    WSAVE   CONTAINS RESULTS WHICH MUST NOT BE DESTROYED BETWEEN              
!            CALLS OF RFFTB OR RFFTF.                                          
!                                                                              
!                                                                              
      subroutine rfftb (n,r,wsave,nsave)               
      dimension r(*),wsave(*),nsave(*)                                      
!                                                                             
      if (n .eq. 1) return                                                      
      call rfftb1 (n,r,wsave,wsave(n+1),nsave)                           
      return                                                                    
                        endsubroutine rfftb                                         
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RFFTB1 (N,C,CH,WA,IFAC)                                        
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)               
      NF = IFAC(2)                                                              
      NA = 0                                                                    
      L1 = 1                                                                    
      IW = 1                                                                    
      DO 116 K1=1,NF                                                            
         IP = IFAC(K1+2)                                                        
         L2 = IP*L1                                                             
         IDO = N/L2                                                             
         IDL1 = IDO*L1                                                          
         IF (IP .NE. 4) GO TO 103                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IF (NA .NE. 0) GO TO 101                                               
         CALL RADB4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))                        
         GO TO 102                                                              
  101    CALL RADB4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))                        
  102    NA = 1-NA                                                              
         GO TO 115                                                              
  103    IF (IP .NE. 2) GO TO 106                                               
         IF (NA .NE. 0) GO TO 104                                               
         CALL RADB2 (IDO,L1,C,CH,WA(IW))                                        
         GO TO 105                                                              
  104    CALL RADB2 (IDO,L1,CH,C,WA(IW))                                        
  105    NA = 1-NA                                                              
         GO TO 115                                                              
  106    IF (IP .NE. 3) GO TO 109                                               
         IX2 = IW+IDO                                                           
         IF (NA .NE. 0) GO TO 107                                               
         CALL RADB3 (IDO,L1,C,CH,WA(IW),WA(IX2))                                
         GO TO 108                                                              
  107    CALL RADB3 (IDO,L1,CH,C,WA(IW),WA(IX2))                                
  108    NA = 1-NA                                                              
         GO TO 115                                                              
  109    IF (IP .NE. 5) GO TO 112                                               
         IX2 = IW+IDO                                                           
         IX3 = IX2+IDO                                                          
         IX4 = IX3+IDO                                                          
         IF (NA .NE. 0) GO TO 110                                               
         CALL RADB5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
         GO TO 111                                                              
  110    CALL RADB5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))                
  111    NA = 1-NA                                                              
         GO TO 115                                                              
  112    IF (NA .NE. 0) GO TO 113                                               
         CALL RADBG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))                         
         GO TO 114                                                              
  113    CALL RADBG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))                        
  114    IF (IDO .EQ. 1) NA = 1-NA                                              
  115    L1 = L2                                                                
         IW = IW+(IP-1)*IDO                                                     
  116 CONTINUE                                                                  
      IF (NA .EQ. 0) RETURN                                                     
      DO 117 I=1,N                                                              
         C(I) = CH(I)                                                           
  117 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADB2 (IDO,L1,CC,CH,WA1)                                       
      DIMENSION       CC(IDO,2,L1)           ,CH(IDO,L1,2)           , &          
                      WA1(*)                                                    
      DO 101 K=1,L1                                                             
         CH(1,K,1) = CC(1,1,K)+CC(IDO,2,K)                                      
         CH(1,K,2) = CC(1,1,K)-CC(IDO,2,K)                                      
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)                              
            TR2 = CC(I-1,1,K)-CC(IC-1,2,K)                                      
            CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)                                    
            TI2 = CC(I,1,K)+CC(IC,2,K)                                          
            CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2                             
            CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2                               
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 DO 106 K=1,L1                                                             
         CH(IDO,K,1) = CC(IDO,1,K)+CC(IDO,1,K)                                  
         CH(IDO,K,2) = -(CC(1,2,K)+CC(1,2,K))                                   
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADB3 (IDO,L1,CC,CH,WA1,WA2)                                   
      DIMENSION       CC(IDO,3,L1)           ,CH(IDO,L1,3)           , &          
                      WA1(*)     ,WA2(*)                                        
      DATA TAUR,TAUI /-.5,.866025403784439/                                     
      DO 101 K=1,L1                                                             
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)                                          
         CR2 = CC(1,1,K)+TAUR*TR2                                               
         CH(1,K,1) = CC(1,1,K)+TR2                                              
         CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))                                       
         CH(1,K,2) = CR2-CI3                                                    
         CH(1,K,3) = CR2+CI3                                                    
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)                                      
            CR2 = CC(I-1,1,K)+TAUR*TR2                                          
            CH(I-1,K,1) = CC(I-1,1,K)+TR2                                       
            TI2 = CC(I,3,K)-CC(IC,2,K)                                          
            CI2 = CC(I,1,K)+TAUR*TI2                                            
            CH(I,K,1) = CC(I,1,K)+TI2                                           
            CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))                               
            CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))                                   
            DR2 = CR2-CI3                                                       
            DR3 = CR2+CI3                                                       
            DI2 = CI2+CR3                                                       
            DI3 = CI2-CR3                                                       
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2                             
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2                               
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3                             
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3                               
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADB4 (IDO,L1,CC,CH,WA1,WA2,WA3)                               
      DIMENSION       CC(IDO,4,L1)           ,CH(IDO,L1,4)           , &          
                      WA1(*)     ,WA2(*)     ,WA3(*)                            
      DATA SQRT2 /1.414213562373095/                                            
      DO 101 K=1,L1                                                             
         TR1 = CC(1,1,K)-CC(IDO,4,K)                                            
         TR2 = CC(1,1,K)+CC(IDO,4,K)                                            
         TR3 = CC(IDO,2,K)+CC(IDO,2,K)                                          
         TR4 = CC(1,3,K)+CC(1,3,K)                                              
         CH(1,K,1) = TR2+TR3                                                    
         CH(1,K,2) = TR1-TR4                                                    
         CH(1,K,3) = TR2-TR3                                                    
         CH(1,K,4) = TR1+TR4                                                    
  101 CONTINUE                                                                  
      IF (IDO-2) 107,105,102                                                    
  102 IDP2 = IDO+2                                                              
      DO 104 K=1,L1                                                             
         DO 103 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TI1 = CC(I,1,K)+CC(IC,4,K)                                          
            TI2 = CC(I,1,K)-CC(IC,4,K)                                          
            TI3 = CC(I,3,K)-CC(IC,2,K)                                          
            TR4 = CC(I,3,K)+CC(IC,2,K)                                          
            TR1 = CC(I-1,1,K)-CC(IC-1,4,K)                                      
            TR2 = CC(I-1,1,K)+CC(IC-1,4,K)                                      
            TI4 = CC(I-1,3,K)-CC(IC-1,2,K)                                      
            TR3 = CC(I-1,3,K)+CC(IC-1,2,K)                                      
            CH(I-1,K,1) = TR2+TR3                                               
            CR3 = TR2-TR3                                                       
            CH(I,K,1) = TI2+TI3                                                 
            CI3 = TI2-TI3                                                       
            CR2 = TR1-TR4                                                       
            CR4 = TR1+TR4                                                       
            CI2 = TI1+TI4                                                       
            CI4 = TI1-TI4                                                       
            CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2                             
            CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2                               
            CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3                             
            CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3                               
            CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4                             
            CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4                               
  103    CONTINUE                                                               
  104 CONTINUE                                                                  
      IF (MOD(IDO,2) .EQ. 1) RETURN                                             
  105 CONTINUE                                                                  
      DO 106 K=1,L1                                                             
         TI1 = CC(1,2,K)+CC(1,4,K)                                              
         TI2 = CC(1,4,K)-CC(1,2,K)                                              
         TR1 = CC(IDO,1,K)-CC(IDO,3,K)                                          
         TR2 = CC(IDO,1,K)+CC(IDO,3,K)                                          
         CH(IDO,K,1) = TR2+TR2                                                  
         CH(IDO,K,2) = SQRT2*(TR1-TI1)                                          
         CH(IDO,K,3) = TI2+TI2                                                  
         CH(IDO,K,4) = -SQRT2*(TR1+TI1)                                         
  106 CONTINUE                                                                  
  107 RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADB5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)                           
      DIMENSION       CC(IDO,5,L1)           ,CH(IDO,L1,5)           , &          
                      WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)                
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154, &             
      -.809016994374947,.587785252292473/                                       
      DO 101 K=1,L1                                                             
         TI5 = CC(1,3,K)+CC(1,3,K)                                              
         TI4 = CC(1,5,K)+CC(1,5,K)                                              
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)                                          
         TR3 = CC(IDO,4,K)+CC(IDO,4,K)                                          
         CH(1,K,1) = CC(1,1,K)+TR2+TR3                                          
         CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3                                      
         CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3                                      
         CI5 = TI11*TI5+TI12*TI4                                                
         CI4 = TI12*TI5-TI11*TI4                                                
         CH(1,K,2) = CR2-CI5                                                    
         CH(1,K,3) = CR3-CI4                                                    
         CH(1,K,4) = CR3+CI4                                                    
         CH(1,K,5) = CR2+CI5                                                    
  101 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      IDP2 = IDO+2                                                              
      DO 103 K=1,L1                                                             
         DO 102 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            TI5 = CC(I,3,K)+CC(IC,2,K)                                          
            TI2 = CC(I,3,K)-CC(IC,2,K)                                          
            TI4 = CC(I,5,K)+CC(IC,4,K)                                          
            TI3 = CC(I,5,K)-CC(IC,4,K)                                          
            TR5 = CC(I-1,3,K)-CC(IC-1,2,K)                                      
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)                                      
            TR4 = CC(I-1,5,K)-CC(IC-1,4,K)                                      
            TR3 = CC(I-1,5,K)+CC(IC-1,4,K)                                      
            CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3                                   
            CH(I,K,1) = CC(I,1,K)+TI2+TI3                                       
            CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3                                 
            CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3                                   
            CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3                                 
            CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3                                   
            CR5 = TI11*TR5+TI12*TR4                                             
            CI5 = TI11*TI5+TI12*TI4                                             
            CR4 = TI12*TR5-TI11*TR4                                             
            CI4 = TI12*TI5-TI11*TI4                                             
            DR3 = CR3-CI4                                                       
            DR4 = CR3+CI4                                                       
            DI3 = CI3+CR4                                                       
            DI4 = CI3-CR4                                                       
            DR5 = CR2+CI5                                                       
            DR2 = CR2-CI5                                                       
            DI5 = CI2-CR5                                                       
            DI2 = CI2+CR5                                                       
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2                             
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2                               
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3                             
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3                               
            CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4                             
            CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4                               
            CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5                             
            CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5                               
  102    CONTINUE                                                               
  103 CONTINUE                                                                  
      RETURN                                                                    
      endsubroutine                                                                     
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)                      
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          , &        
                      C1(IDO,L1,IP)          ,C2(IDL1,IP),  &                    
                      CH2(IDL1,IP)           ,WA(*)                             
!      TPI = 2.0*3.141592653589793238462643383279502884197169399375105820                                                     
      ARG = TPI/FLOAT(IP)                                                       
      DCP = COS(ARG)                                                            
      DSP = SIN(ARG)                                                            
      IDP2 = IDO+2                                                              
      NBD = (IDO-1)/2                                                           
      IPP2 = IP+2                                                               
      IPPH = (IP+1)/2                                                           
      IF (IDO .LT. L1) GO TO 103                                                
      DO 102 K=1,L1                                                             
         DO 101 I=1,IDO                                                         
            CH(I,K,1) = CC(I,1,K)                                               
  101    CONTINUE                                                               
  102 CONTINUE                                                                  
      GO TO 106                                                                 
  103 DO 105 I=1,IDO                                                            
         DO 104 K=1,L1                                                          
            CH(I,K,1) = CC(I,1,K)                                               
  104    CONTINUE                                                               
  105 CONTINUE                                                                  
  106 DO 108 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         J2 = J+J                                                               
         DO 107 K=1,L1                                                          
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)                           
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)                              
  107    CONTINUE                                                               
  108 CONTINUE                                                                  
      IF (IDO .EQ. 1) GO TO 116                                                 
      IF (NBD .LT. L1) GO TO 112                                                
      DO 111 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 110 K=1,L1                                                          
            DO 109 I=3,IDO,2                                                    
               IC = IDP2-I                                                      
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)                   
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)                  
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)                         
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)                        
  109       CONTINUE                                                            
  110    CONTINUE                                                               
  111 CONTINUE                                                                  
      GO TO 116                                                                 
  112 DO 115 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 114 I=3,IDO,2                                                       
            IC = IDP2-I                                                         
            DO 113 K=1,L1                                                       
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)                   
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)                  
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)                         
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)                        
  113       CONTINUE                                                            
  114    CONTINUE                                                               
  115 CONTINUE                                                                  
  116 AR1 = 1.                                                                  
      AI1 = 0.                                                                  
      DO 120 L=2,IPPH                                                           
         LC = IPP2-L                                                            
         AR1H = DCP*AR1-DSP*AI1                                                 
         AI1 = DCP*AI1+DSP*AR1                                                  
         AR1 = AR1H                                                             
         DO 117 IK=1,IDL1                                                       
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)                                  
            C2(IK,LC) = AI1*CH2(IK,IP)                                          
  117    CONTINUE                                                               
         DC2 = AR1                                                              
         DS2 = AI1                                                              
         AR2 = AR1                                                              
         AI2 = AI1                                                              
         DO 119 J=3,IPPH                                                        
            JC = IPP2-J                                                         
            AR2H = DC2*AR2-DS2*AI2                                              
            AI2 = DC2*AI2+DS2*AR2                                               
            AR2 = AR2H                                                          
            DO 118 IK=1,IDL1                                                    
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)                                
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)                             
  118       CONTINUE                                                            
  119    CONTINUE                                                               
  120 CONTINUE                                                                  
      DO 122 J=2,IPPH                                                           
         DO 121 IK=1,IDL1                                                       
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)                                     
  121    CONTINUE                                                               
  122 CONTINUE                                                                  
      DO 124 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 123 K=1,L1                                                          
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)                                    
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)                                   
  123    CONTINUE                                                               
  124 CONTINUE                                                                  
      IF (IDO .EQ. 1) GO TO 132                                                 
      IF (NBD .LT. L1) GO TO 128                                                
      DO 127 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 126 K=1,L1                                                          
            DO 125 I=3,IDO,2                                                    
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)                             
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)                            
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)                               
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)                              
  125       CONTINUE                                                            
  126    CONTINUE                                                               
  127 CONTINUE                                                                  
      GO TO 132                                                                 
  128 DO 131 J=2,IPPH                                                           
         JC = IPP2-J                                                            
         DO 130 I=3,IDO,2                                                       
            DO 129 K=1,L1                                                       
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)                             
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)                            
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)                               
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)                              
  129       CONTINUE                                                            
  130    CONTINUE                                                               
  131 CONTINUE                                                                  
  132 CONTINUE                                                                  
      IF (IDO .EQ. 1) RETURN                                                    
      DO 133 IK=1,IDL1                                                          
         C2(IK,1) = CH2(IK,1)                                                   
  133 CONTINUE                                                                  
      DO 135 J=2,IP                                                             
         DO 134 K=1,L1                                                          
            C1(1,K,J) = CH(1,K,J)                                               
  134    CONTINUE                                                               
  135 CONTINUE                                                                  
      IF (NBD .GT. L1) GO TO 139                                                
      IS = -IDO                                                                 
      DO 138 J=2,IP                                                             
         IS = IS+IDO                                                            
         IDIJ = IS                                                              
         DO 137 I=3,IDO,2                                                       
            IDIJ = IDIJ+2                                                       
            DO 136 K=1,L1                                                       
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)          
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)            
  136       CONTINUE                                                            
  137    CONTINUE                                                               
  138 CONTINUE                                                                  
      GO TO 143                                                                 
  139 IS = -IDO                                                                 
      DO 142 J=2,IP                                                             
         IS = IS+IDO                                                            
         DO 141 K=1,L1                                                          
            IDIJ = IS                                                           
            DO 140 I=3,IDO,2                                                    
               IDIJ = IDIJ+2                                                    
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)          
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)            
  140       CONTINUE                                                            
  141    CONTINUE                                                               
  142 CONTINUE                                                                  
  143 RETURN                                                                    
      endsubroutine                                                                       
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine presmud &
(jm &
,dlmd,dphd,sbd &
,nhsmud)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
integer(kind=kint),dimension(1:jm):: &
 nhsmud
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------                                                      
      dlm=dlmd*dtr
      dph=dphd*dtr
      sb=sbd*dtr
!-----------------------------------------------------------------------
      tph=sb
      do j=3,jm-2
        tph=tph+dph
        nhsmud(j)=.99*dph/(dlm*cos(tph))
      enddo
!-----------------------------------------------------------------------
                        endsubroutine presmud
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine smudh2 &
(im,jm &
,nhsmud &
,h2)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),parameter:: &
 wa=0.5 &
,w1=wa*0.5 &
,w2=1.-wa

integer(kind=kint),dimension(1:jm),intent(in):: &
 nhsmud(jm)

real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 h2

real(kind=kfpt),dimension(1:im):: &
 buff
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      icycle=im-3
      rcycle=1./icycle
!-----------------------------------------------------------------------
      as=0.
      an=0.
      do i=2,im-2
        as=h2(i,2   )+as
        an=h2(i,jm-1)+an
      enddo
      as=as*rcycle
      an=an*rcycle
      do i=1,im
        h2(i,2   )=as
        h2(i,jm-1)=an
      enddo
!-----------------------------------------------------------------------
      do j=3,jm-2
!----------------------------------------------------------------------
        do ks=1,nhsmud(j)
!----------------------------------------------------------------------
          do i=2,im-1
            buff(i)=(h2(i-1,j)+h2(i+1,j))*w1+h2(i,j)*w2       
          enddo
!
          buff(1)=buff(im-2)
          ave=(buff(2)+buff(im-1))*0.5
          buff(2)=ave
          buff(im-1)=ave
          buff(im)=buff(3)
!
          do i=1,im
            h2(i,j)=buff(i)
          enddo
!----------------------------------------------------------------------
        enddo ! end of smoothing
!----------------------------------------------------------------------
      enddo ! end of j
!----------------------------------------------------------------------
                        endsubroutine smudh2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine smudhn &
(im,jm,km &
,nhsmud &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),parameter:: &
 wa=0.5 &
,w1=wa*0.5 &
,w2=1.-wa

integer(kind=kint),dimension(1:jm),intent(in):: &
 nhsmud(jm)

real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn

real(kind=kfpt),dimension(1:im):: &
 buff
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      icycle=im-3
      rcycle=1./icycle
!-----------------------------------------------------------------------
      do k=1,km
        as=0.
        an=0.
        do i=2,im-2
          as=hn(i,2   ,k)+as
          an=hn(i,jm-1,k)+an
        enddo
        as=as*rcycle
        an=an*rcycle
        do i=1,im
          hn(i,2   ,k)=as
          hn(i,jm-1,k)=an
        enddo
      enddo
!-----------------------------------------------------------------------
      do k=1,km
!-----------------------------------------------------------------------
        do j=3,jm-2
!-----------------------------------------------------------------------
          do ks=1,nhsmud(j)
!-----------------------------------------------------------------------
            do i=2,im-1
              buff(i)=(hn(i-1,j,k)+hn(i+1,j,k))*w1+hn(i,j,k)*w2       
            enddo
!
            buff(1)=buff(im-2)
            ave=(buff(2)+buff(im-1))*0.5
            buff(2)=ave
            buff(im-1)=ave
            buff(im)=buff(3)
!
            do i=1,im
              hn(i,j,k)=buff(i)
            enddo
!-----------------------------------------------------------------------
          enddo ! end of smoothing
!-----------------------------------------------------------------------
        enddo ! end of j
!-----------------------------------------------------------------------
      enddo ! end of j
!-----------------------------------------------------------------------
                        endsubroutine smudhn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine poavh2 &
(im,jm &
,h2)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 h2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      rcycle=1./(im-3)
      as=0.
      an=0.
      do i=2,im-2
        as=h2(i,2   )+as
        an=h2(i,jm-1)+an
      enddo
      as=as*rcycle
      an=an*rcycle
      do i=1,im
        h2(i,2   )=as
        h2(i,jm-1)=an
      enddo
!-----------------------------------------------------------------------
                        endsubroutine poavh2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine poavhn &
(im,jm,km &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      rcycle=1./(im-3)
      do l=1,km
        as=0.
        an=0.
        do i=2,im-2
          as=hn(i,2   ,l)+as
          an=hn(i,jm-1,l)+an
        enddo
        as=as*rcycle
        an=an*rcycle
        do i=1,im
          hn(i,2   ,l)=as
          hn(i,jm-1,l)=an
        enddo
      enddo
!-----------------------------------------------------------------------
                        endsubroutine poavhn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine nhpoav &
(im,jm,km &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      rcycle=1./(im-3)
      do l=1,km
        as=0.
        an=0.
        do i=2,im-2
          as=hn(i,3   ,l)+as
          an=hn(i,jm-2,l)+an
        enddo
        as=as*rcycle
        an=an*rcycle
        do i=1,im
          hn(i,2   ,l)=as
          hn(i,jm-1,l)=an
        enddo
      enddo
!-----------------------------------------------------------------------
                        endsubroutine nhpoav
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine swaph2 &
(im,jm &
,h2)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 h2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      do j=1,jm
        h2(1,j)=h2(im-2,j)
        ave=(h2(2,j)+h2(im-1,j))*0.5
        h2(2,j)=ave
        h2(im-1,j)=ave
        h2(im,j)=h2(3,j)
      enddo       
!-----------------------------------------------------------------------
                        endsubroutine swaph2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine swaphn &
(im,jm,km &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      do l=1,km
        do j=1,jm
          hn(1,j,l)=hn(im-2,j,l)
          ave=(hn(2,j,l)+hn(im-1,j,l))*0.5
          hn(2,j,l)=ave
          hn(im-1,j,l)=ave
          hn(im,j,l)=hn(3,j,l)
        enddo
      enddo       
!-----------------------------------------------------------------------
                        endsubroutine swaphn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine swpshn &
(im,jm,km &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      do j=1,jm
        do l=1,km
          hn(1,j,l)=hn(im-2,j,l)
          ave=(hn(2,j,l)+hn(im-1,j,l))*0.5
          hn(2,j,l)=ave
          hn(im-1,j,l)=ave
          hn(im,j,l)=hn(3,j,l)
        enddo
      enddo       
!-----------------------------------------------------------------------
                        endsubroutine swpshn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine poleh2 &
(im,jm &
,h2)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 h2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      do i=1,im
        h2(i,1 )=h2(i,3   )
        h2(i,jm)=h2(i,jm-2)
      enddo       
!-----------------------------------------------------------------------
                        endsubroutine poleh2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine polehn &
(im,jm,km &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      do l=1,km
        do i=1,im
          hn(i,1 ,l)=hn(i,3   ,l)
          hn(i,jm,l)=hn(i,jm-2,l)
        enddo
      enddo       
!-----------------------------------------------------------------------
                        endsubroutine polehn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine polshn &
(im,jm,km &
,hn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 hn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      do i=1,im
        do l=1,km
          hn(i,1 ,l)=hn(i,3   ,l)
          hn(i,jm,l)=hn(i,jm-2,l)
        enddo
      enddo       
!-----------------------------------------------------------------------
                        endsubroutine polshn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine swapw2 &
(im,jm &
,w2)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 w2
!-----------------------------------------------------------------------
      do j=1,jm
        w2(1   ,j)=w2(im-2,j)
        w2(im-1,j)=w2(2   ,j)
        w2(im  ,j)=w2(3   ,j)
      enddo
!-----------------------------------------------------------------------
                        endsubroutine swapw2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine swapwn &
(im,jm,km &
,wn)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 wn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      do l=1,km
        do j=1,jm
          wn(1   ,j,l)=wn(im-2,j,l)
          wn(im-1,j,l)=wn(2   ,j,l)
          wn(im  ,j,l)=wn(3   ,j,l)
        enddo
      enddo
!-----------------------------------------------------------------------
                        endsubroutine swapwn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine polew2 &
(im,jm &
,u,v)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 u &
,v
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
        do i=1,im
          u(i,1   )=-u(i,2   )
          u(i,jm-1)=-u(i,jm-2)
          u(i,jm  )=-u(i,jm-2)
!
          v(i,1   )=-v(i,2   )
          v(i,jm-1)=-v(i,jm-2)
          v(i,jm  )=-v(i,jm-2)
        enddo
!-----------------------------------------------------------------------
                        endsubroutine polew2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine poled2 &
(im,jm &
,u,v)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 u &
,v
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
        do i=1,im
          u(i,1   )=-u(i,2   )
          u(i,jm-1)=-u(i,jm-2)
          u(i,jm  )=-u(i,jm-2)
!
          v(i,1   )=-v(i,2   )
          v(i,jm-1)=-v(i,jm-2)
          v(i,jm  )=-v(i,jm-2)
        enddo
!-----------------------------------------------------------------------
                        endsubroutine poled2
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine polewn &
(im,jm,km &
,u,v)
!-----------------------------------------------------------------------
implicit real(a-h,o-z),integer(i-n)
!-----------------------------------------------------------------------
real(kind=kfpt),dimension(1:im,1:jm,1:km),intent(inout):: &
 u &
,v
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      do l=1,km
        do i=1,im
          u(i,1   ,l)=-u(i,2   ,l)
          u(i,jm-1,l)=-u(i,jm-2,l)
          u(i,jm  ,l)=-u(i,jm-2,l)
!
          v(i,1   ,l)=-v(i,2   ,l)
          v(i,jm-1,l)=-v(i,jm-2,l)
          v(i,jm  ,l)=-v(i,jm-2,l)
        enddo
      enddo      
!-----------------------------------------------------------------------
                        endsubroutine polewn
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine bocoh &
(im,jm,lm,lnsh &
,dt,pt &
,dsg2,pdsg1 &
,pd &
,pdbe,pdbn,pdbs,pdbw &
,tbe,tbn,tbs,tbw,qbe,qbn,qbs,qbw,wbe,wbn,wbs,wbw &
,t,q,cw &
,pint)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
implicit none
!-----------------------------------------------------------------------
real(kind=kfpt),parameter:: &
 wa=0.5 &                    ! weighting factor
,w1=wa*0.25 &                ! weighting factor
,w2=1.-wa                    ! weighting factor
!-----------------------------------------------------------------------
integer(kind=kint),intent(in):: &
 im &                        ! total # of columns
,jm &                        ! total # of rows
,lm &                        ! total # of levels
,lnsh                        ! blending area width, h points

real(kind=kfpt),intent(in):: &
 dt &                        ! dynamics time step
,pt                          ! pressure at the top

real(kind=kfpt),dimension(1:lm),intent(in):: &
 dsg2 &                      ! delta sigmas
,pdsg1                       ! delta pressures

real(kind=kfpt),dimension(1:im,1:lnsh,1:2),intent(inout):: &
 pdbn &                      ! pressure difference at northern boundary
,pdbs                        ! pressure difference at southern boundary

real(kind=kfpt),dimension(1:lnsh,1:jm,1:2),intent(inout):: &
 pdbe &                      ! pressure difference at eastern boundary
,pdbw                        ! pressure difference at western boundary

real(kind=kfpt),dimension(1:im,1:lnsh,1:lm,1:2),intent(inout):: &
 tbn &                       ! temperature at northern boundary
,tbs &                       ! temperature at southern boundary
,qbn &                       ! specific humidity at northern boundary
,qbs &                       ! specific humidity at southern boundary
,wbn &                       ! condensate at northern boundary
,wbs                         ! condensate at southern boundary

real(kind=kfpt),dimension(1:lnsh,1:jm,1:lm,1:2),intent(inout):: &
 tbe &                       ! temperature at eastern boundary
,tbw &                       ! temperature at western boundary
,qbe &                       ! specific humidity at eastern boundary
,qbw &                       ! specific humidity at western boundary
,wbe &                       ! condensate at eastern boundary
,wbw                         ! condensate at western boundary

real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
 pd                          ! sigma range pressure difference

real(kind=kfpt),dimension(1:im,1:jm,1:lm),intent(inout):: &
 cw &                        ! condensate
,q &                         ! specific humidity
,t                           ! temperature

real(kind=kfpt),dimension(1:im,1:jm,1:lm+1),intent(inout):: &
 pint                        ! pressure at interfaces
!---local variables-----------------------------------------------------
integer(kind=kint):: &
 i &                         ! index in x direction
,ib &                        ! index in x direction, boundary zone
,ihe &                       ! ending index in x direction, boundaries
,ihs &                       ! starting index in x direction, boundaries
,j &                         ! index in y direction
,jb &                        ! index in y direction, boundary zone
,jhe &                       ! ending index in x direction, boundaries
,jhs &                       ! starting index in x direction, boundaries
,k &                         ! boundary line counter
,ks &                        ! smoothing counter
,l &                         ! index in p direction
,lines &                     ! boundary smoothing area
,nsmud                       ! number of smoothing passes

real(kind=kfpt),dimension(1:lnsh):: &
 wh(lnsh) &                  ! blending weighting function, temperature
,wq(lnsh)                    ! blending weighting function, moisture

real(kind=kfpt),dimension(1:im,1:jm):: &
 pdr                         ! pressure difference

real(kind=kfpt),dimension(1:im,1:jm,1:lm):: &
 pr &                        ! pressure
,qr &                        ! specific humidity
,tr                          ! temperature
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      lines=lnsh
      nsmud=lines-1
!-----------------------------------------------------------------------
      wh(1)=1.
      wq(1)=1.
      do k=2,lnsh
        wh(k)=exp(-(float(k)-1.)/(float(lnsh)-1.)*7.)
        wq(k)=exp(-(float(k)-1.)/(float(lnsh)-1.)*7.)
      enddo
!-------------update of boundary values at h points---------------------
!-------------southern and northern boundary----------------------------
      do jb=1,lnsh
        do ib=1,im
          pdbs(ib,jb,1)=pdbs(ib,jb,1)+pdbs(ib,jb,2)*dt
          pdbn(ib,jb,1)=pdbn(ib,jb,1)+pdbn(ib,jb,2)*dt
        enddo
      enddo
      do l=1,lm
        do jb=1,lnsh
          do ib=1,im
            tbs(ib,jb,l,1)=tbs(ib,jb,l,1)+tbs(ib,jb,l,2)*dt
            qbs(ib,jb,l,1)=qbs(ib,jb,l,1)+qbs(ib,jb,l,2)*dt
            wbs(ib,jb,l,1)=wbs(ib,jb,l,1)+wbs(ib,jb,l,2)*dt
            tbn(ib,jb,l,1)=tbn(ib,jb,l,1)+tbn(ib,jb,l,2)*dt
            qbn(ib,jb,l,1)=qbn(ib,jb,l,1)+qbn(ib,jb,l,2)*dt
            wbn(ib,jb,l,1)=wbn(ib,jb,l,1)+wbn(ib,jb,l,2)*dt
          enddo
        enddo
      enddo
!-------------western and eastern boundary------------------------------
      do jb=1,jm
        do ib=1,lnsh
          pdbw(ib,jb,1)=pdbw(ib,jb,1)+pdbw(ib,jb,2)*dt
          pdbe(ib,jb,1)=pdbe(ib,jb,1)+pdbe(ib,jb,2)*dt
        enddo
      enddo
      do l=1,lm
        do jb=1,jm
          do ib=1,lnsh
            tbw(ib,jb,l,1)=tbw(ib,jb,l,1)+tbw(ib,jb,l,2)*dt
            qbw(ib,jb,l,1)=qbw(ib,jb,l,1)+qbw(ib,jb,l,2)*dt
            wbw(ib,jb,l,1)=wbw(ib,jb,l,1)+wbw(ib,jb,l,2)*dt
            tbe(ib,jb,l,1)=tbe(ib,jb,l,1)+tbe(ib,jb,l,2)*dt
            qbe(ib,jb,l,1)=qbe(ib,jb,l,1)+qbe(ib,jb,l,2)*dt
            wbe(ib,jb,l,1)=wbe(ib,jb,l,1)+wbe(ib,jb,l,2)*dt
          enddo
        enddo
      enddo
!-------------southern boundary-----------------------------------------
      do j=1,lnsh
        jb=j
        ihs=jb
        ihe=im+1-jb
        do i=ihs,ihe
          ib=i
          pd(i,j)=pdbs(ib,jb,1)*wh(jb)+pd(i,j)*(1.-wh(jb))
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do j=1,lnsh
          jb=j
          ihs=jb
          ihe=im+1-jb
          do i=ihs,ihe
            ib=i
            t(i,j,l)=tbs(ib,jb,l,1)*wh(jb)+t(i,j,l)*(1.-wh(jb))
            q(i,j,l)=qbs(ib,jb,l,1)*wq(jb)+q(i,j,l)*(1.-wq(jb))
            cw(i,j,l)=wbs(ib,jb,l,1)*wq(jb)+cw(i,j,l)*(1.-wq(jb))
            pint(i,j,l+1)=(pint(i,j,l) &
                          +(dsg2(l)*pd(i,j)+pdsg1(l)))*wh(jb) &
                         +pint(i,j,l+1)*(1.-wh(jb))
          enddo
        enddo
      enddo
!-------------northern boundary-----------------------------------------
      do j=jm-lnsh+1,jm
        jb=j-jm+lnsh
        ihs=1-jb+lnsh
        ihe=im+jb-lnsh
        do i=ihs,ihe
          ib=i
          pd(i,j)=pdbn(ib,jb,1)*wh(lnsh+1-jb)+pd(i,j)*(1.-wh(lnsh+1-jb))
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do j=jm-lnsh+1,jm
          jb=j-jm+lnsh
          ihs=1-jb+lnsh
          ihe=im+jb-lnsh
          do i=ihs,ihe
            ib=i
            t(i,j,l)=tbn(ib,jb,l,1)*wh(lnsh+1-jb) &
                    +t(i,j,l)*(1.-wh(lnsh+1-jb))
            q(i,j,l)=qbn(ib,jb,l,1)*wq(lnsh+1-jb) &
                    +q(i,j,l)*(1.-wq(lnsh+1-jb))
            cw(i,j,l)=wbn(ib,jb,l,1)*wq(lnsh+1-jb) &
                     +cw(i,j,l)*(1.-wq(lnsh+1-jb))
            pint(i,j,l+1)=(pint(i,j,l) &
                          +(dsg2(l)*pd(i,j)+pdsg1(l)))*wh(lnsh+1-jb) &                    
                         +pint(i,j,l+1)*(1.-wh(lnsh+1-jb))
          enddo
        enddo
      enddo
!-------------western boundary------------------------------------------
      do i=1,lnsh
        ib=i
        jhs=1+ib
        jhe=jm-ib
        do j=jhs,jhe
          jb=j
          pd(i,j)=pdbw(ib,jb,1)*wh(ib)+pd(i,j)*(1.-wh(ib))
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do i=1,lnsh
          ib=i
          jhs=1+ib
          jhe=jm-ib
          do j=jhs,jhe
            jb=j
            t(i,j,l)=tbw(ib,jb,l,1)*wh(ib)+t(i,j,l)*(1.-wh(ib))
            q(i,j,l)=qbw(ib,jb,l,1)*wq(ib)+q(i,j,l)*(1.-wq(ib))
            cw(i,j,l)=wbw(ib,jb,l,1)*wq(ib)+cw(i,j,l)*(1.-wq(ib))
            pint(i,j,l+1)=(pint(i,j,l) &
                          +(dsg2(l)*pd(i,j)+pdsg1(l)))*wh(ib) &
                         +pint(i,j,l+1)*(1.-wh(ib))
          enddo
        enddo
      enddo
!-------------eastern boundary------------------------------------------
      do i=im+1-lnsh,im
        ib=i-im+lnsh
        jhs=2+lnsh-ib
        jhe=jm-lnsh-1+ib
        do j=jhs,jhe
          jb=j
          pd(i,j)=pdbe(ib,jb,1)*wh(lnsh+1-ib)+pd(i,j)*(1.-wh(lnsh+1-ib))
        enddo
      enddo
      do l=1,lm
        do i=im+1-lnsh,im
          ib=i-im+lnsh
          jhs=2+lnsh-ib
          jhe=jm-lnsh-1+ib
          do j=jhs,jhe
            jb=j
            t(i,j,l)=tbe(ib,jb,l,1)*wh(lnsh+1-ib) &
                    +t(i,j,l)*(1.-wh(lnsh+1-ib))
            q(i,j,l)=qbe(ib,jb,l,1)*wq(lnsh+1-ib) &
                    +q(i,j,l)*(1.-wq(lnsh+1-ib))
            cw(i,j,l)=wbe(ib,jb,l,1)*wq(lnsh+1-ib) &
                     +cw(i,j,l)*(1.-wq(lnsh+1-ib))
            pint(i,j,l+1)=(pint(i,j,l) &
                          +(dsg2(l)*pd(i,j)+pdsg1(l)))*wh(lnsh+1-ib) &
                         +pint(i,j,l+1)*(1.-wh(lnsh+1-ib))
          enddo
        enddo
      enddo
!-----------------------------------------------------------------------
      pd(2,2)=(pd(2,1)+pd(1,2)+pd(3,2)+pd(2,3))*0.25
      pd(im-1,2)=(pd(im-1,1)+pd(im-2,2)+pd(im,2)+pd(im-1,3))*0.25
      pd(2,jm-1)=(pd(2,jm-2)+pd(1,jm-1)+pd(3,jm-1)+pd(2,jm))*0.25
      pd(im-1,jm-1)=(pd(im-1,jm-2)+pd(im-2,jm-1) &
                    +pd(im,jm-1)+pd(im-1,jm))*0.25
      do l=1,lm
        t(2,2,l)=(t(2,1,l)+t(1,2,l)+t(3,2,l)+t(2,3,l))*0.25
        t(im-1,2,l)=(t(im-1,1,l)+t(im-2,2,l) &
                   +t(im,2,l)+t(im-1,3,l))*0.25
        t(2,jm-1,l)=(t(2,jm-2,l)+t(1,jm-1,l) &
                   +t(3,jm-1,l)+t(2,jm,l))*0.25
        t(im-1,jm-1,l)=(t(im-1,jm-2,l)+t(im-2,jm-1,l) &
                       +t(im,jm-1,l)+t(im-1,jm,l))*0.25
        q(2,2,l)=(q(2,1,l)+q(1,2,l)+q(3,2,l)+q(2,3,l))*0.25
        q(im-1,2,l)=(q(im-1,1,l)+q(im-2,2,l) &
                    +q(im,2,l)+q(im-1,3,l))*0.25
        q(2,jm-1,l)=(q(2,jm-2,l)+q(1,jm-1,l) &
                    +q(3,jm-1,l)+q(2,jm,l))*0.25
        q(im-1,jm-1,l)=(q(im-1,jm-2,l)+q(im-2,jm-1,l) &
                      +q(im,jm-1,l)+q(im-1,jm,l))*0.25      
      enddo
!-----------------------------------------------------------------------
      do j=1,2
        do i=1,im
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do j=1,2
          do i=1,im
            pint(i,j,l+1)=pint(i,j,l)+(dsg2(l)*pd(i,j)+pdsg1(l))
          enddo
        enddo
      enddo
      do j=jm-1,jm
        do i=1,im
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do j=jm-1,jm
          do i=1,im
            pint(i,j,l+1)=pint(i,j,l)+(dsg2(l)*pd(i,j)+pdsg1(l))
          enddo
        enddo
      enddo
      do j=3,jm-2
        do i=1,2
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do j=3,jm-2
          do i=1,2
            pint(i,j,l+1)=pint(i,j,l)+(dsg2(l)*pd(i,j)+pdsg1(l))
          enddo
        enddo
      enddo
      do j=3,jm-2
        do i=im-1,im
          pint(i,j,1)=pt
        enddo
      enddo
      do l=1,lm
        do j=3,jm-2
          do i=im-1,im
            pint(i,j,l+1)=pint(i,j,l)+(dsg2(l)*pd(i,j)+pdsg1(l))
          enddo
        enddo
      enddo
!-----------------------------------------------------------------------
      do ks=1,nsmud
!-----------------------------------------------------------------------
        do j=2,lines
          do i=2,im-1
            pdr(i,j)=(pd(i,j-1)+pd(i-1,j) &
                    +pd(i+1,j)+pd(i,j+1))*w1+w2*pd(i,j)       
          enddo
        enddo
        do l=1,lm
          do j=2,lines
            do i=2,im-1
              tr(i,j,l)=(t(i,j-1,l)+t(i-1,j,l) &
                        +t(i+1,j,l)+t(i,j+1,l))*w1 &
                       +w2*t(i,j,l)       
              qr(i,j,l)=(q(i,j-1,l)+q(i-1,j,l) &
                        +q(i+1,j,l)+q(i,j+1,l))*w1 &
                       +w2*q(i,j,l)
              pr(i,j,l)=(pint(i,j-1,l+1)+pint(i-1,j,l+1) &
                        +pint(i+1,j,l+1)+pint(i,j+1,l+1))*w1 &
                       +w2*pint(i,j,l+1)       
            enddo
          enddo
        enddo
        do j=jm-lines+1,jm-1
          do i=2,im-1
            pdr(i,j)=(pd(i,j-1)+pd(i-1,j) &
                    +pd(i+1,j)+pd(i,j+1))*w1+w2*pd(i,j)       
          enddo
        enddo
        do l=1,lm
          do j=jm-lines+1,jm-1
            do i=2,im-1
              tr(i,j,l)=(t(i,j-1,l)+t(i-1,j,l) &
                        +t(i+1,j,l)+t(i,j+1,l))*w1 &
                       +w2*t(i,j,l)       
              qr(i,j,l)=(q(i,j-1,l)+q(i-1,j,l) &
                        +q(i+1,j,l)+q(i,j+1,l))*w1 &
                       +w2*q(i,j,l)
              pr(i,j,l)=(pint(i,j-1,l+1)+pint(i-1,j,l+1) &
                        +pint(i+1,j,l+1)+pint(i,j+1,l+1))*w1 &
                       +w2*pint(i,j,l+1)       
            enddo
          enddo
        enddo
        do j=lines+1,jm-lines
          do i=2,lines
            pdr(i,j)=(pd(i,j-1)+pd(i-1,j) &
                    +pd(i+1,j)+pd(i,j+1))*w1+w2*pd(i,j)       
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines
            do i=2,lines
              tr(i,j,l)=(t(i,j-1,l)+t(i-1,j,l) &
                        +t(i+1,j,l)+t(i,j+1,l))*w1 &
                       +w2*t(i,j,l)       
              qr(i,j,l)=(q(i,j-1,l)+q(i-1,j,l) &
                        +q(i+1,j,l)+q(i,j+1,l))*w1 &
                       +w2*q(i,j,l)
              pr(i,j,l)=(pint(i,j-1,l+1)+pint(i-1,j,l+1) &
                        +pint(i+1,j,l+1)+pint(i,j+1,l+1))*w1 &
                       +w2*pint(i,j,l+1)       
            enddo
          enddo
        enddo
        do j=lines+1,jm-lines
          do i=im-lines+1,im-1
            pdr(i,j)=(pd(i,j-1)+pd(i-1,j) &
                    +pd(i+1,j)+pd(i,j+1))*w1+w2*pd(i,j)       
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines
            do i=im-lines+1,im-1
              tr(i,j,l)=(t(i,j-1,l)+t(i-1,j,l) &
                        +t(i+1,j,l)+t(i,j+1,l))*w1 &
                       +w2*t(i,j,l)       
              qr(i,j,l)=(q(i,j-1,l)+q(i-1,j,l) &
                        +q(i+1,j,l)+q(i,j+1,l))*w1 &
                       +w2*q(i,j,l)
              pr(i,j,l)=(pint(i,j-1,l+1)+pint(i-1,j,l+1) &
                        +pint(i+1,j,l+1)+pint(i,j+1,l+1))*w1 &
                       +w2*pint(i,j,l+1)       
            enddo
          enddo
        enddo
!-----------------------------------------------------------------------
        do j=2,lines
          do i=2,im-1
            pd(i,j)=pdr(i,j)
          enddo
        enddo
        do l=1,lm
          do j=2,lines
            do i=2,im-1
              t(i,j,l)=tr(i,j,l)
              q(i,j,l)=qr(i,j,l)
              pint(i,j,l+1)=pr(i,j,l)
            enddo
          enddo
        enddo
        do j=jm-lines+1,jm-1
          do i=2,im-1
            pd(i,j)=pdr(i,j)
          enddo
        enddo
        do l=1,lm
          do j=jm-lines+1,jm-1
            do i=2,im-1
              t(i,j,l)=tr(i,j,l)
              q(i,j,l)=qr(i,j,l)
              pint(i,j,l+1)=pr(i,j,l)
            enddo
          enddo
        enddo
        do j=lines+1,jm-lines
          do i=2,lines
            pd(i,j)=pdr(i,j)
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines
            do i=2,lines
              t(i,j,l)=tr(i,j,l)
              q(i,j,l)=qr(i,j,l)
              pint(i,j,l+1)=pr(i,j,l)
            enddo
          enddo
        enddo
        do j=lines+1,jm-lines
          do i=im-lines+1,im-1
            pd(i,j)=pdr(i,j)
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines
            do i=im-lines+1,im-1
              t(i,j,l)=tr(i,j,l)
              q(i,j,l)=qr(i,j,l)
              pint(i,j,l+1)=pr(i,j,l)
            enddo
          enddo
        enddo
!-----------------------------------------------------------------------
      enddo
!-----------------------------------------------------------------------
                        endsubroutine bocoh
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        subroutine bocov &
(im,jm,lm,lnsv &
,dt &
,ube,ubn,ubs,ubw,vbe,vbn,vbs,vbw &
,u,v)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
implicit none
!-----------------------------------------------------------------------
real(kind=kfpt),parameter:: &
 wa=0.5 &                    ! weighting factor
,w1=wa*0.25 &                ! weighting factor
,w2=1.-wa                    ! weighting factor
!-----------------------------------------------------------------------
integer(kind=kint),intent(in):: &
 im &                        ! total # of columns
,jm &                        ! total # of rows
,lm &                        ! total # of levels
,lnsv                        ! blending area width, v points

real(kind=kfpt),intent(in):: &
 dt                          ! dynamics time step

real(kind=kfpt),dimension(1:im,1:lnsv,1:lm,1:2),intent(inout):: &
 ubn &                       ! u wind component at northern boundary
,ubs &                       ! u wind component at southern boundary
,vbn &                       ! v wind component at northern boundary
,vbs                         ! v wind component at southern boundary

real(kind=kfpt),dimension(1:lnsv,1:jm,1:lm,1:2),intent(inout):: &
 ube &                       ! u wind component at eastern boundary
,ubw &                       ! u wind component at western boundary
,vbe &                       ! v wind component at eastern boundary
,vbw                         ! v wind component at western boundary

real(kind=kfpt),dimension(1:im,1:jm,1:lm),intent(inout):: &
 u &                         ! u wind component
,v                           ! v wind component
!---local variables-----------------------------------------------------
integer(kind=kint):: &
 i &                         ! index in x direction
,ib &                        ! index in x direction, boundary zone
,ive &                       ! ending index in x direction, boundaries
,ivs &                       ! starting index in x direction, boundaries
,j &                         ! index in y direction
,jb &                        ! index in y direction, boundary zone
,jve &                       ! ending index in x direction, boundaries
,jvs &                       ! starting index in x direction, boundaries
,k &                         ! boundary line counter
,ks &                        ! smoothing counter
,l &                         ! index in p direction
,lines &                     ! boundary smoothing area
,nsmud                       ! number of smoothing passes

real(kind=kfpt),dimension(1:lnsv):: &
 wv(lnsv)                    ! blending weighting function, wind

real(kind=kfpt),dimension(1:im,1:jm,1:lm):: &
 ur &                        ! u wind component
,vr                          ! v wind component
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      lines=lnsv
      nsmud=lines-1
!-----------------------------------------------------------------------
      wv(1)=1.
      do k=2,lnsv
        wv(k)=exp(-(float(k)-1.)/(float(lnsv)-1.)*7.)
      enddo
!-------------update boundary values at v points------------------------
!-------------southern and northern boundaries--------------------------
      do l=1,lm
        do jb=1,lnsv
          do ib=1,im-1
            ubs(ib,jb,l,1)=ubs(ib,jb,l,1)+ubs(ib,jb,l,2)*dt
            vbs(ib,jb,l,1)=vbs(ib,jb,l,1)+vbs(ib,jb,l,2)*dt
            ubn(ib,jb,l,1)=ubn(ib,jb,l,1)+ubn(ib,jb,l,2)*dt
            vbn(ib,jb,l,1)=vbn(ib,jb,l,1)+vbn(ib,jb,l,2)*dt
          enddo
        enddo
      enddo
!-------------western and eastern boundaries----------------------------
      do l=1,lm
        do jb=1,jm-1
          do ib=1,lnsv
            ubw(ib,jb,l,1)=ubw(ib,jb,l,1)+ubw(ib,jb,l,2)*dt
            vbw(ib,jb,l,1)=vbw(ib,jb,l,1)+vbw(ib,jb,l,2)*dt
            ube(ib,jb,l,1)=ube(ib,jb,l,1)+ube(ib,jb,l,2)*dt
            vbe(ib,jb,l,1)=vbe(ib,jb,l,1)+vbe(ib,jb,l,2)*dt
          enddo
        enddo
      enddo
!-------------southern boundary-----------------------------------------
      do l=1,lm
        do j=1,lnsv
          jb=j
          ivs=jb
          ive=im-jb
          do i=ivs,ive
            ib=i
            u(i,j,l)=ubs(ib,jb,l,1)*wv(jb)+u(i,j,l)*(1.-wv(jb))
            v(i,j,l)=vbs(ib,jb,l,1)*wv(jb)+v(i,j,l)*(1.-wv(jb))
          enddo
        enddo
      enddo
!-------------northern boundary-----------------------------------------
      do l=1,lm
        do j=jm-lnsv,jm-1
          jb=j-jm+lnsv+1
          ivs=lnsv-jb+1
          ive=im+jb-lnsv-1
          do i=ivs,ive
            ib=i
            u(i,j,l)=ubn(ib,jb,l,1)*wv(lnsv+1-jb) &
                    +u(i,j,l)*(1.-wv(lnsv+1-jb))
            v(i,j,l)=vbn(ib,jb,l,1)*wv(lnsv+1-jb) &
                    +v(i,j,l)*(1.-wv(lnsv+1-jb))
          enddo
        enddo
      enddo
!-------------western boundary------------------------------------------
      do l=1,lm
        do i=1,lnsv
          ib=i
          jvs=1+ib
          jve=jm-1-ib
          do j=jvs,jve
            jb=j
            u(i,j,l)=ubw(ib,jb,l,1)*wv(ib)+u(i,j,l)*(1.-wv(ib))
            v(i,j,l)=vbw(ib,jb,l,1)*wv(ib)+v(i,j,l)*(1.-wv(ib))
          enddo
        enddo
      enddo
!-------------eastern boundary------------------------------------------
      do l=1,lm
        do i=im-lnsv,im-1
          ib=i-im+lnsv+1
          jvs=lnsv-ib+2
          jve=jm-lnsv+ib-2
          do j=jvs,jve
            jb=j
            u(i,j,l)=ube(ib,jb,l,1)*wv(lnsv+1-ib) &
                    +u(i,j,l)*(1.-wv(lnsv+1-ib))
            v(i,j,l)=vbe(ib,jb,l,1)*wv(lnsv+1-ib) &
                    +v(i,j,l)*(1.-wv(lnsv+1-ib))
          enddo
        enddo
      enddo
!-----------------------------------------------------------------------
      do ks=1,nsmud
!-----------------------------------------------------------------------
        do l=1,lm
          do j=2,lines
            do i=2,im-2
              ur(i,j,l)=(u(i,j-1,l)+u(i,j-1,l) &
                        +u(i+1,j,l)+u(i,j+1,l))*w1+w2*u(i,j,l)       
              vr(i,j,l)=(v(i,j-1,l)+v(i,j-1,l) &
                        +v(i+1,j,l)+v(i,j+1,l))*w1+w2*v(i,j,l)       
            enddo
          enddo
        enddo
        do l=1,lm
          do j=jm-lines,jm-2
            do i=2,im-2
              ur(i,j,l)=(u(i,j-1,l)+u(i,j-1,l) &
                        +u(i+1,j,l)+u(i,j+1,l))*w1+w2*u(i,j,l)       
              vr(i,j,l)=(v(i,j-1,l)+v(i,j-1,l) &
                        +v(i+1,j,l)+v(i,j+1,l))*w1+w2*v(i,j,l)       
            enddo
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines-1
            do i=2,lines
              ur(i,j,l)=(u(i,j-1,l)+u(i,j-1,l) &
                        +u(i+1,j,l)+u(i,j+1,l))*w1+w2*u(i,j,l)       
              vr(i,j,l)=(v(i,j-1,l)+v(i,j-1,l) &
                        +v(i+1,j,l)+v(i,j+1,l))*w1+w2*v(i,j,l)       
            enddo
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines-1
            do i=im-lines,im-2
              ur(i,j,l)=(u(i,j-1,l)+u(i,j-1,l) &
                        +u(i+1,j,l)+u(i,j+1,l))*w1+w2*u(i,j,l)       
              vr(i,j,l)=(v(i,j-1,l)+v(i,j-1,l) &
                        +v(i+1,j,l)+v(i,j+1,l))*w1+w2*v(i,j,l)       
            enddo
          enddo
        enddo
!-----------------------------------------------------------------------
        do l=1,lm
          do j=2,lines
            do i=2,im-2
              u(i,j,l)=ur(i,j,l)       
              v(i,j,l)=vr(i,j,l)       
            enddo
          enddo
        enddo
        do l=1,lm
          do j=jm-lines,jm-2
            do i=2,im-2
              u(i,j,l)=ur(i,j,l)       
              v(i,j,l)=vr(i,j,l)       
            enddo
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines-1
            do i=2,lines
              u(i,j,l)=ur(i,j,l)       
              v(i,j,l)=vr(i,j,l)       
            enddo
          enddo
        enddo
        do l=1,lm
          do j=lines+1,jm-lines-1
            do i=im-lines,im-2
              u(i,j,l)=ur(i,j,l)       
              v(i,j,l)=vr(i,j,l)       
            enddo
          enddo
        enddo
!-----------------------------------------------------------------------
      enddo
!-----------------------------------------------------------------------
                        endsubroutine bocov
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        endmodule module_fltbnds
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

