!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        module module_moist
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
use module_control,only:spline
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        contains
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                            
                        subroutine cucnvc &
      (global &
      ,im,itb,jm,jtb,kmsc,lm,ncnvc &
      ,cp,dt,g,pl,pt,thl,rdp,rdq,rdth,rdthe &
      ,psgml1,pdsg1,sgml2,dsg2 &
      ,qs0,sqs,ptbl &
      ,the0,sthe,ttbl &
      ,pd,sm &
      ,lpbl,ltop,lbot &
      ,acprec,cldefi,cuppt,cuprec,deep &
      ,prcu,prec,prsn &
      ,tg &
      ,q,t)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!----------------------------------------------------------------------- 
implicit none

include 'kind.inc'
!-----------------------------------------------------------------------
      real(kind=kfpt),parameter:: &
       cappa=0.28589641,dtshal=-1.0 &
      ,elwv=2.50e6,eliv=2.834e6,elivw=2.72e6,row=1.e3,epsq=1.e-20 &
      ,pq0=379.90516,f2=17.2693882,f3=273.15,f4=35.86 &
      ,tfrz=273.15,t1=274.15 &
      ,elevfc=0.6 &
      ,stabs=1.0,rhlsc=0.6,rhhsc=0.9,rhbot=0.80 & !zjtest
      ,epsup=0.95,epsdn=1.05,epsth=0.0 & !zjtest
      ,stabdf=.80,stabds=1.05,epsntp=0.00001,dttop=0.0 & !zjtest
      ,pbm=13000.,pqm=2000.,pno=1000.,pone=2500. &!zjtest
      ,psh=20000.,pfrz=15000.,pshu=45000. &
      ,deftop=.95 & !soft2
      ,wdry=0.75
!
      real(kind=kfpt),parameter:: &
       efimn=.20,efmnt=.70,fr=0.85 & ! .ge.8 km
!      ,dspbfl=-4843.*fr,dsp0fl=-7050.*fr,dsptfl=-2250.*fr,fsl=.85 &
!      ,dspbfs=-4843.*fr,dsp0fs=-7050.*fr,dsptfs=-2250.*fr,fss=.85 &
      ,dspbfl=-3875.*fr,dsp0fl=-5875.*fr,dsptfl=-1875.*fr,fsl=.85 &
      ,dspbfs=-3875.*fr,dsp0fs=-5875.*fr,dsptfs=-1875.*fr,fss=.85 &

      ,dspbsl=dspbfl*fsl,dsp0sl=dsp0fl*fsl,dsptsl=dsptfl*fsl &
      ,dspbss=dspbfs*fss,dsp0ss=dsp0fs*fss,dsptss=dsptfs*fss &
      ,trel=2400.,epspr=1.e-10,efifc=5.0 &
      ,avgefi=(efimn+1.)*.5,dspc=-3000.,epsp=1.e-7 &
      ,stefi=1. &
      ,slopbl=(dspbfl-dspbsl)/(1.-efimn) &
      ,slop0l=(dsp0fl-dsp0sl)/(1.-efimn) &
      ,sloptl=(dsptfl-dsptsl)/(1.-efimn) &
      ,slopbs=(dspbfs-dspbss)/(1.-efimn) &
      ,slop0s=(dsp0fs-dsp0ss)/(1.-efimn) &
      ,slopts=(dsptfs-dsptss)/(1.-efimn) &
      ,slopsd=(stabdf-stabds)/(1.-efimn) &
      ,slope=(1.-efmnt)/(1.-efimn) &
      ,f23m4l=f2*(f3-f4)*elwv
!-----------------------------------------------------------------------
      logical(kind=klog),intent(in):: &
       global
!
      integer(kind=kint),intent(in):: &
       im,itb,jm,jtb,kmsc,lm,ncnvc
!
      real(kind=kfpt),intent(in):: &
       cp,dt,g,pl,pt,thl,rdp,rdq,rdth,rdthe
!
      real(kind=kfpt),dimension(1:lm),intent(in):: &
       dsg2,pdsg1,psgml1,sgml2
!
      real(kind=kfpt),dimension(1:itb),intent(in):: &
       sthe,the0
!
      real(kind=kfpt),dimension(1:jtb),intent(in):: &
       qs0,sqs
!
      integer(kind=kint),dimension(1:im,1:jm),intent(in):: &
       lpbl
!
      real(kind=kfpt),dimension(1:im,1:jm),intent(in):: &
       pd,sm
!
      real(kind=kfpt),dimension(1:itb,1:jtb),intent(in):: &
       ptbl
!
      real(kind=kfpt),dimension(1:jtb,1:itb),intent(in):: &
       ttbl
!
      real(kind=kfpt),dimension(1:im,1:jm,1:kmsc),intent(in):: &
       tg
!
      integer(kind=kint),dimension(1:im,1:jm),intent(out):: &
       lbot,ltop
!
      real(kind=kfpt),dimension(1:im,1:jm),intent(out):: &
       deep

      real(kind=kfpt),dimension(1:im,1:jm),intent(inout):: &
       acprec,cldefi,cuppt,cuprec,prcu,prec,prsn
!
      real(kind=kfpt),dimension(1:im,1:jm,1:lm),intent(inout):: &
       q,t
!-----------------------------------------------------------------------
!  local variables
!-----------------------------------------------------------------------
      logical(kind=klog):: &
       newall,newupup,plume
!
      integer(kind=kint):: &
       i,iq,iqtb,iswap,it,iter &
      ,itrefi,ittb,ittbk,ivi,j,k,kb,kbmax,khdeep,khshal,l,l0,l0m1 &
      ,lbm1,lbtk,lcor,lmid,lqm,lshu,ltp1,ltp2,ltpk,ltsh,n,ndst &
      ,nnew,nold,npbl
!
      real(kind=kfpt):: &
       a11,a12,a21,a22,adef,ama,aqs,arg,arh,avm,avrgt,avrgtl &
      ,b1qsat,b1rh,b1thma,b1thvm,b2qsat,b2rh,b2thma,b2thvm &
      ,bma,bq,bqk,bqs,bqs00k,bqs10k,brh,btfc,bvm,cprlg,cup,den &
      ,dentp1,dentp2,dentp3,depmin,depth,depwl,dhdt,difql,diftl &
      ,dp,dpkl,dpl,dplo,dpmix,dpot,dpravt,dpup,dqref,drhdp,drheat &
      ,dsp,dsp0k,dspbk,dsptk,dsq,dst,dstq,dtcnvc,dtdp,dthem &
      ,elocp,efi,enplo,enpup,epsdt,fefi,ffup,fk,fprs,fptk,fup &
      ,hcorr,otsum,p,p00k,p01k,p10k,p11k,pbtk,pdp,pk0,pkb,pkhi,pkl &
      ,pklo,pkt,plo,potsum,pp1,ppk,preck,psfcp,pspp,psum,ptpk,pup &
      ,qbt,qcorr,qkl,qnew,qotsum,qq1,qqbt,qqk,qrfkl,qrftp,qsat1,qsat2 &
      ,qsp,qsum,qup,qwat,rcp,rden,rdp0t,rdpsum,rhavg,rhh,rhl,rhmax &
      ,rhmean,rhref,rhshmax,rotsum,rtbar,rxnrhi,rxnrkl,rxnrlo,rxnrsp &
      ,smix,smk,smk1,sq,sqk,sqs00k,sqs10k,stabdl,sumde,sumdp,sumdq &
      ,sumdt,sumrh,tauk,tauksc,tcorr,therhi,therlo,thesp,thskl &
      ,thtpk,tkl,tlev2,tlo,tnew,tpsp,tq,tqk,treflo,trfkl,trmlo &
      ,trmup,tskl,tsp,tth,tthbt,tthes,tthk,tup
!
      real(kind=kfpt),dimension(1:lm):: &
       difq,dift,dpk,dspnew,dspold,el,fpk,pk,pnew,pold,psk &
      ,qk,qrefk,qsatk,rhk,rxnrk,rxnrsk &
      ,thee,therk,thmak,thsk,thvmk,thvref,tk,trefk &
      ,spp,spq,wcld,y2
!
      real(kind=kfpt),dimension(1:im,1:jm):: &
       psp,pbot,ptop,rxnrs,thbt

      real(kind=kfpt),dimension(1:im*jm):: &
       ideep,jdeep,ishal,jshal

      real(kind=kfpt),dimension(1:im,1:jm,1:lm):: &
       dentpl,qmod,rxnr,thes,tmod,tref
!-----------------------------------------------------------------------
      elocp=elivw/cp
      cprlg=cp/(row*g*elwv)
      rcp=1./cp
!
      dtcnvc=ncnvc*dt
      tauk=dtcnvc/trel
      tauksc=dtcnvc/(1.*trel)
!
      newall =.false.
      newupup=.true.
!-------------preparations----------------------------------------------
      do j=2,jm-1
        do i=2,im-1
          deep(i,j)=0.
          pdp=pd(i,j)
          lbot(i,j)=lm
          thesp=0.
          tref(i,j,1)=t(i,j,1)
!
          do l=1,lm
            rxnr(i,j,l)=(100000./(sgml2(l)*pdp+psgml1(l)))**0.28589641
            q(i,j,l)=max(q(i,j,l),epsq)
            dentpl(i,j,l)=0.
          enddo
!-------------search for maximum buoyancy level-------------------------
          psfcp=sgml2(lm)*pdp+psgml1(lm)
!
          kbmax=1
          do kb=1,lm
!-----------------------------------------------------------------------
            qbt=q(i,j,kb)
            tthbt=t(i,j,kb)*rxnr(i,j,kb)
            tth=(tthbt-thl)*rdth
            qq1=tth-aint(tth)
            ittb=int(tth)+1
!--------------keeping indices within the table-------------------------
            if (ittb.lt.1) then
              ittb=1
              qq1=0.
            endif
            if (ittb.ge.jtb) then
              ittb=jtb-1
              qq1=0.
            endif
!--------------base and scaling factor for spec. humidity---------------
            ittbk=ittb
            bqs00k=qs0(ittbk)
            sqs00k=sqs(ittbk)
            bqs10k=qs0(ittbk+1)
            sqs10k=sqs(ittbk+1)
!--------------scaling spec. humidity and table index-------------------
            bq=(bqs10k-bqs00k)*qq1+bqs00k
            sq=(sqs10k-sqs00k)*qq1+sqs00k
            tq=(qbt-bq)/sq*rdq
            pp1=tq-aint(tq)
            iqtb=int(tq)+1
!--------------keeping indices within the table-------------------------
            if (iqtb.lt.1) then
              iqtb=1
              pp1=0.
            endif
            if(iqtb.ge.itb)then
              iqtb=itb-1
              pp1=0.
            endif
!--------------saturation pressure at four surrounding table pts.-------
            iq=iqtb
            it=ittb
            p00k=ptbl(iq,it)
            p10k=ptbl(iq+1,it)
            p01k=ptbl(iq,it+1)
            p11k=ptbl(iq+1,it+1)
!--------------saturation point variables at the bottom-----------------
            tpsp=max(p00k+(p10k-p00k)*pp1+(p01k-p00k)*qq1 &
                    +(p00k-p10k-p01k+p11k)*pp1*qq1,1.)
            rxnrsp=(100000./tpsp)**0.28589641
            tthes=tthbt*exp(elocp*qbt*rxnrsp/tthbt)
!-----------------------------------------------------------------------
            thes(i,j,kb)=tthes
!-----------------------------------------------------------------------
            pkl=sgml2(kb)*pdp+psgml1(kb)
!
            if(pkl.ge.elevfc*psfcp) then
!--------------check for maximum buoyancy-------------------------------
              if(tthes.gt.thesp) then
                kbmax=kb
                psp(i,j)=tpsp
                rxnrs(i,j)=rxnrsp
                thbt(i,j)=tthbt
                thesp=tthes
                qqbt=qbt
              endif
!-----------------------------------------------------------------------
            endif
!-----------------------------------------------------------------------
          enddo
!-----------------------------------------------------------------------
          pkb=sgml2(kbmax)*pdp+psgml1(kbmax)
!-----------------------------------------------------------------------
          ltop(i,j)=lbot(i,j)
          pbot(i,j)=sgml2(lbot(i,j))*pdp+psgml1(lbot(i,j))
          ptop(i,j)=pbot(i,j)          
!-----------------------------------------------------------------------
          if(pkb-psp(i,j).lt.5000.) then
!---------choose cloud base as model level just below psp---------------
            pspp=psp(i,j)
            do l=lm,2,-1
              plo=sgml2(l)*pdp+psgml1(l)
              if(plo.ge.pspp.and.plo.gt.pqm) then
                lbot(i,j)=l
              endif
            enddo
!*** warning: lbot(i,j) must not be gt lm-1 in shallow convection
!*** make sure cloud base is at least pone above the surface
            pbot(i,j)=sgml2(lbot(i,j))*pdp+psgml1(lbot(i,j))
            if (pbot(i,j).ge.psfcp-pone.or.lbot(i,j).ge.lm) then
              do l=1,lm-1
                p=sgml2(l)*pdp+psgml1(l)
                if (p.lt.psfcp-pone) then
                  lbot(i,j)=l
                endif
              enddo
              pbot(i,j)=sgml2(lbot(i,j))*pdp+psgml1(lbot(i,j))
            endif
!--------------cloud top computation------------------------------------
            ltop(i,j)=lbot(i,j)
            ptop(i,j)=pbot(i,j)
!-----------------------------------------------------------------------
            enplo=98500.  !+++
            enpup=95000.  !+++
!            enplo=20000.
!            enpup=15000.
            if(global) then
              fup=0.
            else
              fup=1./200000.
            endif
!
            do l=lm,kbmax,-1
              thes(i,j,l)=thesp
            enddo
            do l=1,lm
              thee(l)=thes(i,j,l)
            enddo
!
            fefi=(cldefi(i,j)-efimn)*slope+efmnt
            ffup=fup/(fefi*fefi)
!
            if(pbot(i,j).gt.enplo) then
              fprs=1.
            elseif(pbot(i,j).gt.enpup) then
              fprs=(pbot(i,j)-enpup)/(enplo-enpup)
            else
              fprs=0.
            endif
!
            ffup=ffup*fprs*fprs*0.5
            dpup=dsg2(kbmax)*pdp+pdsg1(kbmax)
!
            do l=kbmax-1,1,-1
              dplo=dpup
              dpup=dsg2(l)*pdp+pdsg1(l)
              thes(i,j,l)=((-ffup*dplo+1.)*thes(i,j,l+1) &
                          +(thee(l)*dpup+thee(l+1)*dplo)*ffup) &
                         /(ffup*dpup+1.)
            enddo
!-----------------------------------------------------------------------
            do ivi=1,lm
              l=lm+1-ivi
              pkl=sgml2(l)*pdp+psgml1(l)
!-----------------------------------------------------------------------
              call ttblex(itb,jtb,pl,pkl,rdp,rdthe,sthe &
                         ,the0,thes(i,j,l),ttbl,tref(i,j,l))
            enddo
!--------------buoyancy check-------------------------------------------
            do l=lm,1,-1
              if(tref(i,j,l).gt.t(i,j,l)-dttop) ltop(i,j)=l
            enddo
!-----------------cloud top pressure------------------------------------
            ptop(i,j)=sgml2(ltop(i,j))*pdp+psgml1(ltop(i,j))
!------------------first entropy check----------------------------------
            if(kbmax.gt.lbot(i,j).and.lbot(i,j).gt.ltop(i,j)) then
!-----------------------------------------------------------------------
              dentp1=0.
              sumdp=0.
              l=kbmax
!
              plo=sgml2(l)*pdp+psgml1(l)          
              tlo=tthbt/rxnr(i,j,l)
              trmlo=((qqbt    *0.608+1.)*tlo &
                    -(q(i,j,l)*0.608+1.)*t(i,j,l))*0.5 &
                   /((q(i,j,l)*0.608+1.)*t(i,j,l))
!
!--- below cloud base
!
              if(kbmax-lbot(i,j).ge.1) then
                do l=kbmax-1,lbot(i,j),-1
                  pup=sgml2(l)*pdp+psgml1(l)
                  tup=tthbt/rxnr(i,j,l)
                  dp=plo-pup
                  trmup=((qqbt    *0.608+1.)*tup &
                        -(q(i,j,l)*0.608+1.)*t(i,j,l))*0.5 &
                       /((q(i,j,l)*0.608+1.)*t(i,j,l))
                  dentpl(i,j,l)=(trmlo+trmup)*dp
                  dentp1=dentpl(i,j,l)+dentp1
                  sumdp=sumdp+dp
                  plo=pup
                  trmlo=trmup
                enddo
              endif
!
!--- cloud base layer
! 
              l=lbot(i,j)-1
              pkl=sgml2(l)*pdp+psgml1(l)
              pup=psp(i,j)
              tup=tthbt/rxnrs(i,j)
              tsp=((t(i,j,l+1)-t(i,j,l))/(plo-pkl))*(pup-pkl)+t(i,j,l)
              qsp=((q(i,j,l+1)-q(i,j,l))/(plo-pkl))*(pup-pkl)+q(i,j,l)
              dp=plo-pup
              trmup=((qqbt*0.608+1.)*tup &
                    -(qsp *0.608+1.)*tsp)*0.5 &
                   /((qsp *0.608+1.)*tsp)
              dentpl(i,j,l)=(trmlo+trmup)*dp
              sumdp=sumdp+dp
              plo=pup
              trmlo=trmup
!
!--- above saturation pressure updraft t and q along moist adiabat
!
              pup=pkl
!
!--- calculate updraft temperature along moist adiabat (tup)
!
              call ttblex(itb,jtb,pl,pup,rdp,rdthe &
                         ,sthe,the0,thes(i,j,l),ttbl,tup)
!
              qup=pq0/pup*exp(f2*(tup-f3)/(tup-f4))
              qwat=qqbt-qup  !-- water loading effects, reversible adiabat
              dp=plo-pup
              trmup=((qup* 0.608+1.-qwat)*tup &
                    -(q(i,j,l)*0.608+1.     )*t(i,j,l))*0.5 &
                   /((q(i,j,l)*0.608+1.     )*t(i,j,l))
!
              dentpl(i,j,l)=(trmlo+trmup)*dp+dentpl(i,j,l)
              dentp1=dentpl(i,j,l)+dentp1
              sumdp=sumdp+dp
              plo=pup
              trmlo=trmup
!
!-----------------------------------------------------------------------
!--- in cloud above cloud base
!-----------------------------------------------------------------------
              do l=lbot(i,j)-2,ltop(i,j),-1
                pup=sgml2(l)*pdp+psgml1(l)
!--- calculate updraft temperature along moist adiabat (tup)
!
                call ttblex(itb,jtb,pl,pup,rdp,rdthe &
                           ,sthe,the0,thes(i,j,l),ttbl,tup)
!
                qup=pq0/pup*exp(f2*(tup-f3)/(tup-f4))
                qwat=qqbt-qup  !-- water loading , reversible adiabat
                dp=plo-pup
                trmup=((qup     *0.608+1.-qwat)*tup &
                      -(q(i,j,l)*0.608+1.     )*t(i,j,l))*0.5 &
                     /((q(i,j,l)*0.608+1.     )*t(i,j,l))
                dentpl(i,j,l)=(trmlo+trmup)*dp
                dentp1=dentpl(i,j,l)+dentp1
!
!                if(dentpl(i,j,l).lt.epsntp) then
!                  ltop(i,j)=l
!                  ptop(i,j)=plo
!                  go to 300
!                endif
!
                sumdp=sumdp+dp
                plo=pup
                trmlo=trmup
              enddo
!-----------------------------------------------------------------------
              dentp1=dentp1*cp/sumdp
!-----------------------------------------------------------------------
              if(dentp1.le.epsntp) then
                ltop(i,j)=lbot(i,j)
                ptop(i,j)=pbot(i,j)
              endif
!-----------------------------------------------------------------------
            endif
            do l=1,lm
              dentpl(i,j,l)=0.
            enddo
            ltop(i,j)=lbot(i,j)
            ptop(i,j)=pbot(i,j)
          endif
!-----------------------------------------------------------------------
 300      continue
        enddo
      enddo
!-------------second grand loop-----------------------------------------
      ndst=0
      khdeep=0
      do j=2,jm-1
        do i=2,im-1
!-------------initialize changes of t and q due to convection-----------
          do l=1,lm
            tmod(i,j,l)=0.
            qmod(i,j,l)=0.
          enddo
!-------------clean up and gather deep convection points----------------
          if (ltop(i,j).gt.lbot(i,j)) then
            lbot(i,j)=0
            ltop(i,j)=lbot(i,j)
            ptop(i,j)=pbot(i,j)
          endif
          if (ptop(i,j).gt.pbot(i,j)-pno.or. &
              ltop(i,j).gt.lbot(i,j)-2) then
            cldefi(i,j)=avgefi
          endif
          psfcp=pd(i,j)+pt
          depmin=psh*(psfcp*1.e-5)
          depth=pbot(i,j)-ptop(i,j)
          if (depth.ge.depmin) then
            khdeep=khdeep+1
            ideep(khdeep)=i
            jdeep(khdeep)=j
          endif
        enddo
      enddo
!-------------horizontal loop for deep convection-----------------------
      do n=1,khdeep
        i=ideep(n)
        j=jdeep(n)
!print*,2,khdeep,n,i,j
!dcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd
!dcdcdcdcdcdc  deep convection   dcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd
!dcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd
        pdp=pd(i,j)
        psfcp=pd(i,j)+pt
!-----------------------------------------------------------------------
 100    ltpk=ltop(i,j)
        lbtk=lbot(i,j)
!--------------initialize variables in the convective column------------
        do l=1,lm
          dift(l)=0.
          difq(l)=0.
          tkl=t(i,j,l)
          tk(l)=tkl
          trefk(l)=tkl
          if(tkl.ge.tfrz) then
            el(l)=elwv
          else
            el(l)=eliv
          endif
          qkl=q(i,j,l)
          qk(l)=qkl
          qrefk(l)=qkl
          pkl=sgml2(l)*pdp+psgml1(l)
          pk(l)=pkl
          psk(l)=pkl
          rxnrkl=rxnr(i,j,l)
          rxnrk(l)=rxnrkl
          therk(l)=tref(i,j,l)*rxnrkl
        enddo
!-------------deep convection reference temperature profile-------------
        ltp1=ltpk+1
        lbm1=lbtk-1
        pkb=pk(lbtk)
        pkt=pk(ltpk)
!
        efi=cldefi(i,j)
!-------------temperature reference profile below freezing level--------
        l0=lbtk
        pk0=pk(lbtk)
        treflo=trefk(lbtk)
        therlo=therk(lbtk)
        rxnrlo=rxnrk(lbtk)
        therhi=therk(lbm1)
        rxnrhi=rxnrk(lbm1)
!
        stabdl=(efi-efimn)*slopsd+stabds
!
        do l=ltpk,lbm1
          ivi=ltpk+lbm1-l
          if (t(i,j,ivi+1).lt.tfrz) go to 430
          treflo=((therhi-therlo)*stabdl+treflo*rxnrlo)/rxnrhi
          trefk(ivi)=treflo
          rxnrlo=rxnrhi
          therlo=therhi
          rxnrhi=rxnrk(ivi-1)
          therhi=therk(ivi-1)
          l0=ivi
          pk0=pk(l0)
        enddo
!if(i.eq.289.and.j.eq.346) print*,2
!-------------freezing level at or above the cloud top------------------
        go to 450
 430  continue
!-------------temperature reference profile above freezing level--------
        l0m1=l0-1
        rdp0t=1./(pk0-pkt)
        dthem=therk(l0)-trefk(l0)*rxnrk(l0)
        do l=ltpk,l0m1
          trefk(l)=(therk(l)-(pk(l)-pkt)*dthem*rdp0t)/rxnrk(l)
        enddo 
 450    continue
!-------------first correction of reference temperature profile---------
        sumdt=0.
        sumdp=0.
        do l=ltpk,lbtk
          dpl=dsg2(l)*pdp+pdsg1(l)
          sumdt=(tk(l)-trefk(l))*dpl+sumdt
          sumdp=sumdp+dpl
        enddo
        tcorr=sumdt/sumdp
        do l=ltpk,lbtk
          trefk(l)=trefk(l)+tcorr
        enddo
!if(i.eq.289.and.j.eq.346) print*,3,pfrz,psfcp,pkb,pk0
!-----------------------------------------------------------------------
        depth=pfrz*psfcp*1.e-5
        depwl=pkb-pk0
!        btfc=100000./psfcp
        btfc=1.
!
        smk=sm(i,j)
        smk1=1.-smk
!-----------------------------------------------------------------------
!if(i.eq.289.and.j.eq.346) print*,4
        do itrefi=1,3  ! iteration loop for efi !zjtest control
!-----------------------------------------------------------------------
          dspbk=((efi-efimn)*slopbs+dspbss*btfc)*smk &
               +((efi-efimn)*slopbl+dspbsl*btfc)*smk1
          dsp0k=((efi-efimn)*slop0s+dsp0ss*btfc)*smk &
               +((efi-efimn)*slop0l+dsp0sl*btfc)*smk1
          dsptk=((efi-efimn)*slopts+dsptss*btfc)*smk &
               +((efi-efimn)*sloptl+dsptsl*btfc)*smk1
!-------------spline interpolation of dsp's-----------------------------
          if(depwl.ge.depth.and.l0.gt.ltpk) then 
            nold=3
!
            pold(1)=pk(ltpk)
            pold(2)=pk(l0)
            pold(3)=pk(lbtk)
!
            dspold(1)=dsptk
            dspold(2)=dsp0k
            dspold(3)=dspbk
!
            y2(1)=0.
            y2(3)=0.
!
            nnew=lbtk-ltpk+1
!
            do l=ltpk,lbtk
              pnew(l-ltpk+1)=pk(l)
            enddo
!
            call spline(lm,nold,pold,dspold,y2,nnew,pnew,dspnew,spp,spq)
          endif
!-------------deep convection reference humidity profile----------------
!if(i.eq.289.and.j.eq.346) print*,41
          do l=ltpk,lbtk
!-------------saturation pressure difference----------------------------
            if(depwl.ge.depth.and.l0.gt.ltpk) then 
              dsp=dspnew(l-ltpk+1)
            else
              dsp=dsp0k
              if(l.lt.l0) then
                dsp=((pk0-pk(l))*dsptk+(pk(l)-pkt)*dsp0k)/(pk0-pkt)
              endif
            endif
!-------------humidity profile------------------------------------------
            if(pk(l).gt.pqm) then
              psk(l)=pk(l)+dsp
              rxnrsk(l)=(100000./psk(l))**0.28589641
              thsk(l)=trefk(l)*rxnrk(l)
              qrefk(l)=pq0/psk(l)*exp(f2*(thsk(l)-f3*rxnrsk(l)) &
                                        /(thsk(l)-f4*rxnrsk(l)))
            else
              qrefk(l)=q(i,j,l)
            endif
          enddo
!if(i.eq.289.and.j.eq.346) print*,42
!-------------enthalpy conservation integral----------------------------
          do iter=1,2
!-----------------------------------------------------------------------
            sumde=0.
            sumdp=0.
!if(i.eq.289.and.j.eq.346) print*,421

            do l=ltpk,lbtk
              dpl=dsg2(l)*pdp+pdsg1(l)
              sumde=((tk(l)-trefk(l))*cp+(qk(l)-qrefk(l))*el(l))*dpl+sumde
              sumdp=sumdp+dpl
            enddo
!if(i.eq.289.and.j.eq.346) print*,422

            hcorr=sumde/(sumdp-pdsg1(ltpk)-dsg2(ltpk)*pdp)
            lcor=ltpk+1
!-------------find lqm--------------------------------------------------
            lqm=1
!if(i.eq.289.and.j.eq.346) print*,423
            do l=1,lbtk
              if (pk(l).le.pqm) lqm=l
            enddo
!-------------above lqm correct temperature only------------------------
            if (lcor.le.lqm) then
              do l=lcor,lqm
                trefk(l)=trefk(l)+hcorr*rcp
              enddo
              lcor=lqm+1
            endif
!if(i.eq.289.and.j.eq.346) print*,424

!-------------below lqm correct both temperature and moisture-----------
            do l=lcor,lbtk
              tskl=trefk(l)*rxnrk(l)/rxnrsk(l)
              dhdt=qrefk(l)*f23m4l/(tskl-f4)**2+cp
!if(i.eq.289.and.j.eq.346) print*,l,lqm,lcor,lbtk,tskl,dhdt,hcorr
              trefk(l)=hcorr/dhdt+trefk(l)
              thskl=trefk(l)*rxnrk(l)
              arg=(f2*(thskl-f3*rxnrsk(l))/(thskl-f4*rxnrsk(l)))
!if(i.eq.289.and.j.eq.346) print*,arg
              if(abs(arg).lt.37.) then
                qrefk(l)=pq0/psk(l)*exp(arg)
              else
                qrefk(l)=q(i,j,l)
              endif
!if(i.eq.289.and.j.eq.346) print*,l,qrefk(l)
            enddo
!-----------------------------------------------------------------------
          enddo ! end of enthalpy conservation iterations
!if(i.eq.289.and.j.eq.346) print*,44
!-------------heating, moistening, precipitation------------------------
          dst=0.
          dsq=0.
          avrgt=0.
          preck=0.
!
          do l=ltpk,lbtk
            dpl=dsg2(l)*pdp+pdsg1(l)
            tkl=tk(l)
            diftl=(trefk(l)-tkl)*tauk
            difql=(qrefk(l)-qk(l))*tauk
            avrgtl=(tkl+tkl+diftl)
            dpravt=dpl/avrgtl
            dst=diftl*dpravt+dst
            dsq=difql*el(l)*dpravt+dsq
            avrgt=avrgtl*dpl+avrgt
            preck=diftl*dpl+preck
            dift(l)=diftl
            difq(l)=difql
          enddo
          dst=dst*cp
          dst=dst+dst
          dsq=dsq+dsq
          dentp2=dst+dsq
          avrgt=avrgt/(sumdp+sumdp)
!-------------deep convection ------------------------------------------
          drheat=preck*cp/avrgt
          efi=efifc*dentp2/drheat
!-------------unified or separate land/sea convection-------------------
          efi=min(efi,1.)
          efi=max(efi,efimn)
!-------------end of iteration loop for efi-----------------------------
        enddo  ! end of iteration loop for efi
!if(i.eq.289.and.j.eq.346) print*,45,dentp2,epsntp,fefi
!-------------swap if entropy and/or precip .lt. 0 ...------------------
!zjtest              if(dst.gt.0..and.dentp2.ge.epsntp.and.preck.gt.epspr) then
        deep_or_swap: if(dentp2.ge.epsntp.and.preck.gt.epspr) then ! deep
!-------------deep convection-------------------------------------------
          cldefi(i,j)=efi
          fefi=(efi-efimn)*slope+efmnt
          fefi=fefi*(dentp2-epsntp)/dentp2
          preck=preck*fefi
!-------------update precipitation, temperature and moisture------------
          deep(i,j)=1.
          cup=preck*cprlg
!if(preck.gt.45000.) then
!print*,'preck,efi,fefi,dentp1,cup,cprlg',preck,efi,fefi,dentp1,cup,cprlg
!print*,'dift,',dift
!print*,'difq,',difq
!print*,'dentpl',(dentpl(i,j,l),l=1,lm)
!endif
            if(     t(i,j,lm  ).ge.273.15 &
               .and.t(i,j,lm-1).ge.273.15 &
               .and.t(i,j,lm-2).ge.273.15 &
               .and.t(i,j,lm-3).ge.273.15 &
               .and.t(i,j,lm-4).ge.273.15 &
               .and.t(i,j,lm-5).ge.273.15 &
               .and.tg(i,j,1)  .ge.273.15) then
              prcu(i,j)=cup
            else
              prsn(i,j)=cup+prsn(i,j)
            endif
            prec(i,j)=prec(i,j)+cup
            cuppt(i,j)=cuppt(i,j)+cup
            cuprec(i,j)=cuprec(i,j)+cup
            acprec(i,j)=acprec(i,j)+cup
!if(i.eq.289.and.j.eq.346) print*,6
!if(i.eq.150)print*,j,(difq(l),l=25,lm)
!
            do l=ltpk,lbtk
              tmod(i,j,l)=dift(l)*fefi
              qmod(i,j,l)=difq(l)*fefi
            enddo
!-----------------------------------------------------------------------
          else deep_or_swap ! swap
!-----------------------------------------------------------------------
!***  reduce the cloud top
!-----------------------------------------------------------------------
!if(i.eq.289.and.j.eq.346) print*,451,cldefi(i,j),efimn,smk,stefi,pshu &
!                               ,pk,lbot(i,j),depmin
!          cldefi(i,j)=efimn*smk+stefi*(1.-smk)
!          ptpk=max(pshu,pk(lbot(i,j))-depmin)
!***
!***  cloud top is the level just below pbtk-psh or just below pshu
!**
!if(i.eq.289.and.j.eq.346) print*,45112
!          do l=1,lm
!            if(pk(l)<=ptpk)ltop(i,j)=l+1
!          enddo
!if(i.eq.289.and.j.eq.346) print*,45113
!-----------------------------------------------------------------------
!-- make shallow cloud top a function of entropy change sign
!-----------------------------------------------------------------------
!          ltp1=lbot(i,j)
!          do l=lbot(i,j)-1,ltop(i,j),-1
!            if (dentpl(i,j,l).lt.epsntp) then
!              ltp1=l+1
!            else
!              exit
!            endif
!          enddo
!if(i.eq.289.and.j.eq.346) print*,45114
!        ltop(i,j)=min(ltp1,lbot(i,j))
!-- end: buoyancy check (24 aug 2006)
!if(i.eq.289.and.j.eq.346) print*,452
!          iswap=1 ! failed deep convection, shallow swap point
!          ptop=pk(ltop(i,j))
!-----------------------------------------------------------------------
!        endif deep_or_swap
!if(i.eq.289.and.j.eq.346) print*,453
!-----------------reduce the cloud top----------------------------------
!zjtest      ltop(i,j)=ltop(i,j)+2
!zjtest      ptop(i,j)=sgml2(ltop(i,j))*pdp+psgml1(ltop(i,j))
!zjtest      depmin=psh*(psfcp*1.e-5)
!zjtest      depth=pbot(i,j)-ptop(i,j)
!zjtest      if(depth.ge.depmin) go to 100
!-------------swap to shallow convection--------------------------------
            if(dst.lt.0.) ndst=ndst+1
            cldefi(i,j)=avgefi
!-----------------------------------------------------------------------
!dcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd
!dcdcdcdcdcdc          end of deep convection            dcdcdcdcdcdcdcd
!dcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd
!-------------swap and search for shallow cloud top---------------------
            lbtk=lbot(i,j)
            ltsh=lbtk
            lbm1=lbtk-1
            pbtk=pk(lbtk)
!
            psfcp=pd(i,j)+pt
            depmin=psh*(psfcp*1.e-5)
!
            ptpk=pbtk-depmin
!if(i.eq.289.and.j.eq.346) print*,454
!-------------cloud top is the level just below pbtk-psh----------------
            do l=1,lm
              if(pk(l).le.ptpk) ltpk=l+1
            enddo
            ptpk=pk(ltpk)
!--------------highest level allowed is level just below pshu-----------
            if(ptpk.le.pshu) then
              do l=1,lm
                if(pk(l).le.pshu) lshu=l+1
              enddo
              ltpk=lshu
              ptpk=pk(ltpk)
            endif
            ltp1=ltpk+1
            ltp2=ltpk+2
!if(i.eq.289.and.j.eq.346) print*,7
!-----------------------------------------------------------------------
            do l=ltpk,lbtk
              qsatk(l)=pq0/pk(l)*exp(f2*(tk(l)-f3)/(tk(l)-f4))
            enddo
!-----------------------------------------------------------------------
            rhh=qk(ltpk)/qsatk(ltpk)
            rhmax=0.
            do l=ltp1,lbm1
              rhl=qk(l)/qsatk(l)
              drhdp=(rhh-rhl)/(pk(l-1)-pk(l))
              if(drhdp.gt.rhmax)then
                ltsh=l-1
                rhmax=drhdp
              endif
              rhh=rhl
            enddo
!
            ltop(i,j)=ltsh
!---------------shallow cloud must be at least two layers thick---------
            if(lbot(i,j)-ltop(i,j).lt.2) ltop(i,j)=lbot(i,j)-2
!
            ptop(i,j)=pk(ltop(i,j))
!-----------------------------------------------------------------------
          endif deep_or_swap ! swap
        enddo
!-----------------------------------------------------------------------
!      acpmx=-999.
!      cupmx=-999.
!              do j=jm/4,3*jm/4
!          do i=im/4,3*im/4
!          if(acprec(i,j).gt.acpmx) then
!      acpmx=acprec(i,j)
!      iacpmx=i
!      jacpmx=j
!          endif
!          if(cuprec(i,j).gt.cupmx) then
!      cupmx=cuprec(i,j)
!      icupmx=i
!      jcupmx=j
!          endif
!          enddo
!              enddo
!-----------------------------------------------------------------------
!      write(25,*) 'acpmx=',acpmx,' iacpmx=',iacpmx,' jacpmx=',jacpmx
!      write(25,*) 'cupmx=',cupmx,' icupmx=',icupmx,' jcupmx=',jcupmx
!-------------gather shallow convection points--------------------------
      khshal=0
      npbl=0
              do j=2,jm-1
          do i=2,im-1
!if(i.eq.289.and.j.eq.346) print*,3,lpbl(i,j),lpbl(i,j)
          if(lbot(i,j).ne.0) then
          if(lpbl(i,j).lt.lbot(i,j)) then
      lbot(i,j)=lpbl(i,j)
      npbl=npbl+1
          endif
      if(lbot(i,j).gt.lm-1) lbot(i,j)=lm-1
!
      pbot(i,j)=sgml2(lbot(i,j))*pd(i,j)+psgml1(lbot(i,j))
!
              if(.not.(ptop(i,j).gt.pbot(i,j)-pno.or. &
                       ltop(i,j).gt.lbot(i,j)-2)) then
          psfcp=pd(i,j)+pt
          depmin=psh*(psfcp*1.e-5)
          if(ptop(i,j)+1.0.ge.pbot(i,j)-depmin) then
      khshal=khshal+1
      ishal(khshal)=i
      jshal(khshal)=j
          endif
              endif
              endif
!if(i.eq.289.and.j.eq.346) print*,31,i,j
              enddo
                  enddo
!-------------horizontal loop for shallow convection--------------------
      do n=1,khshal
        i=ishal(n)
        j=jshal(n)
!scscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscs
!scscscscscsc         shallow convection          cscscscscscscscscscscs
!scscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscs
        pdp=pd(i,j)
!print*,32,khshal,i,j
!-----------------------------------------------------------------------
        do l=1,lm
          dpk   (l)=dsg2(l)*pdp+pdsg1(l)
          pk    (l)=sgml2(l)*pdp+psgml1(l)
          tk    (l)=t(i,j,l)
          qk    (l)=q(i,j,l)
          trefk (l)=t(i,j,l)
          qrefk (l)=q(i,j,l)
          qsatk (l)=pq0/pk(l)*exp(f2*(tk(l)-f3)/(tk(l)-f4))
          rxnrk (l)=rxnr(i,j,l)
          thvref(l)=tk(l)*rxnrk(l)*(qk(l)*0.608+1.)
!
          if(tk(l).ge.273.15)then
            el(l)=elwv
          else
            el(l)=eliv
          endif
        enddo
!if(i.eq.158.and.j.eq.65) print*,311,i,j
!-----------------------------------------------------------------------
!-- begin: raise cloud top if avg rh>rhshmax and cape>0
!   rhshmax=rh at cloud base associated with a dsp of pone
!-----------------------------------------------------------------------
      tlev2=tk(lbot(i,j))*((pk(lbot(i,j))-pone)/pk(lbot(i,j)))**cappa
      qsat1=pq0/pk(lbot(i,j)) &
           *exp(f2*(tk(lbot(i,j))-f3)/(tk(lbot(i,j))-f4))
      qsat2=pq0/(pk(lbot(i,j))-pone)*exp(f2*(tlev2-f3)/(tlev2-f4))
      rhshmax=qsat2/qsat1
      sumdp=0.
      rhavg=0.
!
      do l=lbot(i,j),ltop(i,j),-1
        rhavg=rhavg+dpk(l)*qk(l)/qsatk(l)
        sumdp=sumdp+dpk(l)
      enddo
!
      if (rhavg/sumdp > rhshmax) then
        ltsh=ltop(i,j)
        do l=ltop(i,j)-1,1,-1
          rhavg=rhavg+dpk(l)*qk(l)/qsatk(l)
          sumdp=sumdp+dpk(l)
          if (dentpl(i,j,l).lt.0) then
            ltsh=l
          else
            exit
          endif
          if (rhavg/sumdp <= rhshmax) exit
          if (pk(l) <= pshu) exit
        enddo
        ltop(i,j)=ltsh
        ptop=pk(ltop(i,j))
      endif
!if(i.eq.158.and.j.eq.65) print*,312,i,j                                         

!-- end: raise cloud top if avg rh>rhshmax and cape>0
!---------------------------shallow cloud top---------------------------
      lbm1=lbot(i,j)-1
      ptpk=ptop(i,j)
      ltp1=ltop(i,j)-1
      depth=pbot(i,j)-ptop(i,j)
!-----------------------------------------------------------------------
      if(depth.ge.depmin*0.75) then
        plume=.true.
      else
        plume=.false.
      endif
!-----------------------------------------------------------------------
      if(ptop(i,j)>pbot(i,j)-pno.or.ltop(i,j)>lbot(i,j)-2)then
        lbot(i,j)=0
        ltop(i,j)=lm
        ptop(i,j)=pbot(i,j)
        return
      endif
!if(i.eq.158.and.j.eq.65) print*,313,i,j                                         

!-----------------------------------------------------------------------
!***  new cloud at all shallow points
!-----------------------------------------------------------------------
!zj      if(newall) go to 810 ! new cloud at all shallow points
!zj      if(newall.and.sm.lt.0.5) go to 810 ! new cloud at land points
      if(newall.and.plume) go to 810 ! new cloud at plume points
!zj      if(newall.and.plume.and.sm.lt.0.5) go to 810 !plume land points
!-----------------------------------------------------------------------
!***  new cloud at swap shallow points
!-----------------------------------------------------------------------
!zj      if(newswap.and.iswap.gt.0) go to 810 ! new cloud only at swap pts.
!zj      if(newswap.and.iswap.gt.0.and.sm.lt.0.5) go to 810 ! new cloud only at swap pts.
!zj      if(newswap.and.iswap.gt.0.and.plume) go to 810 ! new cloud if plume at swap pts.
!zj      if(newswap.and.iswap.gt.0.and.plume.and.sm.lt.0.5) go to 810 ! new cloud only at swap pts.
!--------------scaling potential temperature & table index at top-------
      thtpk=t(i,j,ltpk)*rxnr(i,j,ltpk)
!
      tthk=(thtpk-thl)*rdth
      qqk=tthk-aint(tthk)
      it=int(tthk)+1
      if(it.lt.1)then
        it=1
        qqk=0.
      endif
      if(it.ge.jtb)then
        it=jtb-1
        qqk=0.
      endif
!--------------base and scaling factor for spec. humidity at top--------
      bqs00k=qs0(it)
      sqs00k=sqs(it)
      bqs10k=qs0(it+1)
      sqs10k=sqs(it+1)
!--------------scaling spec. humidity & table index at top--------------
      bqk=(bqs10k-bqs00k)*qqk+bqs00k
      sqk=(sqs10k-sqs00k)*qqk+sqs00k
!
      tqk=(q(i,j,ltpk)-bqk)/sqk*rdq
!
      ppk=tqk-aint(tqk)
      iq=int(tqk)+1
      if(iq.lt.1)then
        iq=1
        ppk=0.
      endif
      if(iq.ge.itb)then
        iq=itb-1
        ppk=0.
      endif
!--------------cloud top saturation point pressure----------------------
      ptpk=ptbl(iq,it) &
          +(ptbl(iq+1,it)-ptbl(iq,it))*ppk &
          +(ptbl(iq,it+1)-ptbl(iq,it))*qqk &
          +(ptbl(iq  ,it  )-ptbl(iq+1,it  ) &
           -ptbl(iq  ,it+1)+ptbl(iq+1,it+1))*ppk*qqk
if(i.eq.158.and.j.eq.65) print*,314,i,j                                         

!-----------------------------------------------------------------------
      dpmix=ptpk-psp(i,j)
      if(abs(dpmix).lt.3000.)dpmix=-3000.
!----------------temperature profile slope------------------------------
      smix=(thtpk-thbt(i,j))/dpmix*stabs
!
      treflo=trefk(lbot(i,j)+1)
      pklo=pk(lbot(i,j)+1)
      pkhi=pk(lbot(i,j))
      rxnrlo=rxnrk(lbot(i,j)+1)
      rxnrhi=rxnrk(lbot(i,j))
!
      lmid=.5*(lbot(i,j)+ltop(i,j))
!
      do l=lbot(i,j),ltop(i,j),-1
        treflo=((pkhi-pklo)*smix+treflo*rxnrlo)/rxnrhi
        trefk(l)=treflo
        if(l<=lmid) trefk(l)=max(trefk(l),tk(l)+dtshal)
        rxnrlo=rxnrhi
        pklo=pkhi
        rxnrhi=rxnrk(l-1)
        pkhi=pk(l-1)
      enddo
!----------------temperature reference profile correction---------------
      sumdt=0.
      sumdp=0.
!
      do l=ltop(i,j),lbot(i,j)
        sumdt=(tk(l)-trefk(l))*dpk(l)+sumdt
        sumdp=sumdp+dpk(l)
      enddo
!
      rdpsum=1./sumdp
      fpk(lbot(i,j))=trefk(lbot(i,j))
!
      tcorr=sumdt*rdpsum
!
      do l=ltop(i,j),lbot(i,j)
        trfkl   =trefk(l)+tcorr
        trefk(l)=trfkl
        fpk  (l)=trfkl
      enddo
!----------------humidity profile equations-----------------------------
      psum  =0.
      qsum  =0.
      potsum=0.
      qotsum=0.
      otsum =0.
      dst   =0.
      fptk  =fpk(ltop(i,j))
!
      do l=ltop(i,j),lbot(i,j)
        dpkl  =fpk(l)-fptk
        psum  =dpkl *dpk(l)+psum
        qsum  =qk(l)*dpk(l)+qsum
        rtbar =2./(trefk(l)+tk(l))
        otsum =dpk(l)*rtbar+otsum
        potsum=dpkl   *rtbar*dpk(l)+potsum
        qotsum=qk(l)  *rtbar*dpk(l)+qotsum
        dst   =(trefk(l)-tk(l))*rtbar*dpk(l)/el(l)+dst
      enddo
!
      psum  =psum*rdpsum
      qsum  =qsum*rdpsum
      rotsum=1./otsum
      potsum=potsum*rotsum
      qotsum=qotsum*rotsum
      dst   =dst*rotsum*cp
!
!-----------------------------------------------------------------------
!***  if upward transport of temperature go to new cloud
!-----------------------------------------------------------------------
!zj      if(newupup.and.dst.gt.0.) go to 810 ! new for both heat and moisture up

!zj      if(newupup.and.dst.gt.0..and.sm.lt.0.5) go to 810 ! new shallow cloud for both heat and moisture up
      if(newupup.and.dst.gt.0..and.plume) go to 810 ! new shallow cloud if plume for both heat and moisture up
!zj      if(newupup.and.dst.gt.0..and.plume.and.sm.lt.0.5) go to 810 ! new shallow cloud for both heat and moisture up
!-----------------------------------------------------------------------
!*** otherwise old cloud
!-----------------------------------------------------------------------
      if(dst.gt.0.) then 
        lbot(i,j)=0          
        ltop(i,j)=lm     
        ptop(i,j)=pbot(i,j)   
        return 
      endif
!-----------------------------------------------------------------------
!***  otherwise continue with old cloud
!----------------ensure positive entropy change-------------------------
      dstq=dst*epsdn
!----------------check for isothermal atmosphere------------------------
      den=potsum-psum
!
      if(-den/psum<5.e-5)then
        lbot(i,j)=0
        ltop(i,j)=lm
        ptop(i,j)=pbot(i,j)
        return
!----------------slope of the reference humidity profile----------------
!
      else
        dqref=(qotsum-dstq-qsum)/den
      endif
!
!-------------- humidity does not increase with height------------------
!
      if(dqref<0.)then
        lbot(i,j)=0
        ltop(i,j)=lm
        ptop(i,j)=pbot(i,j)
        return
      endif
!
!----------------humidity at the cloud top------------------------------
!
      qrftp=qsum-dqref*psum
!
!----------------humidity profile---------------------------------------
!
      do l=ltop(i,j),lbot(i,j)
        qrfkl=(fpk(l)-fptk)*dqref+qrftp
!
!***  too dry clouds not allowed
!
        tnew=(trefk(l)-tk(l))*tauksc+tk(l)
        qsatk(l)=pq0/pk(l)*exp(f2*(tnew-f3)/(tnew-f4))
        qnew=(qrfkl-qk(l))*tauksc+qk(l)
!
        if(qnew<qsatk(l)*rhlsc)then
          lbot(i,j)=0
          ltop(i,j)=lm
          ptop(i,j)=pbot(i,j)
          return
        endif
!
!-------------too moist clouds not allowed------------------------------
!
        if(qnew>qsatk(l)*rhhsc)then
          lbot(i,j)=0
          ltop(i,j)=lm
          ptop(i,j)=pbot(i,j)
          return
        endif

!
        thvref(l)=trefk(l)*rxnrk(l)*(qrfkl*0.608+1.)
        qrefk(l)=qrfkl
      enddo
!
!------------------ eliminate clouds with bottoms too dry --------------
!!
!      qnew=(qrefk(lbot(i,j))-qk(lbot(i,j)))*tauksc+qk(lbot(i,j))
!!
!      if(qnew<qk(lbot(i,j)+1)*stresh)then  !!?? stresh too large!!
!        lbot(i,j)=0
!        ltop=lm
!        ptop(i,j)=pbot(i,j)
!        return
!      endif
!!
!-------------- eliminate impossible slopes (betts,dtheta/dq)------------
!
      do l=ltop(i,j),lbot(i,j)
        dtdp=(thvref(l-1)-thvref(l))/(pk(l)-pk(l-1))
!
        if(dtdp<epsdt)then
          lbot(i,j)=0
          ltop(i,j)=lm
          ptop(i,j)=pbot(i,j)
          return
        endif
!
      enddo
!-----------------------------------------------------------------------
              go to 820 ! relaxation
!-----------------------------------------------------------------------
!***  new cloud starts here
!-----------------------------------------------------------------------
 810  do l=1,lm
        wcld(l)=0.
        rhk(l)=qk(l)/qsatk(l)
        thvmk(l)=tk(l)*rxnrk(l) !zj *(qk(l)*00.608+1.)
!----calculate updraft temperature along moist adiabat tref(l)----------
          call ttblex(itb,jtb,pl,pk(l),rdp,rdthe &
                     ,sthe,the0,thes(i,j,l),ttbl,trefk(l))
!-----------------------------------------------------------------------
        thmak(l)=tref(i,j,l)*rxnrk(l)
      enddo
!-------------mean rh and slopes within cloud---------------------------
      sumdp=0.
      sumrh=0.
      a11=0.
      a12=0.
      b1qsat=0.
      b2qsat=0.
      b1thvm=0.
      b1thma=0.
      b2thvm=0.
      b2thma=0.
      b1rh  =0.
      b2rh  =0.
!
      do l=ltop(i,j),lbot(i,j)
        sumdp=dpk(l)+sumdp
        sumrh=rhk(l)*dpk(l)+sumrh
        a11=pk(l)**2*dpk(l)+a11
        a12=pk(l)*dpk(l)+a12
        b1qsat=qsatk(l)*pk(l)*dpk(l)+b1qsat
        b1thvm=thvmk(l)*pk(l)*dpk(l)+b1thvm
        b1thma=thmak(l)*pk(l)*dpk(l)+b1thma
        b1rh  =rhk  (l)*pk(l)*dpk(l)+b1rh
        b2qsat=qsatk(l)*dpk(l)+b2qsat
        b2thvm=thvmk(l)*dpk(l)+b2thvm
        b2thma=thmak(l)*dpk(l)+b2thma
        b2rh  =rhk  (l)*dpk(l)+b2rh
      enddo
!
      rhmean=sumrh/sumdp
!-------------no shallow convection if the cloud is saturated-----------
      if(rhmean.gt.0.95) then
        lbot(i,j)=0
        ltop(i,j)=lm
        ptop(i,j)=pbot(i,j)
        return
      endif
!-----------------------------------------------------------------------
      a21=a12
      a22=sumdp
!
      rden=1./(a11*a22-a12*a21)
!
      aqs=(b1qsat*a22-a12*b2qsat)*rden
      avm=(b1thvm*a22-a12*b2thvm)*rden
      ama=(b1thma*a22-a12*b2thma)*rden
      arh=(b1rh  *a22-a12*b2rh  )*rden
!
      bqs=(a11*b2qsat-b1qsat*a21)*rden
      bvm=(a11*b2thvm-b1thvm*a21)*rden
      bma=(a11*b2thma-b1thma*a21)*rden
      brh=(a11*b2rh  -b1rh  *a21)*rden
!-------------no shallow convection if the cloud moister on top---------
      if(arh.lt.0.) then !soft2
        lbot(i,j)=0           !soft2
        ltop(i,j)=lm          !soft2
        ptop(i,j)=pbot(i,j)        !soft2
        return        !soft2
      endif              !soft2
!-------------first guess t & q profiles--------------------------------
      adef=(1.-deftop)*2./(pk(lbot(i,j))-pk(ltop(i,j))) !soft2
!
      do l=ltop(i,j),lbot(i,j)
        fk=(pk(l)-pk(ltop(i,j)))*adef+deftop !soft2
        rhref=rhmean*fk                 !soft2
!
        wcld(l)=(1.-wdry)*rhref/(1.-wdry*rhref)
        trefk(l)=((1.-wcld(l))*(avm*pk(l)+bvm) &
                 +    wcld(l) *(ama*pk(l)+bma))/rxnrk(l)
        qrefk(l)=rhref*(aqs*pk(l)+bqs)
      enddo
!-------------enthalpy conservation-------------------------------------
      sumdp=0.
      sumdt=0.
      sumdq=0.
!
      do l=ltop(i,j),lbot(i,j)
        sumdp=dpk(l)+sumdp
        sumdt=(tk(l)-trefk(l))*dpk(l)+sumdt
        sumdq=(qk(l)-qrefk(l))*dpk(l)+sumdq
      enddo
!
      rdpsum=1./sumdp
!
      tcorr=sumdt*rdpsum
      qcorr=sumdq*rdpsum
!
      do l=ltop(i,j),lbot(i,j)
        trefk(l)=trefk(l)+tcorr
        qrefk(l)=qrefk(l)+qcorr
      enddo
!-----------------------------------------------------------------------
      dsq=0.
      dst=0.
!
      do l=ltop(i,j),lbot(i,j)
        tkl=tk(l)
        diftl=(trefk(l)-tkl  )*tauksc
        difql=(qrefk(l)-qk(l))*tauksc
        dpot=dpk(l)/(tkl+tkl+diftl)
        dst=diftl      *dpot+dst
        dsq=difql*el(l)*dpot+dsq
      enddo
!
      dst=(dst+dst)*cp
      dsq=dsq+dsq
      dentp3=dst+dsq
!
      if(dentp3.lt.0.) then
        lbot(i,j)=0
        ltop(i,j)=lm
        ptop(i,j)=pbot(i,j)
        return
      endif
!--------------relaxation towards reference profiles--------------------
 820  do l=ltop(i,j),lbot(i,j)
        tmod(i,j,l)=(trefk(l)-tk(l))*tauksc
        qmod(i,j,l)=(qrefk(l)-qk(l))*tauksc
      enddo
!-----------------------------------------------------------------------
!scscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscs
!scscscscscsc         end of shallow convection        scscscscscscscscs
!scscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscscs
 800  continue
        enddo
!!if(i.eq.289.and.j.eq.346) print*,9
!-------------update the fundamental prognostic arrays------------------
      do l=1,lm
        do j=2,jm-1
          do i=2,im-1
            t(i,j,l)=t(i,j,l)+tmod(i,j,l)
            q(i,j,l)=q(i,j,l)+qmod(i,j,l)
          enddo
        enddo
      enddo
!-----------------------------------------------------------------------
                        endsubroutine cucnvc
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
                           subroutine ttblex &
      (itbx,jtbx,plx,prsmid,rdpx,rdthex,sthe &
      ,the0,thesp,ttbl,tref)
!-----------------------------------------------------------------------
!     ******************************************************************
!     *                                                                *
!     *           extract temperature of the moist adiabat from        *
!     *                      the appropriate ttbl                      *
!     *                                                                *
!     ******************************************************************
!-----------------------------------------------------------------------
      implicit none

      include 'kind.inc'
!-----------------------------------------------------------------------
      integer(kind=kint),intent(in):: &
       itbx,jtbx
!
      real(kind=kfpt),intent(in):: &
       plx,prsmid,rdpx,rdthex,thesp
!
      real(kind=kfpt),dimension(itbx),intent(in):: &
       sthe,the0
!
      real(kind=kfpt),dimension(jtbx,itbx),intent(in):: &
       ttbl
!
      real(kind=kfpt),intent(out):: &
       tref
!-----------------------------------------------------------------------
      integer(kind=kint):: &
       iptb,ithtb
!
      real(kind=kfpt):: &
       bthe00k,bthe10k,bthk,pk,pp,qq,sthe00k,sthe10k,sthk &
      ,t00k,t01k,t10k,t11k,tpk,tthk
!-----------------------------------------------------------------------
!----------------scaling pressure & tt table index----------------------
!-----------------------------------------------------------------------
      pk=prsmid
      tpk=(pk-plx)*rdpx
      qq=tpk-aint(tpk)
      iptb=int(tpk)+1
!----------------keeping indices within the table-----------------------
      if(iptb<1)then
        iptb=1
        qq=0.
      endif
!
      if(iptb>=itbx)then
        iptb=itbx-1
        qq=0.
      endif
!----------------base and scaling factor for thetae---------------------
      bthe00k=the0(iptb)
      sthe00k=sthe(iptb)
      bthe10k=the0(iptb+1)
      sthe10k=sthe(iptb+1)
!----------------scaling the & tt table index---------------------------
      bthk=(bthe10k-bthe00k)*qq+bthe00k
      sthk=(sthe10k-sthe00k)*qq+sthe00k
      tthk=(thesp-bthk)/sthk*rdthex
      pp=tthk-aint(tthk)
      ithtb=int(tthk)+1
!----------------keeping indices within the table-----------------------
      if(ithtb<1)then
        ithtb=1
        pp=0.
      endif
!
      if(ithtb>=jtbx)then
        ithtb=jtbx-1
        pp=0.
      endif
!----------------temperature at four surrounding tt table pts.----------
      t00k=ttbl(ithtb,iptb)
      t10k=ttbl(ithtb+1,iptb)
      t01k=ttbl(ithtb,iptb+1)
      t11k=ttbl(ithtb+1,iptb+1)
!-----------------------------------------------------------------------
!----------------parcel temperature-------------------------------------
!-----------------------------------------------------------------------
      tref=(t00k+(t10k-t00k)*pp+(t01k-t00k)*qq                           &
      &    +(t00k-t10k-t01k+t11k)*pp*qq)
!-----------------------------------------------------------------------
      endsubroutine ttblex
!-----------------------------------------------------------------------
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!-----------------------------------------------------------------------
      subroutine rain &
      (global &
      ,im,jm,kmsc,lm &
      ,cp,g,r &
      ,psgml1,pdsg1,sgml2,dsg2 &
      ,pd &
      ,acprec,prec,prra,prsn &
      ,tg &
      ,q,t)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                            
      parameter &
      (f1=610.78,f2=17.2693882,f3=273.15,f4=35.86,pq0=379.90516 &
      ,tresh=.90,pq0c=pq0*tresh &
      ,elwv=2.50e6,eliv=2.834e6,dldt=2274.,row=1.e3 &
      ,revap=1./200. &
      ,epsq=1.e-20)
!-----------------------------------------------------------------------
      logical global
!
      dimension &
       psgml1(lm),pdsg1(lm),sgml2(lm),dsg2(lm)
      dimension &
       pd(im,jm)
      dimension &
       aprec(im,jm)
      dimension &
       acprec(im,jm),prec(im,jm),prra(im,jm),prsn(im,jm)
      dimension &
       tg(im,jm,kmsc)
      dimension &
       q(im,jm,lm),t(im,jm,lm)
!--------------preparatory calculations---------------------------------
      arcp=f2*(f3-f4)/cp
      rrog=1./(row*g)
      rog=r/g
!-----------------------------------------------------------------------
      do j=2,jm-1
        do i=2,im-1
          aprec(i,j)=0.0
        enddo
      enddo
      do l=1,lm
        do j=2,jm-1
          do i=2,im-1
            pdp=pd(i,j)
!-----------------------------------------------------------------------
            q(i,j,l)=max(q(i,j,l),epsq)
!
            tl=t(i,j,l)
            ql=q(i,j,l)
            if(tl.gt.f3) then
              elv=elwv
            else
              elv=eliv
            endif 
            elv=elv-dldt*(tl-f3)
            dpl=dsg2(l)*pdp+pdsg1(l)
            rpl=1./(sgml2(l)*pdp+psgml1(l))
            qc=pq0c*rpl*exp(f2*(tl-f3)/(tl-f4))
            precl=(ql-qc)*dpl/(elv*qc*arcp/((tl-f4)*(tl-f4))+1.0)
            if(precl.lt.0.) then
              precl=min(tl*dpl*rpl*rog*revap,1.)*precl
              if(aprec(i,j)+precl.lt.0.0) then
                precl=-aprec(i,j)
              endif
            endif
!
            aprec(i,j)=precl+aprec(i,j)
            precl     =precl/dpl
!
            t(i,j,l)=precl*elv/cp+t(i,j,l)
            q(i,j,l)=q(i,j,l)-precl
!-----------------------------------------------------------------------
          enddo
        enddo
      enddo
!-----------------------------------------------------------------------
      do j=2,jm-1
        do i=2,im-1
          precp=aprec(i,j)*rrog
          if(     t(i,j,lm  ).ge.273.15 &
             .and.t(i,j,lm-1).ge.273.15 &
             .and.t(i,j,lm-2).ge.273.15 &
             .and.t(i,j,lm-3).ge.273.15 &
             .and.t(i,j,lm-4).ge.273.15 &
             .and.t(i,j,lm-5).ge.273.15 &
             .and.tg(i,j,1)  .ge.273.15) then                                                                                                                                                                                
            prra(i,j)=precp
          else
            prsn(i,j)=precp+prsn(i,j)
          endif
          prec(i,j)=precp+prec(i,j)
          acprec(i,j)=precp+acprec(i,j)
!-----------------------------------------------------------------------
        enddo
      enddo
!-----------------------------------------------------------------------
      endsubroutine rain
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine cltend &
      (icltend,nphs &
      ,t)
!-----------------------------------------------------------------------
      include 'modelgrid.inc'
!----------------------------------------------------------------------- 
      real t(im,jm,lm)
      real,save :: t_adj (im,jm,lm),t_old (im,jm,lm)
!-----------------------------------------------------------------------
                      if (icltend .lt. 0) then
                  do j=2,jm-1
              do i=2,im-1
          do l=1,lm
      t_old(i,j,l)=t(i,j,l)
          enddo
              enddo
                  enddo
                      else if (icltend .eq. 0) then
                  do j=2,jm-1
              do i=2,im-1
          do l=1,lm
      t_adj(i,j,l)=t(i,j,l)-t_old(i,j,l)
      t(i,j,l)=t_old(i,j,l)
          enddo
              enddo
                  enddo
                      else
      deltph=1./float(nphs)
                  do j=2,jm-1
              do i=2,im-1
          do l=1,lm
      t(i,j,l)=deltph*t_adj(i,j,l)+t(i,j,l)
          enddo
              enddo
                  enddo
                      endif
!-----------------------------------------------------------------------
      endsubroutine cltend
!
!#######################################################################
!------- initialize constants & lookup tables for microphysics ---------
!#######################################################################
!
      subroutine gsmconst &
      (dtph,dyh)
!
!-------------------------------------------------------------------------------
!---  subprogram documentation block
!   prgrmmr: ferrier         org: w/np22     date: february 2001
!-------------------------------------------------------------------------------
! abstract:
!   * reads various microphysical lookup tables used in column_micro
!   * lookup tables were created "offline" and are read in during execution
!   * creates lookup tables for saturation vapor pressure w/r/t water & ice
!-------------------------------------------------------------------------------
!
! usage: call gsmconst from subroutine gsmdrive at model start time
!
!   input argument list:
!       dtph - physics time step (s)
!
!   output argument list:
!     none
!
!   output files:
!     none
!
!   subroutines:
!     my_growth_rates - lookup table for growth of nucleated ice
!
!   unique: none
!
!   library: none
!
!   common blocks:
!     cmicro_cons - constants used in gsmcolumn
!     cmy600       - lookup table for growth of ice crystals in
!                    water saturated conditions (miller & young, 1979)
!     ivent_tables - lookup tables for ventilation effects of ice
!     iaccr_tables - lookup tables for accretion rates of ice
!     imass_tables - lookup tables for mass content of ice
!     irate_tables - lookup tables for precipitation rates of ice
!     irime_tables - lookup tables for increase in fall speed of rimed ice
!     mapot        - need lat/lon grid resolution
!     rvent_tables - lookup tables for ventilation effects of rain
!     raccr_tables - lookup tables for accretion rates of rain
!     rmass_tables - lookup tables for mass content of rain
!     rvelr_tables - lookup tables for fall speeds of rain
!     rrate_tables - lookup tables for precipitation rates of rain
!
! attributes:
!   language: fortran 90
!   machine : ibm sp
!
!-----------------------------------------------------------------------
!
!--- include common blocks
!-----------------------------------------------------------------------
      include "modelgrid.inc"
!-------------- parameters & arrays for lookup tables --------------------
!-------------------------------------------------------------------------
!
!--- common block of constants used in column microphysics
!
      common /cmicro_cons/ abfr, cbfr, ciacw, ciacr, c_n0r0, &
     & cn0r0, cn0r_dmrmin, cn0r_dmrmax, cracw, craut, esw0, &
     & qaut0, rfmax, rhgrd, rqr_dr1, rqr_dr2, rqr_dr3, rqr_drmin, &
     & rqr_drmax, rr_drmin, rr_dr1, rr_dr2, rr_dr3, rr_drmax
!
!--- pass rhgrd into radiation  (2/4/03)
!
     common /crhgrid/ rhgrid
!
!--- common block for lookup table used in calculating growth rates of
!    nucleated ice crystals growing in water saturated conditions
!
      integer, parameter :: my_t1=1, my_t2=35
      common /cmy600/ my_growth(my_t1:my_t2)
      real my_growth
!
!--- mean ice particle diameters vary from 50 microns to 1000 microns
!
      real, parameter :: dmimin=.05e-3, dmimax=1.e-3, deldmi=1.e-6, &
     &  xmimin=1.e6*dmimin, xmimax=1.e6*dmimax
      integer, parameter :: mdimin=xmimin, mdimax=xmimax
!
!--- various ice lookup tables
!
      common /iaccr_tables/ accri(mdimin:mdimax)
      common /imass_tables/ massi(mdimin:mdimax)
      common /sdens_tables/ sdens(mdimin:mdimax)
      real massi
      common /irate_tables/ vsnowi(mdimin:mdimax)
      common /ivent_tables/ venti1(mdimin:mdimax), venti2(mdimin:mdimax)
!
!--- common block for riming tables
!
      integer, parameter :: nrime=40
      common /irime_tables/ vel_rf(2:9,0:nrime)
!
!--- mean rain drop diameters vary from 50 microns to 450 microns
!
      real, parameter :: dmrmin=.05e-3, dmrmax=.45e-3, deldmr=1.e-6, &
     & xmrmin=1.e6*dmrmin, xmrmax=1.e6*dmrmax
      integer, parameter :: mdrmin=xmrmin, mdrmax=xmrmax
!
!--- various rain lookup tables
!
      common /raccr_tables/ accrr(mdrmin:mdrmax)
      common /rmass_tables/ massr(mdrmin:mdrmax)
      real massr
      common /rrate_tables/ rrate(mdrmin:mdrmax)
      common /rvelr_tables/ vrain(mdrmin:mdrmax)
      common /rvent_tables/ ventr1(mdrmin:mdrmax), ventr2(mdrmin:mdrmax)
!
!--- parameters & data statement for local calculations
!
      real, parameter :: c1=1./3., dmr1=.1e-3, dmr2=.2e-3, dmr3=.32e-3, &
     & n0r0=8.e6, n0s0=4.e6, rhol=1000., rhos=100., t0c=273.15, &
     & xmr1=1.e6*dmr1, xmr2=1.e6*dmr2, xmr3=1.e6*dmr3
      integer, parameter :: mdr1=xmr1, mdr2=xmr2, mdr3=xmr3
!
!------------------------------------------------------------------------
!--------- constants passed through /cmicro_cons/ common block ----------
!------------------------------------------------------------------------
!
!--- dphd, dlmd are delta latitude and longitude at the model (not geodetic) equator
!    => "dx" is the hypotenuse of the model zonal & meridional grid increments.
!
      dx=dyh/1000. !111.*((dphd**2+dlmd**2)*0.5)**.5         ! resolution at model equator (km)
      dx=min(100., max(5., dx) )
!
!--- assume the following functional relationship for key constants that
!    depend on grid resolution from dxmin (5 km) to dxmax (100 km) resolution:
!
      dxmin=5.
!zj      dxmax=100.
      dxmax=120.
      dx=min(dxmax-.1, max(dxmin+.1, dx) )
!
!--- extune determines the degree to which the coefficients change with resolution.
!    the larger extune is, the more sensitive the parameter.
!
!      extune=1.
      extune=.5    !-- matches what's in operations (4/13/02)
!
!--- fxtune ==> f(dx) is the grid-resolution tuning parameter (from 0 to 1)
!
      fxtune=((dxmax-dx)/(dxmax-dxmin))**extune
      fxtune=max(0., min(1., fxtune))
!
!--- calculate grid-averaged rh for the onset of condensation (rhgrd) based on
!    simple ***assumed*** (user-specified) values at dxmax and at dxmin.
!
!      rh_dxmax=.90              !-- 90% rh at dxmax=100 km
      rh_dxmax=.90              !-- 90% rh at dxmax=100 km
      rh_dxmin=.95              !-- 98% rh at dxmin=5 km
!
!--- note that rhgrd is right now fixed throughout the domain!!
!
!      rhgrd=rh_dxmax+(rh_dxmin-rh_dxmax)*fxtune

      rhgrd=0.95
      rhgrid=rhgrd
!
!--- read in various lookup tables
!      open (unit=1,file='/nwprod/fix/nam_micro_lookup.dat' &
!           ,form='unformatted')
!      read(1) ventr1
!      read(1) ventr2
!      read(1) accrr
!      read(1) massr
!      read(1) vrain
!      read(1) rrate
!      read(1) venti1
!      read(1) venti2
!      read(1) accri
!      read(1) massi
!      read(1) vsnowi
!      read(1) vel_rf
!!      read(1) my_growth    ! applicable only for dtph=180 s
!
 1000 format(100e14.8)
      open (unit=1,file="../input/prmdata/lookup",form="formatted")
      read(1,1000) ventr1
      read(1,1000) ventr2
      read(1,1000) accrr
      read(1,1000) massr
      read(1,1000) vrain
      read(1,1000) rrate
      read(1,1000) venti1
      read(1,1000) venti2
      read(1,1000) accri
      read(1,1000) massi
      read(1,1000) vsnowi
      read(1,1000) velrf
!      read(1,1000) my_growth    ! applicable only for dtph=180 s

      close (1)
!
!--- calculates coefficients for growth rates of ice nucleated in water
!    saturated conditions, scaled by physics time step (lookup table)
!
      call my_growth_rates (dtph)
!
      pi=acos(-1.)
!
!--- constants associated with biggs (1953) freezing of rain, as parameterized
!    following lin et al. (jcam, 1983) & reisner et al. (1998, qjrms).
!
      abfr=-0.66
      bbfr=100.
      cbfr=20.*pi*pi*bbfr*rhol*1.e-21
!
!--- ciacw is used in calculating riming rates
!      the assumed effective collection efficiency of cloud water rimed onto
!      ice is =0.5 below:
!
      ciacw=dtph*0.25*pi*0.5*(1.e5)**c1
!
!--- ciacr is used in calculating freezing of rain colliding with large ice
!      the assumed collection efficiency is 1.0
!
      ciacr=pi*dtph
!
!--- based on rain lookup tables for mean diameters from 0.05 to 0.45 mm
!    * four different functional relationships of mean drop diameter as
!      a function of rain rate (rr), derived based on simple fits to
!      mass-weighted fall speeds of rain as functions of mean diameter
!      from the lookup tables.
!
      rr_drmin=n0r0*rrate(mdrmin)     ! rr for mean drop diameter of .05 mm
      rr_dr1=n0r0*rrate(mdr1)         ! rr for mean drop diameter of .10 mm
      rr_dr2=n0r0*rrate(mdr2)         ! rr for mean drop diameter of .20 mm
      rr_dr3=n0r0*rrate(mdr3)         ! rr for mean drop diameter of .32 mm
      rr_drmax=n0r0*rrate(mdrmax)     ! rr for mean drop diameter of .45 mm
!
      rqr_drmin=n0r0*massr(mdrmin)    ! rain content for mean drop diameter of .05 mm
      rqr_dr1=n0r0*massr(mdr1)        ! rain content for mean drop diameter of .10 mm
      rqr_dr2=n0r0*massr(mdr2)        ! rain content for mean drop diameter of .20 mm
      rqr_dr3=n0r0*massr(mdr3)        ! rain content for mean drop diameter of .32 mm
      rqr_drmax=n0r0*massr(mdrmax)    ! rain content for mean drop diameter of .45 mm
      c_n0r0=pi*rhol*n0r0
      cn0r0=1.e6/c_n0r0**.25
      cn0r_dmrmin=1./(pi*rhol*dmrmin**4)
      cn0r_dmrmax=1./(pi*rhol*dmrmax**4)
!
!--- cracw is used in calculating collection of cloud water by rain (an
!      assumed collection efficiency of 1.0)
!
      cracw=dtph*0.25*pi*1.0
!
      esw0=1000.*fpvs0(t0c)     ! saturation vapor pressure at 0c
      rfmax=1.1**nrime          ! maximum rime factor allowed
!
!------------------------------------------------------------------------
!--------------- constants passed through argument list -----------------
!------------------------------------------------------------------------
!
!--- important parameters for self collection (autoconversion) of
!    cloud water to rain.
!
!--- craut is proportional to the rate that cloud water is converted by
!      self collection to rain (autoconversion rate)
!
      craut=1.-exp(-1.e-3*dtph)
!
!--- qaut0 is the threshold cloud content for autoconversion to rain
!      needed for droplets to reach a diameter of 20 microns (following
!      manton and cotton, 1977; banta and hanson, 1987, jcam).  it is
!      **strongly** affected by the assumed droplet number concentrations
!     xncw!  for example, qaut0=1.2567, 0.8378, or 0.4189 g/m**3 for
!     droplet number concentrations of 300, 200, and 100 cm**-3, respectively.
!
!--- calculate grid-averaged xncw based on simple ***assumed*** (user-specified)
!    values at dxmax and at dxmin.
!
      xncw_dxmax=50.e6          !--  50 /cm**3 at dxmax=100 km
      xncw_dxmin=200.e6         !-- 200 /cm**3 at dxmin=5 km
!
!--- note that xncw is right now fixed throughout the domain!!
!
!--- change on 4/11/02 => remove resolution dependence on cloud-water
!    autoconversion to rain, similar to what's running in operations.
!
!      xncw=xncw_dxmax+(xncw_dxmin-xncw_dxmax)*fxtune
      xncw=xncw_dxmax
!
      qaut0=pi*rhol*xncw*(20.e-6)**3/6.
!
      write(6,"(a, a,f6.2,a, a,f5.4, a,f7.3,a, a,f6.2,a, a,f5.3,a)") &
     &   'key microphysical parameters for ' &
     &  ,'dx=',dx,' km:' &
     &  ,'   fxtune=',fxtune &
     &  ,'   rhgrd=',100.*rhgrd,' %' &
     &  ,'   ncw=',1.e-6*xncw,' /cm**3' &
     &  ,'   qaut0=',1.e3*qaut0,' g/kg'
!
!--- for calculating snow optical depths by considering bulk density of
!      snow based on emails from q. fu (6/27-28/01), where optical
!      depth (t) = 1.5*swp/(reff*dens), swp is snow water path, reff
!      is effective radius, and dens is the bulk density of snow.
!
!    swp (kg/m**2)=(1.e-3 kg/g)*swprad, swprad in g/m**2 used in radiation
!    t = 1.5*1.e3*swprad/(reff*dens)
!
!    see derivation for massi(indexs), note equal to rho*qsnow/nsnow
!
!    sdens=1.5e3/dens, dens=massi(indexs)/[pi*(1.e-6*indexs)**3]
!
      do i=mdimin,mdimax
        sdens(i)=pi*1.5e-15*float(i*i*i)/massi(i)
      enddo
!
!-----------------------------------------------------------------------
!
      endsubroutine gsmconst
!
!#######################################################################
!--- sets up lookup table for calculating initial ice crystal growth ---
!#######################################################################
!
      subroutine my_growth_rates (dtph)
!
!--- below are tabulated values for the predicted mass of ice crystals
!    after 600 s of growth in water saturated conditions, based on
!    calculations from miller and young (jas, 1979).  these values are
!    crudely estimated from tabulated curves at 600 s from fig. 6.9 of
!    young (1993).  values at temperatures colder than -27c were
!    assumed to be invariant with temperature.
!
!--- used to normalize miller & young (1979) calculations of ice growth
!    over large time steps using their tabulated values at 600 s.
!    assumes 3d growth with time**1.5 following eq. (6.3) in young (1993).
!
      integer, parameter :: my_t1=1, my_t2=35
      common /cmy600/ my_growth(my_t1:my_t2)
      real my_growth, my_600(my_t1:my_t2)
!
      data my_600 / &
     & 5.5e-8, 1.4e-7, 2.8e-7, 6.e-7, 3.3e-6, &     !  -1 to  -5 deg c
     & 2.e-6, 9.e-7, 8.8e-7, 8.2e-7, 9.4e-7, &      !  -6 to -10 deg c
     & 1.2e-6, 1.85e-6, 5.5e-6, 1.5e-5, 1.7e-5, &   ! -11 to -15 deg c
     & 1.5e-5, 1.e-5, 3.4e-6, 1.85e-6, 1.35e-6, &   ! -16 to -20 deg c
     & 1.05e-6, 1.e-6, 9.5e-7, 9.0e-7, 9.5e-7, &    ! -21 to -25 deg c
     & 9.5e-7, 9.e-7, 9.e-7, 9.e-7, 9.e-7, &        ! -26 to -30 deg c
     & 9.e-7, 9.e-7, 9.e-7, 9.e-7, 9.e-7 /          ! -31 to -35 deg c
!
!-----------------------------------------------------------------------
!
      dt_ice=(dtph/600.)**1.5
      my_growth=dt_ice*my_600
!
!-----------------------------------------------------------------------
!
      endsubroutine my_growth_rates
!
!#######################################################################
!-- lookup tables for the saturation vapor pressure w/r/t water & ice --
!#######################################################################
!
      subroutine gpvs
!     ******************************************************************
!$$$  subprogram documentation block
!                .      .    .
! subprogram:    gpvs        compute saturation vapor pressure table
!   author: n phillips       w/np2      date: 30 dec 82
!
! abstract: compute saturation vapor pressure table as a function of
!   temperature for the table lookup function fpvs.
!   exact saturation vapor pressures are calculated in subprogram fpvsx.
!   the current implementation computes a table with a length
!   of 7501 for temperatures ranging from 180.0 to 330.0 kelvin.
!
! program history log:
!   91-05-07  iredell
!   94-12-30  iredell             expand table
!   96-02-19  hong                ice effect
!
! usage:  call gpvs
!
! subprograms called:
!   (fpvsx)  - inlinable function to compute saturation vapor pressure
!
! common blocks:
!   compvs   - scaling parameters and table for function fpvs.
!
! attributes:
!   language: fortran 90
!   machine:  ibm sp
!
!$$$
!----------------------------------------------------------------------
      parameter(nx=7501)
      real tbpvs(nx),tbpvs0(nx)
      common/compvs0/ c1xpvs0,c2xpvs0,tbpvs0
      common/compvs/ c1xpvs,c2xpvs,tbpvs
!----------------------------------------------------------------------
      xmin=180.0
      xmax=330.0
      xinc=(xmax-xmin)/(nx-1)
      c1xpvs=1.-xmin/xinc
      c2xpvs=1./xinc
      c1xpvs0=1.-xmin/xinc
      c2xpvs0=1./xinc
!
      do jx=1,nx
        x=xmin+(jx-1)*xinc
        t=x
        tbpvs(jx)=fpvsx(t)
        tbpvs0(jx)=fpvsx0(t)
      enddo
!
      endsubroutine gpvs
!-----------------------------------------------------------------------
!***********************************************************************
!-----------------------------------------------------------------------
                           function fpvs(t)
!-----------------------------------------------------------------------
!$$$  subprogram documentation block
!                .      .    .
! subprogram:    fpvs        compute saturation vapor pressure
!   author: n phillips            w/np2      date: 30 dec 82
!
! abstract: compute saturation vapor pressure from the temperature.
!   a linear interpolation is done between values in a lookup table
!   computed in gpvs. see documentation for fpvsx for details.
!   input values outside table range are reset to table extrema.
!   the interpolation accuracy is almost 6 decimal places.
!   on the cray, fpvs is about 4 times faster than exact calculation.
!   this function should be expanded inline in the calling routine.
!
! program history log:
!   91-05-07  iredell             made into inlinable function
!   94-12-30  iredell             expand table
!   96-02-19  hong                ice effect
!
! usage:   pvs=fpvs(t)
!
!   input argument list:
!     t        - real temperature in kelvin
!
!   output argument list:
!     fpvs     - real saturation vapor pressure in kilopascals (cb)
!
! common blocks:
!   compvs   - scaling parameters and table computed in gpvs.
!
! attributes:
!   language: fortran 90
!   machine:  ibm sp
!
!$$$
!-----------------------------------------------------------------------
      parameter(nx=7501)
      real tbpvs(nx)
      common/compvs/ c1xpvs,c2xpvs,tbpvs
!-----------------------------------------------------------------------
      xj=min(max(c1xpvs+c2xpvs*t,1.),float(nx))
      jx=min(xj,nx-1.)
      fpvs=tbpvs(jx)+(xj-jx)*(tbpvs(jx+1)-tbpvs(jx))
!
      endfunction fpvs
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
                         function fpvs0(t)
!-----------------------------------------------------------------------
      parameter(nx=7501)
      real tbpvs0(nx)
      common/compvs0/ c1xpvs0,c2xpvs0,tbpvs0
!-----------------------------------------------------------------------
      xj1=min(max(c1xpvs0+c2xpvs0*t,1.),float(nx))
      jx1=min(xj1,nx-1.)
      fpvs0=tbpvs0(jx1)+(xj1-jx1)*(tbpvs0(jx1+1)-tbpvs0(jx1))
!
      endfunction fpvs0
!-----------------------------------------------------------------------
!***********************************************************************
!-----------------------------------------------------------------------
                         function fpvsx(t)
!-----------------------------------------------------------------------
!$$$  subprogram documentation block
!                .      .    .
! subprogram:    fpvsx       compute saturation vapor pressure
!   author: n phillips            w/np2      date: 30 dec 82
!
! abstract: exactly compute saturation vapor pressure from temperature.
!   the water model assumes a perfect gas, constant specific heats
!   for gas and liquid, and neglects the volume of the liquid.
!   the model does account for the variation of the latent heat
!   of condensation with temperature.  the ice option is not included.
!   the clausius-clapeyron equation is integrated from the triple point
!   to get the formula
!       pvs=psatk*(tr**xa)*exp(xb*(1.-tr))
!   where tr is ttp/t and other values are physical constants
!   this function should be expanded inline in the calling routine.
!
! program history log:
!   91-05-07  iredell             made into inlinable function
!   94-12-30  iredell             exact computation
!   96-02-19  hong                ice effect
!
! usage:   pvs=fpvsx(t)
! reference:   emanuel(1994),116-117
!
!   input argument list:
!     t        - real temperature in kelvin
!
!   output argument list:
!     fpvsx    - real saturation vapor pressure in kilopascals (cb)
!
! attributes:
!   language: fortran 90
!   machine:  ibm sp
!
!$$$
!-----------------------------------------------------------------------
      parameter(cp=1.0046e+3,rd=287.04,rv=4.6150e+2 &
      ,         ttp=2.7316e+2,hvap=2.5000e+6,psat=6.1078e+2 &
      ,         cliq=4.1855e+3,cvap= 1.8460e+3 &
      ,         cice=2.1060e+3,hsub=2.8340e+6)
      parameter(psatk=psat*1.e-3)
      parameter(dldt=cvap-cliq,xa=-dldt/rv,xb=xa+hvap/(rv*ttp))
      parameter(dldti=cvap-cice,xai=-dldti/rv,xbi=xai+hsub/(rv*ttp))
!-----------------------------------------------------------------------
      tr=ttp/t
!
      if(t.ge.ttp)then
        fpvsx=psatk*(tr**xa)*exp(xb*(1.-tr))
      else
        fpvsx=psatk*(tr**xai)*exp(xbi*(1.-tr))
      endif
!
      endfunction fpvsx
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
                        function fpvsx0(t)
!-----------------------------------------------------------------------
      parameter(cp=1.0046e+3,rd=287.04,rv=4.6150e+2 &
      ,         ttp=2.7316e+2,hvap=2.5000e+6,psat=6.1078e+2 &
      ,         cliq=4.1855e+3,cvap=1.8460e+3 &
      ,         cice=2.1060e+3,hsub=2.8340e+6)
      parameter(psatk=psat*1.e-3)
      parameter(dldt=cvap-cliq,xa=-dldt/rv,xb=xa+hvap/(rv*ttp))
      parameter(dldti=cvap-cice,xai=-dldt/rv,xbi=xa+hsub/(rv*ttp))
!-----------------------------------------------------------------------
      tr=ttp/t
      fpvsx0=psatk*(tr**xa)*exp(xb*(1.-tr))
!
      endfunction fpvsx0

!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                            
!###############################################################################
!---------------------- driver of the new microphysics -------------------------
!###############################################################################
!
      subroutine gsmdrive &
      (global &
      ,ntsd &
      ,dt,dtq2,dyh &
      ,dsg2,pdsg1 &
      ,acprec,pd,prec,prra,prsn &
      ,t &
      ,cw,q &
      ,pint)
!-------------------------------------------------------------------------------
!----- note:  code is currently set up w/o threading!
!-------------------------------------------------------------------------------
!$$$  subprogram documentation block
!                .      .    .
! subprogram:  grid-scale microphysical processes - condensation & precipitation
!   prgrmmr: ferrier         org: w/np22     date: february 2001
!  2001-04-xx   ferrier     - beta-tested version
!  2001-05-21   ferrier     - added gradual latent heating to remove external waves
!  2001-05-30   ferrier     - changed default to uniform maritime conditions for testing
!  2002-06-14   ferrier     - most of the changes result in more accurate rhs
!  2003-03-xx   janjic      - modified for nonhydrostatic hybrid model
!-------------------------------------------------------------------------------
! abstract:
!   * merges original gscond & precpd subroutines.
!   * code has been substantially streamlined and restructured.
!   * exchange between water vapor & small cloud condensate is calculated using
!     the original asai (1965, j. japan) algorithm.  see also references to
!     yau and austin (1979, jas), rutledge and hobbs (1983, jas), and tao et al.
!     (1989, mwr).  this algorithm replaces the sundqvist et al. (1989, mwr)
!     parameterization.
!-------------------------------------------------------------------------------
! prior program history log:
!
! *** heritage as subroutine gscond:
!   94-~??  zhao         - originator
!   95-03-25  black      - conversion from 1-d to 2-d in horizontal
!   95-03-28  black      - added external edge
!   98-11-02  black      - modified for distributed memory
!
! *** heritage as subroutine precpd:
!   94-~??  zhao       - originator
!   95-03-25  black      - conversion from 1-d to 2-d in horizontal
!   95-11-20  abeles     - parallel optimization
!   96-03-29  black      - removed scrch common
!   96-07-18  zhao       - new wmin calculation
!   96-09-25  baldwin    - new sr calculation
!   98-11-02  black      - modification for distributed memory
!-------------------------------------------------------------------------------
!
! usage: call gsmdrive from main program ebu
!
!   input argument list:
!       none
!
!   output argument list:
!     none
!
!   output files:
!     none
!
! subprograms & functions called:
!   gsmconst  - initialize rain & ice lookup tables, read from external file;
!               initialize constants
!   gsmcolumn - cloud microphysics calculations over vertical columns
!
! unique: none
!
! library: none
!
!--- common blocks (input for microphysics):
!       ctlblk, loops, masks, phys, vrbls, cldwtr, pvrbls, acmclh, pptasm, c_fracn
!
!--- common blocks ("triggers" for microphysics & statistics):
!
! attributes:
!   language: fortran 90
!   machine : ibm sp
!
!------------------------------------------------------------------------
      include 'modelgrid.inc'
!----------------------------------------------------------------------
      parameter(lnprc=1)
!-------------------------------------------------------------------------
!-----  key parameters passed to column microphysics (column_micro) ------
!-------------------------------------------------------------------------
!--- this variable is for debugging purposes (if .true.)
!
      logical, parameter :: print_diag=.false.
!
!--- the following variables are for microphysical statistics (non-essential)
!
      integer, parameter :: itlo=-60, ithi=40, ithilo=ithi-itlo+1, &
     & ithilo_n=ithilo*4, ithilo_qm=ithilo*5, ithilo_qt=ithilo*22
      common /cmicro_stats/ nstats(itlo:ithi,4), qmax(itlo:ithi,5), &
     & qtot(itlo:ithi,22)
      integer :: nstats
      real, save :: thour_print, &
     &  precmax(2),prectot(2)
      real, parameter :: dthour_print=9999.     ! print statistics every 3 h
!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~ begin section on hydrometeor fractions
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
      common /c_fractions/ f_ice(im,jm,lm) &
     &,                    f_rain(im,jm,lm) &
     &,                    f_rimef(im,jm,lm)
!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~ saved values use real (real*4) arrays rather than integer*2
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
      real f_ice, f_rain, f_rimef, fice, frain, dum
!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~ saved values use integer*2 arrays rather than real*4
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
!--- parameters used in converting from real to integer*2 fields for
!      fraction of ice (f_ice), fraction of rain (f_rain), and mass
!      ratio of rimed ice ("rime factor", f_rimef).
!
!!      real, parameter :: fscale=10000., rfscale=1./fscale,
!!     &  rimescale=100., rimeround=.5/rimescale
!!      integer*2, parameter :: ifmin=0, ifmax=fscale, irimef=rimescale
!!
!!      integer*2 :: f_ice, f_rain, f_rimef, fice, frain, i2dum
!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!~~~~~~ end section on hydrometeor fractions
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
!-----------------------------------------------------------------------
!-------------- local arrays & parameters in gsmdrive -----------------
!-----------------------------------------------------------------------
!
!---- comments on 14 march 2002
!    * epsq=1.e-12 is the universal lower limit for specific humidity and
!      total condensate, and is consistent throughout the code.
!
      real, parameter :: epsq=1.e-12, grav=9.8, rhol=1000., t0c=273.15, &
     & t_ice=-30., t_icek=t0c+t_ice, rrhol=1./rhol, epsq1=1.001*epsq
!
      real arain, asnow, p_col(lm), qi_col(lm), qr_col(lm), &
     & qv_col(lm), qw_col(lm), rimef_col(lm), t_col(lm), thick_col(lm), &
     & wc_col(lm),dpcol(lm),fcol(lm)
!
!------------------------------------------------------------------------
      logical global,micro_start,mpfilt
      real &
       dsg2(lm),pdsg1(lm) &
      ,acprec(im,jm),pd(im,jm),prec(im,jm),prra(im,jm),prsn(im,jm) &
      ,cw(im,jm,lm),q(im,jm,lm),t(im,jm,lm) &
      ,pint(im,jm,lm+1)
      data micro_start/.true./
      save micro_start,lmsc
!
!------------------------------------------------------------------------
!#######################################################################
!########################## begin execution ############################
!#######################################################################
!
!------------------------------------------------------------------------
!---------------------- microphysical constants -------------------------
!------------------------------------------------------------------------
!
      dtph=dtq2                   ! physics time step (s)
      prectot(1)=0.
      prectot(2)=0.
!
!------------------------------------------------------------------------
!--------------- initialize constants for statistics --------------------
!------------------------------------------------------------------------
!
      if (micro_start) then
        micro_start=.false.       ! no need to calculate these parameters again
        call gpvs   !
   !--- begin: initialize arrays if not initialized in restart files (1/16/02)
   !
        dum=0.
        do j=1+lnprc,jm-lnprc
          do i=1+lnprc,im-lnprc
            lmsc=lm
            do l=1,lmsc
              dum=max(dum,f_rain(i,j,l),f_ice(i,j,l),f_rimef(i,j,l))
              if (dum .gt. 0.) go to 110
            enddo
          enddo
        enddo
110     if (dum .le. 0.) then
          write(0, "(a,2i3)" ) 'initialize internal microphysics arrays'
        do j=1+lnprc,jm-lnprc
          do i=1+lnprc,im-lnprc
              do l=1,lmsc
                f_rain(i,j,l)=0.
                if (t(i,j,l) .le. t_icek) then
                  f_ice(i,j,l)=1.
                else
                  f_ice(i,j,l)=0.
                endif
                  f_rimef(i,j,l)=1.
              enddo
            enddo
          enddo
        endif
   !
        call gsmconst (dtph,dyh)      ! initialize lookup tables & constants
        thour_print=-dtph/3600.+float(ntsd-1)*dt/3600.
        if (print_diag) then
      !
      !-------- total and maximum quantities
      !
          do i=itlo,ithi
        !--- microphysical statistics dealing w/ grid-point counts
            do j=1,4
              nstats(i,j)=0
            enddo
        !--- microphysical statistics dealing w/ maxima of hydrometeor mass
            do j=1,5
              qmax(i,j)=0.
            enddo
        !--- microphysical statistics dealing w/ total hydrometeor mass
            do j=1,22
              qtot(i,j)=0.
            enddo
          enddo
          do i=1,2
            precmax(i)=0.    ! maximum precip rates (rain, snow) at surface (mm/h)
            prectot(i)=0.    ! total precipitation (rain, snow) accumulation at surface
          enddo
        endif
      endif
!
!-----------------------------------------------------------------------
!------------------- loop horizontally through domain ------------------
!-----------------------------------------------------------------------
!
      rgrav=1./grav
!
      do 100 j=1+lnprc,jm-lnprc
        do 100 i=1+lnprc,im-lnprc
          pdsl=pd(i,j)                 ! (psfc-ptop)/eta_sfc
   !
   !--- initialize column data (1d arrays)
   !
          if (cw(i,j,1) .le. epsq) cw(i,j,1)=epsq
          f_ice(i,j,1)=1.
          f_rain(i,j,1)=0.
          f_rimef(i,j,1)=1.
          do l=1,lmsc
      !
      !--- pressure (pa)
      !
            p_col(l)=(pint(i,j,l)+pint(i,j,l+1))*0.5
      !
      !--- layer thickness = rho*dz = -dp/g
      !
            thick_col(l)=(dsg2(l)*pdsl+pdsg1(l))*rgrav
            t_col(l)=t(i,j,l)
            tc=t_col(l)-t0c
            qv_col(l)=max(epsq, q(i,j,l))
            if (cw(i,j,l) .le. epsq1) then
              wc_col(l)=0.
              if (tc .lt. t_ice) then
                f_ice(i,j,l)=1.
              else
                f_ice(i,j,l)=0.
              endif
              f_rain(i,j,l)=0.
              f_rimef(i,j,l)=1.
            else
              wc_col(l)=cw(i,j,l)
            endif
      !
      !--- determine composition of condensate in terms of
      !      cloud water, ice, & rain
      !
            wc=wc_col(l)
            qi=0.
            qr=0.
            qw=0.
            fice=f_ice(i,j,l)
            frain=f_rain(i,j,l)
      !
      !--- real*4 array storage
      !
            if (fice .ge. 1.) then
              qi=wc
            else if (fice .le. 0.) then
              qw=wc
            else
              qi=fice*wc
              qw=wc-qi
            endif
            if (qw.gt.0. .and. frain.gt.0.) then
              if (frain .ge. 1.) then
                qr=qw
                qw=0.
              else
                qr=frain*qw
                qw=qw-qr
              endif
            endif
            rimef_col(l)=f_rimef(i,j,l)               ! (real)
!!      !
!!      !--- integer*2 array storage
!!      !
!!            if (tc.le.t_ice .or. fice.ge.ifmax) then
!!              qi=wc
!!            else if (fice .le. ifmin) then
!!              qw=wc
!!            else
!!              qi=rfscale*fice*wc
!!              qw=wc-qi
!!            endif
!!            if (qw.gt.0. .and. frain.gt.0) then
!!              if (frain .eq. ifmax) then
!!                qr=qw
!!                qw=0.
!!              else
!!                qr=rfscale*frain*qw
!!                qw=qw-qr
!!              endif
!!            endif
!!            rimef_col(l)=f_rimef(i,j,l)/rimescale
      !
            qi_col(l)=qi
            qr_col(l)=qr
            qw_col(l)=qw
          enddo
!
!#######################################################################
   !
   !--- perform the microphysical calculations in this column
   !
          i_index=i
          j_index=j
          call gsmcolumn ( arain, asnow, dtph, i_index, j_index, lmsc, &
     & p_col, qi_col, qr_col, qv_col, qw_col, rimef_col, t_col, &
     & thick_col, wc_col )
   !
!#######################################################################
go to 3333


!--filtering of temperature profile after microphysics------------------
      epsmpt=0.1     ! non-negligible mp temperature change
      mpfilt=.false. ! 3-point filter switch
      weight=0.125
!
      do l=2,lm
        if(abs(t_col(l)-t(i,j,l)).ge.epsmpt) then
          mpfilt=.true.
          ltop=l-1 ! top of filtered column
          exit
        endif
      enddo
!
      do l=lm-1,2,-1
        if(abs(t_col(l)-t(i,j,l)).ge.epsmpt) then
          mpfilt=.true.
          lbot=l+1 ! bottom of filtered column
          exit
        endif
      enddo
      lbot=min(lbot,lm-1)
!
      if(mpfilt.and.ltop+1.lt.lbot-1) then ! filter
!
        do l=1,lm
          fcol (l)=0.
          dpcol(l)=dsg2(l)*pdsl+pdsg1(l) ! hydrostatic thicknesses
        enddo
!
        itrmax=1  ! filter applied itrmax times
        do iter=1,itrmax
          do l=lbot-1,ltop+1,-1
            fcol(l)=((t_col(l-1)*dpcol(l-1) &
                     +t_col(l+1)*dpcol(l+1)) &
                    /(dpcol(l-1)+dpcol(l+1)))*weight &
                   +t_col(l)*(1.-weight)
          enddo
          do l=ltop+1,lbot-1
            t_col(l)=fcol(l)
          enddo
        enddo
      endif
!-----------------------------------------------------------------------


3333 continue

   !
   !--- update storage arrays
   !
          do l=1,lmsc
            t(i,j,l)=t_col(l)
            q(i,j,l)=max(qv_col(l),epsq)
            cw(i,j,l)=max(wc_col(l),epsq)
      !
      !--- real*4 array storage
      !
            f_rimef(i,j,l)=max(1., rimef_col(l))
            if (qi_col(l) .le. epsq) then
              f_ice(i,j,l)=0.
              if (t_col(l) .lt. t_icek) f_ice(i,j,l)=1.
            else
              f_ice(i,j,l)=max( 0., min(1., qi_col(l)/wc_col(l)) )
            endif
            if (qr_col(l) .le. epsq) then
              dum=0
            else
              dum=qr_col(l)/(qr_col(l)+qw_col(l))
            endif
            f_rain(i,j,l)=dum
!!      !
!!      !--- integer*2 array storage
!!      !
!!            if (rimef_col(l) .le. 1.) then
!!              i2dum=irimef
!!              i2dum=irimef
!!            else
!!              i2dum=(rimef_col(l)+rimeround)*rimescale
!!            endif
!!            f_rimef(i,j,l)=i2dum
!!            if (qi_col(l) .le. epsq) then
!!              i2dum=0
!!            else
!!              i2dum=fscale*qi_col(l)/wc_col(l)
!!              i2dum=max( ifmin, min(ifmax, i2dum) )
!!            endif
!!            f_ice(i,j,l)=i2dum
!!            if (qr_col(l) .le. epsq) then
!!              i2dum=0
!!            else
!!              i2dum=fscale*qr_col(l)/(qr_col(l)+qw_col(l))
!!              i2dum=max( ifmin, min(ifmax, i2dum) )
!!            endif
!!            f_rain(i,j,l)=i2dum
      !
          enddo
   !
   !--- update accumulated precipitation statistics
   !
   !--- surface precipitation statistics; sr is fraction of surface
   !    precipitation (if >0) associated with snow
   !
        arain=arain*rrhol
        asnow=asnow*rrhol
   !
        prra(i,j)=arain
        prsn(i,j)=asnow+prsn(i,j)
   !
        aprec=arain+asnow ! accumulated surface precip (depth in m)  !<--- ying
        prec(i,j)=prec(i,j)+aprec
        acprec(i,j)=acprec(i,j)+aprec
!
   !--- debug statistics
   !
        if (print_diag) then
          prectot(1)=prectot(1)+arain
          prectot(2)=prectot(2)+asnow
          precmax(1)=max(precmax(1), arain)
          precmax(2)=max(precmax(2), asnow)
        endif
!#######################################################################
!#######################################################################
!
100   continue                          ! end "i" & "j" loops
!
!-----------------------------------------------------------------------
!#######################################################################
!#######################################################################
!
!-----------------------------------------------------------------------
!--------------------- end of main microphysics loop -------------------
!-----------------------------------------------------------------------
!
      time_model=float(ntsd-1)*dt/3600.
      if (print_diag .and. time_model.ge.thour_print) then
        hdtph=3600./dtph            ! convert precip rates to mm/h
        do k=itlo,ithi
          qmax(k,1)=1000.*qmax(k,1)
          qmax(k,2)=1000.*qmax(k,2)
          qmax(k,3)=1000.*qmax(k,3)
          qmax(k,4)=hdtph*qmax(k,4)
          qmax(k,5)=hdtph*qmax(k,5)
        enddo
        precmax(1)=hdtph*precmax(1)
        precmax(2)=hdtph*precmax(2)
   !
        write(6,"(a,f5.2,4(a,g11.4))") '{ time(h)=',time_model, &
     & '  train_sfc=',prectot(1),'  tsnow_sfc=',prectot(2), &
     & '  rrmax_sfc(mm/h)=',precmax(1), &
     & '  srmax_sfc(mm/h)=',precmax(2)
   !
        write(6,"(3a)") '{ (c) <--------- counts ----------> ', &
     & '<----------- g/kg ----------> <----- mm/h ------>', &
     & ' <---- kg/m**2 * # grids ---->'
        write(6,"(3a)") '{  t     ncice  ncmix  ncwat ncrain  ', &
     & 'qimax     qwmax     qrmax     srmax     rrmax     qitot     ', &
     & 'qwtot     qrtot'
        do k=itlo,ithi
          write(6,"(a,i3,i9,3i7,8g10.4)") &
     &      '{ ',k,(nstats(k,ii), ii=1,4), &
     &      (qmax(k,jj), jj=1,5),(qtot(k,kk), kk=1,3)
        enddo
   !
        write(6,"(3a)") &
     & '{  t   tcond     ticnd     tievp     tidep     trevp     ', &
     & 'traut     tracw     timlt     tiacw     tiacwi    tiacwr    ', &
     & 'tiacr'
        do k=itlo,ithi
          write(6,"(a,i3,12g10.4)") '{ ',k,(qtot(k,ii), ii=4,15)
        enddo
   !
        write(6,"(2a)") &
     & '{  t   del_qt   tvdif   del_hyd        twdif  tidif       ', &
     & 'trdif    darain   dasnow    rimef'
        do k=itlo,ithi
          del_hyd=0.
          do ii=17,19
            del_hyd=del_hyd+qtot(k,ii)
          enddo
          del_qt=0.
          do ii=16,21
            del_qt=del_qt+qtot(k,ii)
          enddo
          if (qtot(k,22) .gt. 0.) then
            rimef_bulk=qtot(k,1)/qtot(k,22)
            else
            rimef_bulk=1.
          endif
          write(6,"(a,i3,9g10.4)") '{ ',k,del_qt,qtot(k,16), &
     &      del_hyd,(qtot(k,ii), ii=17,21),rimef_bulk
        enddo
   !
   !-------- reset arrays storing total and maximum quantities
   !
       do i=itlo,ithi
   !--- microphysical statistics dealing w/ grid-point counts
         do j=1,4
           nstats(i,j)=0
         enddo
   !--- microphysical statistics dealing w/ maxima of hydrometeor mass
         do j=1,5
           qmax(i,j)=0.
         enddo
   !--- microphysical statistics dealing w/ total hydrometeor mass
         do j=1,22
           qtot(i,j)=0.
         enddo
       enddo
       do i=1,2
         precmax(i)=0.    ! maximum precip rates (rain, snow) at surface (mm/h)
         prectot(i)=0.    ! total precipitation (rain, snow) accumulation at surface
       enddo
       thour_print=thour_print+dthour_print
      endif
!
!-----------------------------------------------------------------------
!------------------------ return to main program -----------------------
!-----------------------------------------------------------------------
200   format(a2,i5,f6.2,4(1x,a10,g11.4))
210   format(a2,i5,f6.2,4(1x,a10,i7))
!-----------------------------------------------------------------------
      endsubroutine gsmdrive
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                            
!###############################################################################
! ***** version of microphysics designed for higher resolution meso eta model
!       (1) represents sedimentation by preserving a portion of the precipitation
!           through top-down integration from cloud-top.  modified procedure to
!           zhao and carr (1997).
!       (2) microphysical equations are modified to be less sensitive to time
!           steps by use of clausius-clapeyron equation to account for changes in
!           saturation mixing ratios in response to latent heating/cooling.
!       (3) prevent spurious temperature oscillations across 0c due to
!           microphysics.
!       (4) uses lookup tables for: calculating two different ventilation
!           coefficients in condensation and deposition processes; accretion of
!           cloud water by precipitation; precipitation mass; precipitation rate
!           (and mass-weighted precipitation fall speeds).
!       (5) assumes temperature-dependent variation in mean diameter of large ice
!           (houze et al., 1979; ryan et al., 1996).
!        -> 8/22/01: this relationship has been extended to colder temperatures
!           to parameterize smaller large-ice particles down to mean sizes of mdimin,
!           which is 50 microns reached at -55.9c.
!       (6) attempts to differentiate growth of large and small ice, mainly for
!           improved transition from thin cirrus to thick, precipitating ice
!           anvils.
!        -> 8/22/01: this feature has been diminished by effectively adjusting to
!           ice saturation during depositional growth at temperatures colder than
!           -10c.  ice sublimation is calculated more explicitly.  the logic is
!           that sources of are either poorly understood (e.g., nucleation for nwp)
!           or are not represented in the eta model (e.g., detrainment of ice from
!           convection).  otherwise the model is too wet compared to the radiosonde
!           observations based on 1 feb - 18 march 2001 retrospective runs.
!       (7) top-down integration also attempts to treat mixed-phase processes,
!           allowing a mixture of ice and water.  based on numerous observational
!           studies, ice growth is based on nucleation at cloud top &
!           subsequent growth by vapor deposition and riming as the ice particles
!           fall through the cloud.  effective nucleation rates are a function
!           of ice supersaturation following meyers et al. (jam, 1992).
!        -> 8/22/01: the simulated relative humidities were far too moist compared
!           to the rawinsonde observations.  this feature has been substantially
!           diminished, limited to a much narrower temperature range of 0 to -10c.
!       (8) depositional growth of newly nucleated ice is calculated for large time
!           steps using fig. 8 of miller and young (jas, 1979), at 1 deg intervals
!           using their ice crystal masses calculated after 600 s of growth in water
!           saturated conditions.  the growth rates are normalized by time step
!           assuming 3d growth with time**1.5 following eq. (6.3) in young (1993).
!        -> 8/22/01: this feature has been effectively limited to 0 to -10c.
!       (9) ice precipitation rates can increase due to increase in response to
!           cloud water riming due to (a) increased density & mass of the rimed
!           ice, and (b) increased fall speeds of rimed ice.
!        -> 8/22/01: this feature has been effectively limited to 0 to -10c.
!###############################################################################
!###############################################################################
!
      subroutine gsmcolumn ( arain, asnow, dtph, i_index, j_index, lmsc, &
     & p_col, qi_col, qr_col, qv_col, qw_col, rimef_col, t_col, &
     & thick_col, wc_col )
!
!###############################################################################
!###############################################################################
!
!-------------------------------------------------------------------------------
!----- note:  code is currently set up w/o threading!
!-------------------------------------------------------------------------------
!$$$  subprogram documentation block
!                .      .    .
! subprogram:  grid-scale microphysical processes - condensation & precipitation
!   prgrmmr: ferrier         org: w/np22     date: 08-2001
!-------------------------------------------------------------------------------
! abstract:
!   * merges original gscond & precpd subroutines.
!   * code has been substantially streamlined and restructured.
!   * exchange between water vapor & small cloud condensate is calculated using
!     the original asai (1965, j. japan) algorithm.  see also references to
!     yau and austin (1979, jas), rutledge and hobbs (1983, jas), and tao et al.
!     (1989, mwr).  this algorithm replaces the sundqvist et al. (1989, mwr)
!     parameterization.
!-------------------------------------------------------------------------------
!
! usage:
!   * call gsmcolumn from subroutine gsmdrive
!   * subroutine gsmdrive called from main program ebu
!
! input argument list:
!   dtph       - physics time step (s)
!   i_index    - i index
!   j_index    - j index
!   lmsc       - level of level above surface, ground
!   p_col      - vertical column of model pressure (pa)
!   qi_col     - vertical column of model ice mixing ratio (kg/kg)
!   qr_col     - vertical column of model rain ratio (kg/kg)
!   qv_col     - vertical column of model water vapor specific humidity (kg/kg)
!   qw_col     - vertical column of model cloud water mixing ratio (kg/kg)
!   rimef_col  - vertical column of rime factor for ice in model (ratio, defined below)
!   t_col      - vertical column of model temperature (deg k)
!   thick_col  - vertical column of model mass thickness (density*height increment)
!   wc_col     - vertical column of model mixing ratio of total condensate (kg/kg)
!
!
! output argument list:
!   arain      - accumulated rainfall at the surface (kg)
!   asnow      - accumulated snowfall at the surface (kg)
!   qv_col     - vertical column of model water vapor specific humidity (kg/kg)
!   wc_col     - vertical column of model mixing ratio of total condensate (kg/kg)
!   qw_col     - vertical column of model cloud water mixing ratio (kg/kg)
!   qi_col     - vertical column of model ice mixing ratio (kg/kg)
!   qr_col     - vertical column of model rain ratio (kg/kg)
!   rimef_col  - vertical column of rime factor for ice in model (ratio, defined below)
!   t_col      - vertical column of model temperature (deg k)
!
! output files:
!     none
!
! subprograms & functions called:
!   * real function condense  - cloud water condensation
!   * real function deposit   - ice deposition (not sublimation)
!
! unique: none
!
! library: none
!
! common blocks:
!     cmicro_cons  - key constants initialized in gsmconst
!     cmicro_stats - accumulated and maximum statistics
!     cmy_growth   - lookup table for growth of ice crystals in
!                    water saturated conditions (miller & young, 1979)
!     ivent_tables - lookup tables for ventilation effects of ice
!     iaccr_tables - lookup tables for accretion rates of ice
!     imass_tables - lookup tables for mass content of ice
!     irate_tables - lookup tables for precipitation rates of ice
!     irime_tables - lookup tables for increase in fall speed of rimed ice
!     rvent_tables - lookup tables for ventilation effects of rain
!     raccr_tables - lookup tables for accretion rates of rain
!     rmass_tables - lookup tables for mass content of rain
!     rvelr_tables - lookup tables for fall speeds of rain
!     rrate_tables - lookup tables for precipitation rates of rain
!
! attributes:
!   language: fortran 90
!   machine : ibm sp
!
!
!-------------------------------------------------------------------------
!--------------- arrays & constants in argument list ---------------------
!-------------------------------------------------------------------------
      include "modelgrid.inc"
!-----------------------------------------------------------------------
      real arain, asnow, p_col(lm), qi_col(lm), qr_col(lm), qv_col(lm), &
     & qw_col(lm), rimef_col(lm), t_col(lm), thick_col(lm), &
     & wc_col(lm)
!
      integer i_index, j_index
!
!-------------------------------------------------------------------------
!-------------- common blocks for microphysical statistics ---------------
!-------------------------------------------------------------------------
!
!-------------------------------------------------------------------------
!--------- common blocks for constants initialized in gsmconst ----------
!
      common /cmicro_cons/ abfr, cbfr, ciacw, ciacr, c_n0r0, &
     & cn0r0, cn0r_dmrmin, cn0r_dmrmax, cracw, craut, esw0, &
     & qaut0, rfmax, rhgrd, rqr_dr1, rqr_dr2, rqr_dr3, rqr_drmin, &
     & rqr_drmax, rr_drmin, rr_dr1, rr_dr2, rr_dr3, rr_drmax
!
!--- the following variables are for microphysical statistics
!
      integer, parameter :: itlo=-60, ithi=40
      common /cmicro_stats/ nstats(itlo:ithi,4), qmax(itlo:ithi,5), &
     & qtot(itlo:ithi,22)
      integer :: nstats
      real :: qmax, qtot
!
!-------------------------------------------------------------------------
!--------------- common blocks for various lookup tables -----------------
!
!--- discretized growth rates of small ice crystals after their nucleation
!     at 1 c intervals from -1 c to -35 c, based on calculations by miller
!     and young (1979, jas) after 600 s of growth.  resultant growth rates
!     are multiplied by physics time step in gsmconst.
!
      integer, parameter :: my_t1=1, my_t2=35
      common /cmy600/ my_growth(my_t1:my_t2)
      real my_growth
!
!-------------------------------------------------------------------------
!
!--- mean ice-particle diameters varying from 50 microns to 1000 microns
!      (1 mm), assuming an exponential size distribution.
!
!--- various rain lookup tables
!
!---- meaning of the following arrays:
!        - mdiam - mean diameter (m)
!        - venti1 - integrated quantity associated w/ ventilation effects
!                   (capacitance only) for calculating vapor deposition onto ice
!        - venti2 - integrated quantity associated w/ ventilation effects
!                   (with fall speed) for calculating vapor deposition onto ice
!        - accri  - integrated quantity associated w/ cloud water collection by ice
!        - massi  - integrated quantity associated w/ ice mass
!        - vsnowi - mass-weighted fall speed of snow (large ice), used to calculate
!                   precipitation rates
!
      real, parameter :: dmimin=.05e-3, dmimax=1.e-3, deldmi=1.e-6, &
     &  xmimin=1.e6*dmimin, xmimax=1.e6*dmimax
      integer, parameter :: mdimin=xmimin, mdimax=xmimax
!
      common /iaccr_tables/ accri(mdimin:mdimax)
      common /imass_tables/ massi(mdimin:mdimax)
      real massi
      common /irate_tables/ vsnowi(mdimin:mdimax)
      common /ivent_tables/ venti1(mdimin:mdimax), venti2(mdimin:mdimax)
!
!------------------------------------------------------------------------- 
!
!--- vel_rf - velocity increase of rimed particles as functions of crude
!      particle size categories (at 0.1 mm intervals of mean ice particle
!      sizes) and rime factor (different values of rime factor of 1.1**n, 
!      where n=0 to nrime).
!
      integer, parameter :: nrime=40
      common /irime_tables/ vel_rf(2:9,0:nrime)
!
!------------------------------------------------------------------------- 
!
!--- mean rain drop diameters varying from 50 microns (0.05 mm) to 450 microns 
!      (0.45 mm), assuming an exponential size distribution.  
!
      real, parameter :: dmrmin=.05e-3, dmrmax=.45e-3, deldmr=1.e-6, &
     & xmrmin=1.e6*dmrmin, xmrmax=1.e6*dmrmax
      integer, parameter :: mdrmin=xmrmin, mdrmax=xmrmax
!
      common /raccr_tables/ accrr(mdrmin:mdrmax)
      common /rmass_tables/ massr(mdrmin:mdrmax)
      real massr
      common /rrate_tables/ rrate(mdrmin:mdrmax)
      common /rvelr_tables/ vrain(mdrmin:mdrmax)
      common /rvent_tables/ ventr1(mdrmin:mdrmax), ventr2(mdrmin:mdrmax)
!
!-------------------------------------------------------------------------
!------- key parameters, local variables, & important comments ---------
!-----------------------------------------------------------------------
!
!--- key parameters:
!
!---- comments on 14 march 2002
!    * set epsq to the universal value of 1.e-12 throughout the code
!      condensate.  the value of epsq will need to be changed in the other
!      subroutines in order to make it consistent throughout the eta code.
!    * set climit=10.*epsq as the lower limit for the total mass of
!      condensate in the current layer and the input flux of condensate
!      from above (tot_ice, tot_icenew, tot_rain, and tot_rainnew).
!
!- nlimax - maximum number concentration of large ice crystals (20,000 /m**3, 20 per liter)
!- nlimin - minimum number concentration of large ice crystals (100 /m**3, 0.1 per liter)
!
      real, parameter :: cp=1004.6, epsq=1.e-12, rd=287.04, &
     & rhol=1000., rv=461.5, t0c=273.15, xls=2.834e6, eps=rd/rv, &
!zjtest     & nlimax=20.e3, nlimin=100., t_ice=-10., t_ice_init=-5., & 
!zjtest     & nlimax=200.e3, nlimin=100., t_ice=-30., t_ice_init=-5., & !zjtest
!zjtest     & nlimax=20.e3, nlimin=100., t_ice=-30., t_ice_init=-5., & !zjtest
     & nlimax=5.e3, nlimin=1000., t_ice=-30., t_ice_init=-5., & !zjtest
     & toler=5.e-7, &
     & climit=10.*epsq, eps1=rv/rd-1., rcp=1./cp, &
     & rcprv=rcp/rv, rrhol=1./rhol, xls1=xls*rcp, xls2=xls*xls*rcprv, &
     & xls3=xls*xls/rv, &
     & c1=1./3., c2=1./6., c3=3.31/6., &
     & dmr1=.1e-3, dmr2=.2e-3, dmr3=.32e-3, n0r0=8.e6, n0rmin=1.e4, &
     & n0s0=4.e6, rho0=1.194, xmr1=1.e6*dmr1, xmr2=1.e6*dmr2, &
     & xmr3=1.e6*dmr3, xratio=.025
      integer, parameter :: mdr1=xmr1, mdr2=xmr2, mdr3=xmr3
!
!--- if blend=1:
!      precipitation (large) ice amounts are estimated at each level as a
!      blend of ice falling from the grid point above and the precip ice
!      present at the start of the time step (see tot_ice below).
!--- if blend=0:
!      precipitation (large) ice amounts are estimated to be the precip
!      ice present at the start of the time step.
!
!--- extended to include sedimentation of rain on 2/5/01
!
      real, parameter :: blend=1.
!
!--- this variable is for debugging purposes (if .true.)
!
      logical, parameter :: print_diag=.true.
!
!--- local variables
!
      real emairi, n0r, nlice, nsmice
      logical clear, ice_logical, dbg_logical, rain_logical
!
!
!#######################################################################
!########################## begin execution ############################
!#######################################################################
!
!
      arain=0.                ! accumulated rainfall into grid box from above (kg/m**2)
      asnow=0.                ! accumulated snowfall into grid box from above (kg/m**2)
!
!-----------------------------------------------------------------------
!------------ loop from top (l=1) to surface (l=lmsc) ------------------
!-----------------------------------------------------------------------
!
      do 10 l=1,lmsc

!--- skip this level and go to the next lower level if no condensate
!      and very low specific humidities
!
        if (qv_col(l).le.epsq .and. wc_col(l).le.epsq) go to 10
!
!-----------------------------------------------------------------------
!------------ proceed with cloud microphysics calculations -------------
!-----------------------------------------------------------------------
!
          tk=t_col(l)         ! temperature (deg k)
          tc=tk-t0c           ! temperature (deg c)
          pp=p_col(l)         ! pressure (pa)
          qv=qv_col(l)        ! specific humidity of water vapor (kg/kg)
          wv=qv/(1.-qv)       ! water vapor mixing ratio (kg/kg)
          wc=wc_col(l)        ! grid-scale mixing ratio of total condensate (water or ice; kg/kg)
!
!-----------------------------------------------------------------------
!--- moisture variables below are mixing ratios & not specifc humidities
!-----------------------------------------------------------------------
!
          clear=.true.
!
!--- this check is to determine grid-scale saturation when no condensate is present
!
          esw=1000.*fpvs0(tk)              ! saturation vapor pressure w/r/t water
          qsw=eps*esw/(pp-esw)             ! saturation mixing ratio w/r/t water
          ws=qsw                           ! general saturation mixing ratio (water/ice)
          if (tc .lt. 0.) then
            esi=1000.*fpvs(tk)             ! saturation vapor pressure w/r/t ice
            qsi=eps*esi/(pp-esi)           ! saturation mixing ratio w/r/t water
            ws=qsi                         ! general saturation mixing ratio (water/ice)
          endif
!
!--- effective grid-scale saturation mixing ratios
!
          qswgrd=rhgrd*qsw
          qsigrd=rhgrd*qsi
          wsgrd=rhgrd*ws
!
!--- check if air is subsaturated and w/o condensate
!
          if (wv.gt.wsgrd .or. wc.gt.epsq) clear=.false.
!
!--- check if any rain is falling into layer from above
!
          if (arain .gt. climit) then
            clear=.false.
          else
            arain=0.
          endif
!
!--- check if any ice is falling into layer from above
!
!--- note that "snow" in variable names is synonomous with
!    large, precipitation ice particles
!
          if (asnow .gt. climit) then
            clear=.false.
          else
            asnow=0.
          endif
!
!-----------------------------------------------------------------------
!-- loop to the endif in clear, subsaturated air free of condensate ---
!-----------------------------------------------------------------------
!
          if (clear) go to 10
!
!-----------------------------------------------------------------------
!--------- initialize rho, thick & microphysical processes -------------
!-----------------------------------------------------------------------
!
!
!--- virtual temperature, tv=t*(1./eps-1)*q, q is specific humidity;
!    (see pp. 63-65 in fleagle & businger, 1963)
!
          rho=pp/(rd*tk*(1.+eps1*qv-wc))   ! air density (kg/m**3) !zjtest
          rrho=1./rho                ! reciprocal of air density
          dtrho=dtph*rho             ! time step * air density
          bldtrh=blend*dtrho         ! blend parameter * time step * air density
          thick=thick_col(l)         ! layer thickness = rho*dz = -dp/g
!
          arainnew=0.                ! updated accumulated rainfall
          asnownew=0.                ! updated accumulated snowfall
          qi=qi_col(l)               ! ice mixing ratio
          qinew=0.                   ! updated ice mixing ratio
          qr=qr_col(l)               ! rain mixing ratio
          qrnew=0.                   ! updated rain ratio
          qw=qw_col(l)               ! cloud water mixing ratio
          qwnew=0.                   ! updated cloud water ratio
!
          pcond=0.                   ! condensation (>0) or evaporation (<0) of cloud water (kg/kg)
          pidep=0.                   ! deposition (>0) or sublimation (<0) of ice crystals (kg/kg)
          piacw=0.                   ! cloud water collection (riming) by precipitation ice (kg/kg; >0)
          piacwi=0.                  ! growth of precip ice by riming (kg/kg; >0)
          piacwr=0.                  ! shedding of accreted cloud water to form rain (kg/kg; >0)
          piacr=0.                   ! freezing of rain onto large ice at supercooled temps (kg/kg; >0)
          picnd=0.                   ! condensation (>0) onto wet, melting ice (kg/kg)
          pievp=0.                   ! evaporation (<0) from wet, melting ice (kg/kg)
          pimlt=0.                   ! melting ice (kg/kg; >0)
          praut=0.                   ! cloud water autoconversion to rain (kg/kg; >0)
          pracw=0.                   ! cloud water collection (accretion) by rain (kg/kg; >0)
          prevp=0.                   ! rain evaporation (kg/kg; <0)
!
!--- double check input hydrometeor mixing ratios
!
!          dum=wc-(qi+qw+qr)
!          dum1=abs(dum)
!          dum2=toler*min(wc, qi+qw+qr)
!          if (dum1 .gt. dum2) then
!            write(6,"(/2(a,i4),a,i2)") '{@ i=',i_index,' j=',j_index,
!     &                                 ' l=',l
!            write(6,"(4(a12,g11.4,1x))")
!     & '{@ tcold=',tc,'p=',.01*pp,'diff=',dum,'wcold=',wc,
!     & '{@ qiold=',qi,'qwold=',qw,'qrold=',qr
!          endif
!
!***********************************************************************
!*********** main microphysics calculations now follow! ****************
!***********************************************************************
!
!--- calculate a few variables, which are used more than once below
!
!--- latent heat of vaporization as a function of temperature from
!      bolton (1980, jas)
!
          xlv=3.148e6-2370*tk        ! latent heat of vaporization (lv)
          xlf=xls-xlv                ! latent heat of fusion (lf)
          xlv1=xlv*rcp               ! lv/cp
          xlf1=xlf*rcp               ! lf/cp
          tk2=1./(tk*tk)             ! 1./tk**2
          xlv2=xlv*xlv*qsw*tk2/rv    ! lv**2*qsw/(rv*tk**2)
          denomw=1.+xlv2*rcp         ! denominator term, clausius-clapeyron correction
!
!--- basic thermodynamic quantities
!      * dynvis - dynamic viscosity  [ kg/(m*s) ]
!      * therm_cond - thermal conductivity  [ j/(m*s*k) ]
!      * diffus - diffusivity of water vapor  [ m**2/s ]
!
!          tfactor=tk**1.5/(tk+120.)
          tfactor=tk*sqrt(tk)/(tk+120.)
          dynvis=1.496e-6*tfactor
          therm_cond=2.116e-3*tfactor
          diffus=8.794e-5*tk**1.81/pp
!
!--- air resistance term for the fall speed of ice following the
!      basic research by heymsfield, kajikawa, others
!
          gammas=(1.e5/pp)**c1
!
!--- air resistance for rain fall speed (beard, 1985, jas, p.470)
!
          gammar=(rho0/rho)**.4
!
!----------------------------------------------------------------------
!-------------  important microphysics decision tree  -----------------
!----------------------------------------------------------------------
!
!--- determine if conditions supporting ice are present
!
          if (tc.lt.0. .or. qi.gt.epsq .or. asnow.gt.climit) then
            ice_logical=.true.
          else
            ice_logical=.false.
            qlice=0.
            qtice=0.
          endif
!
!--- determine if rain is present
!
          rain_logical=.false.
          if (arain.gt.climit .or. qr.gt.epsq) rain_logical=.true.
!
          if (ice_logical) then
!
!--- important:  estimate time-averaged properties.
!
!---
!  * flarge  - ratio of number of large ice to total (large & small) ice
!  * fsmall  - ratio of number of small ice crystals to large ice particles
!  ->  small ice particles are assumed to have a mean diameter of 50 microns.
!  * xsimass - used for calculating small ice mixing ratio
!---
!  * tot_ice - total mass (small & large) ice before microphysics,
!              which is the sum of the total mass of large ice in the
!              current layer and the input flux of ice from above
!  * piloss  - greatest loss (<0) of total (small & large) ice by
!              sublimation, removing all of the ice falling from above
!              and the ice within the layer
!  * rimef1  - rime factor, which is the mass ratio of total (unrimed & rimed)
!              ice mass to the unrimed ice mass (>=1)
!  * vrimef  - the velocity increase due to rime factor or melting (ratio, >=1)
!  * vsnow   - fall speed of rimed snow w/ air resistance correction
!  * emairi  - equivalent mass of air associated layer and with fall of snow into layer
!  * xlimass - used for calculating large ice mixing ratio
!  * flimass - mass fraction of large ice
!  * qtice   - time-averaged mixing ratio of total ice
!  * qlice   - time-averaged mixing ratio of large ice
!  * nlice   - time-averaged number concentration of large ice
!  * nsmice  - number concentration of small ice crystals at current level
!---
!--- assumed number fraction of large ice particles to total (large & small)
!    ice particles, which is based on a general impression of the literature.
!
            wvqw=wv+qw                ! water vapor & cloud water
!
            if (tc.ge.0. .or. wvqw.lt.qsigrd) then
   !
   !--- eliminate small ice particle contributions for melting & sublimation
   !
              flarge=1.
            else
   !
   !--- enhanced number of small ice particles during depositional growth
   !    (effective only when 0c > t >= t_ice [-10c] )
   !
              flarge=.2
   !
   !--- larger number of small ice particles due to rime splintering
   !
              if (tc.ge.-8. .and. tc.le.-3.) flarge=.5*flarge
!
            endif            ! endif (tc.ge.0. .or. wvqw.lt.qsigrd)
            fsmall=(1.-flarge)/flarge
            xsimass=rrho*massi(mdimin)*fsmall
            if (qi.le.epsq .and. asnow.le.climit) then
              indexs=mdimin
              tot_ice=0.
              piloss=0.
              rimef1=1.
              vrimef=1.
              vel_inc=gammas
              vsnow=0.
              emairi=thick
              xlimass=rrho*rimef1*massi(indexs)
              flimass=xlimass/(xlimass+xsimass)
              qlice=0.
              qtice=0.
              nlice=0.
              nsmice=0.
            else
   !
   !--- for t<0c mean particle size follows houze et al. (jas, 1979, p. 160),
   !    converted from fig. 5 plot of lamdas.  similar set of relationships
   !    also shown in fig. 8 of ryan (bams, 1996, p. 66).
   !
              dum=xmimax*exp(.0536*tc)
              indexs=min(mdimax, max(mdimin, int(dum) ) )
              tot_ice=thick*qi+blend*asnow
              piloss=-tot_ice/thick
              lbef=max(1,l-1)
              dum1=rimef_col(lbef)
              dum2=rimef_col(l)
              rimef1=(dum2*thick*qi+dum1*blend*asnow)/tot_ice
              rimef1=min(rimef1, rfmax)
              do ipass=0,1
                if (rimef1 .le. 1.) then
                  rimef1=1.
                  vrimef=1.
                else
                  ixs=max(2, min(indexs/100, 9))
                  xrf=10.492*alog(rimef1)
                  ixrf=max(0, min(int(xrf), nrime))
                  if (ixrf .ge. nrime) then
                    vrimef=vel_rf(ixs,nrime)
                  else
                    vrimef=vel_rf(ixs,ixrf)+(xrf-float(ixrf))* &
     &                    (vel_rf(ixs,ixrf+1)-vel_rf(ixs,ixrf))
                  endif
                endif            ! endif (rimef1 .le. 1.)
                vel_inc=gammas*vrimef
                vsnow=vel_inc*vsnowi(indexs)
                emairi=thick+bldtrh*vsnow
                xlimass=rrho*rimef1*massi(indexs)
                flimass=xlimass/(xlimass+xsimass)
                qtice=tot_ice/emairi
                qlice=flimass*qtice
                nlice=qlice/xlimass
                nsmice=fsmall*nlice
   !
                if ( (nlice.ge.nlimin .and. nlice.le.nlimax) &
     &                .or. ipass.eq.1) then
                  exit
                else
        !
        !--- reduce excessive accumulation of ice at upper levels
        !    associated with strong grid-resolved ascent
        !
        !--- force nlice to be between nlimin and nlimax
        !
                  dum=max(nlimin, min(nlimax, nlice) )
                  xli=rho*(qtice/dum-xsimass)/rimef1
                  if (xli .le. massi(mdimin) ) then
                    indexs=mdimin
                  else if (xli .le. massi(450) ) then
                    dli=9.5885e5*xli**.42066         ! dli in microns
                    indexs=min(mdimax, max(mdimin, int(dli) ) )
                  else if (xli .le. massi(mdimax) ) then
                    dli=3.9751e6*xli**.49870         ! dli in microns
                    indexs=min(mdimax, max(mdimin, int(dli) ) )
                  else
                    indexs=mdimax
           !
           !--- 8/22/01: increase density of large ice if maximum limits
           !    are reached for number concentration (nlimax) and mean size
           !    (mdimax).  done to increase fall out of ice.
           !
                    if (dum .ge. nlimax) &
     &                rimef1=rho*(qtice/nlimax-xsimass)/massi(indexs)
                  endif             ! endif (xli .le. massi(mdimin) )
!            write(6,"(4(a12,g11.4,1x))")
!     & '{$ tc=',tc,'p=',.01*pp,'nlice=',nlice,'dum=',dum,
!     & '{$ xli=',xli,'indexs=',float(indexs),'rho=',rho,'qtice=',qtice,
!     & '{$ xsimass=',xsimass,'rimef1=',rimef1
                endif                  ! endif ( (nlice.ge.nlimin .and. nlice.le.nlimax) ...
              enddo                    ! end do ipass=0,1
            endif                      ! endif (qi.le.epsq .and. asnow.le.climit)
          endif                        ! endif (ice_logical)
!
!----------------------------------------------------------------------
!--------------- calculate individual processes -----------------------
!----------------------------------------------------------------------
!
!--- cloud water autoconversion to rain and collection by rain
!
          if (qw.gt.epsq .and. tc.ge.t_ice) then
   !
   !--- qw0 could be modified based on land/sea properties,
   !      presence of convection, etc.  this is why qaut0 and craut
   !      are passed into the subroutine as externally determined
   !      parameters.  can be changed in the future if desired.
   !
            qw0=qaut0*rrho
            praut=max(0., qw-qw0)*craut
            if (qlice .gt. epsq) then
      !
      !--- collection of cloud water by large ice particles ("snow")
      !    piacwi=piacw for riming, piacwi=0 for shedding
      !
              fws=min(1., ciacw*vel_inc*nlice*accri(indexs)/pp**c1)
              piacw=fws*qw
              if (tc .lt. 0.) piacwi=piacw    ! large ice riming
            endif           ! endif (qlice .gt. epsq)
          endif             ! endif (qw.gt.epsq .and. tc.ge.t_ice)
!
!----------------------------------------------------------------------
!--- loop around some of the ice-phase processes if no ice should be present
!----------------------------------------------------------------------
!
          if (ice_logical .eqv. .false.) go to 20
!
!--- now the pretzel logic of calculating ice deposition
!
          if (tc.lt.t_ice .and. (wv.gt.qsigrd .or. qw.gt.epsq)) then
   !
   !--- adjust to ice saturation at t<t_ice (-10c) if supersaturated.
   !    sources of ice due to nucleation and convective detrainment are
   !    either poorly understood, poorly resolved at typical nwp
   !    resolutions, or are not represented (e.g., no detrained
   !    condensate in bmj cu scheme).
   !
            pcond=-qw
            dum1=tk+xlv1*pcond                 ! updated (dummy) temperature (deg k)
            dum2=wv+qw                         ! updated (dummy) water vapor mixing ratio
            dum=1000.*fpvs(dum1)               ! updated (dummy) saturation vapor pressure w/r/t ice
            dum=rhgrd*eps*dum/(pp-dum)         ! updated (dummy) saturation mixing ratio w/r/t ice
            if (dum2 .gt. dum) pidep=deposit (pp, rhgrd, dum1, dum2)
            dwvi=0.    ! used only for debugging
   !
          else if (tc .lt. 0.) then
   !
   !--- these quantities are handy for ice deposition/sublimation
   !    pidep_max - max deposition or minimum sublimation to ice saturation
   !
            denomi=1.+xls2*qsi*tk2
            dwvi=min(wvqw,qsw)-qsi
            pidep_max=max(piloss, dwvi/denomi)
            if (qtice .gt. 0.) then
      !
      !--- calculate ice deposition/sublimation
      !      * sfactor - [vel_inc**.5]*[schmidt**(1./3.)]*[(rho/dynvis)**.5],
      !        where schmidt (schmidt number) =dynvis/(rho*diffus)
      !      * units: sfactor - s**.5/m ;  abi - m**2/s ;  nlice - m**-3 ;
      !               ventil, ventis - m**-2 ;  venti1 - m ;
      !               venti2 - m**2/s**.5 ; didep - unitless
      !
!              sfactor=vel_inc**.5*(rho/(diffus*diffus*dynvis))**c2
              sfactor=sqrt(vel_inc)*(rho/(diffus*diffus*dynvis))**c2
              abi=1./(rho*xls3*qsi*tk2/therm_cond+1./diffus)
      !
      !--- ventil - number concentration * ventilation factors for large ice
      !--- ventis - number concentration * ventilation factors for small ice
      !
      !--- variation in the number concentration of ice with time is not
      !      accounted for in these calculations (could be in the future).
      !
              ventil=(venti1(indexs)+sfactor*venti2(indexs))*nlice
              ventis=(venti1(mdimin)+sfactor*venti2(mdimin))*nsmice
              didep=abi*(ventil+ventis)*dtph
      !
      !--- account for change in water vapor supply w/ time
      !
              if (didep .ge. xratio) &
     &          didep=(1.-exp(-didep*denomi))/denomi
              if (dwvi .gt. 0.) then
                pidep=min(dwvi*didep, pidep_max)
              else if (dwvi .lt. 0.) then
                pidep=max(dwvi*didep, pidep_max)
              endif
      !
            else if (wvqw.gt.qsi .and. tc.le.t_ice_init) then
      !
      !--- ice nucleation in near water-saturated conditions.  ice crystal
      !    growth during time step calculated using miller & young (1979, jas).
      !--- these deposition rates could drive conditions below water saturation,
      !    which is the basis of these calculations.  intended to approximate
      !    more complex & computationally intensive calculations.
      !
              index_my=max(my_t1, min( int(.5-tc), my_t2 ) )
      !
      !--- dum1 is the supersaturation w/r/t ice at water-saturated conditions
      !
      !--- dum2 is the number of ice crystals nucleated at water-saturated
      !    conditions based on meyers et al. (jam, 1992).
      !
      !--- prevent unrealistically large ice initiation (limited by pidep_max)
      !      if dum2 values are increased in future experiments
      !
              dum1=qsw/qsi-1.
              dum2=1.e3*exp(12.96*dum1-.639)
              pidep=min(pidep_max, dum2*my_growth(index_my)*rrho)
      !
            endif       ! endif (qtice .gt. 0.)
   !
          endif         ! endif (tc.lt.t_ice .and. (wv.gt.qsigrd .or. qw.gt.epsq))
!
!------------------------------------------------------------------------
!
20      continue     ! jump here if conditions for ice are not present
!
!------------------------------------------------------------------------
!
!--- cloud water condensation
!
          if (tc.ge.t_ice .and. (qw.gt.epsq .or. wv.gt.qswgrd)) then
            if (piacwi.eq.0. .and. pidep.eq.0.) then
              pcond=condense (pp, qw, rhgrd, tk, wv)
            else
   !
   !--- modify cloud condensation in response to ice processes
   !
              dum=xlv*qswgrd*rcprv*tk2
              denomwi=1.+xls*dum
              denomf=xlf*dum
              dum=max(0., pidep)
              pcond=(wv-qswgrd-denomwi*dum-denomf*piacwi)/denomw
              dum1=-qw
              dum2=pcond-piacw
              if (dum2 .lt. dum1) then
      !
      !--- limit cloud water sinks
      !
                dum=dum1/dum2
                pcond=dum*pcond
                piacw=dum*piacw
                piacwi=dum*piacwi
              endif        ! endif (dum2 .lt. dum1)
            endif          ! endif (piacwi.eq.0. .and. pidep.eq.0.)
          endif            ! endif (tc.ge.t_ice .and. (qw.gt.epsq .or. wv.gt.qswgrd))
!
!--- limit freezing of accreted rime to prevent temperature oscillations,
!    a crude schumann-ludlam limit (p. 209 of young, 1993).
!
          tcc=tc+xlv1*pcond+xls1*pidep+xlf1*piacwi
          if (tcc .gt. 0.) then
            piacwi=0.
            tcc=tc+xlv1*pcond+xls1*pidep
          endif
!
          if (tc.gt.0. .and. tcc.gt.0. .and. ice_logical) then
   !
   !--- calculate melting and evaporation/condensation
   !      * units: sfactor - s**.5/m ;  abi - m**2/s ;  nlice - m**-3 ;
   !               ventil - m**-2 ;  venti1 - m ;
   !               venti2 - m**2/s**.5 ; cievp - /s
   !
!            sfactor=vel_inc**.5*(rho/(diffus*diffus*dynvis))**c2
            sfactor=sqrt(vel_inc)*(rho/(diffus*diffus*dynvis))**c2
            ventil=nlice*(venti1(indexs)+sfactor*venti2(indexs))
            aievp=ventil*diffus*dtph
            if (aievp .lt. xratio) then
              dievp=aievp
            else
              dievp=1.-exp(-aievp)
            endif
            qsw0=eps*esw0/(pp-esw0)
            dwv0=min(wv,qsw)-qsw0
            dum=qw+pcond
            if (wv.lt.qsw .and. dum.le.epsq) then
   !
   !--- evaporation from melting snow (sink of snow) or shedding
   !    of water condensed onto melting snow (source of rain)
   !
              dum=dwv0*dievp
              pievp=max( min(0., dum), piloss)
              picnd=max(0., dum)
            endif            ! endif (wv.lt.qsw .and. dum.le.epsq)
            pimlt=therm_cond*tcc*ventil*rrho*dtph/xlf
   !
   !--- limit melting to prevent temperature oscillations across 0c
   !
            dum1=max( 0., (tcc+xlv1*pievp)/xlf1 )
            pimlt=min(pimlt, dum1)
   !
   !--- limit loss of snow by melting (>0) and evaporation
   !
            dum=pievp-pimlt
            if (dum .lt. piloss) then
              dum1=piloss/dum
              pimlt=pimlt*dum1
              pievp=pievp*dum1
            endif           ! endif (dum .gt. qtice)
          endif             ! endif (tc.gt.0. .and. tcc.gt.0. .and. ice_logical)
!
!--- important:  estimate time-averaged properties.
!
!  * tot_rain - total mass of rain before microphysics, which is the sum of
!               the total mass of rain in the current layer and the input
!               flux of rain from above
!  * vrain1   - fall speed of rain into grid from above (with air resistance correction)
!  * qtrain   - time-averaged mixing ratio of rain (kg/kg)
!  * prloss   - greatest loss (<0) of rain, removing all rain falling from
!               above and the rain within the layer
!  * rqr      - rain content (kg/m**3)
!  * indexr   - mean size of rain drops to the nearest 1 micron in size
!  * n0r      - intercept of rain size distribution (typically 10**6 m**-4)
!
          tot_rain=0.
          vrain1=0.
          qtrain=0.
          prloss=0.
          rqr=0.
          n0r=0.
          indexr1=indexr    ! for debugging only
          indexr=mdrmin
          if (rain_logical) then
            if (arain .le. 0.) then
              indexr=mdrmin
              vrain1=0.
            else
   !
   !--- indexr (related to mean diameter) & n0r could be modified
   !      by land/sea properties, presence of convection, etc.
   !
   !--- rain rate normalized to a density of 1.194 kg/m**3
   !
              rr=arain/(dtph*gammar)
   !
              if (rr .le. rr_drmin) then
        !
        !--- assume fixed mean diameter of rain (0.2 mm) for low rain rates,
        !      instead vary n0r with rain rate
        !
                indexr=mdrmin
              else if (rr .le. rr_dr1) then
        !
        !--- best fit to mass-weighted fall speeds (v) from rain lookup tables
        !      for mean diameters (dr) between 0.05 and 0.10 mm:
        !      v(dr)=5.6023e4*dr**1.136, v in m/s and dr in m
        !      rr = pi*1000.*n0r0*5.6023e4*dr**(4+1.136) = 1.408e15*dr**5.136,
        !        rr in kg/(m**2*s)
        !      dr (m) = 1.123e-3*rr**.1947 -> dr (microns) = 1.123e3*rr**.1947
        !
                indexr=int( 1.123e3*rr**.1947 + .5 )
                indexr=max( mdrmin, min(indexr, mdr1) )
              else if (rr .le. rr_dr2) then
        !
        !--- best fit to mass-weighted fall speeds (v) from rain lookup tables
        !      for mean diameters (dr) between 0.10 and 0.20 mm:
        !      v(dr)=1.0867e4*dr**.958, v in m/s and dr in m
        !      rr = pi*1000.*n0r0*1.0867e4*dr**(4+.958) = 2.731e14*dr**4.958,
        !        rr in kg/(m**2*s)
        !      dr (m) = 1.225e-3*rr**.2017 -> dr (microns) = 1.225e3*rr**.2017
        !
                indexr=int( 1.225e3*rr**.2017 + .5 )
                indexr=max( mdr1, min(indexr, mdr2) )
              else if (rr .le. rr_dr3) then
        !
        !--- best fit to mass-weighted fall speeds (v) from rain lookup tables
        !      for mean diameters (dr) between 0.20 and 0.32 mm:
        !      v(dr)=2831.*dr**.80, v in m/s and dr in m
        !      rr = pi*1000.*n0r0*2831.*dr**(4+.80) = 7.115e13*dr**4.80,
        !        rr in kg/(m**2*s)
        !      dr (m) = 1.3006e-3*rr**.2083 -> dr (microns) = 1.3006e3*rr**.2083
        !
                indexr=int( 1.3006e3*rr**.2083 + .5 )
                indexr=max( mdr2, min(indexr, mdr3) )
              else if (rr .le. rr_drmax) then
        !
        !--- best fit to mass-weighted fall speeds (v) from rain lookup tables
        !      for mean diameters (dr) between 0.32 and 0.45 mm:
        !      v(dr)=944.8*dr**.6636, v in m/s and dr in m
        !      rr = pi*1000.*n0r0*944.8*dr**(4+.6636) = 2.3745e13*dr**4.6636,
        !        rr in kg/(m**2*s)
        !      dr (m) = 1.355e-3*rr**.2144 -> dr (microns) = 1.355e3*rr**.2144
        !
                indexr=int( 1.355e3*rr**.2144 + .5 )
                indexr=max( mdr3, min(indexr, mdrmax) )
              else
        !
        !--- assume fixed mean diameter of rain (0.45 mm) for high rain rates,
        !      instead vary n0r with rain rate
        !
                indexr=mdrmax
              endif              ! endif (rr .le. rr_drmin) etc.
              vrain1=gammar*vrain(indexr)
            endif              ! endif (arain .le. 0.)
            indexr1=indexr     ! for debugging only
            tot_rain=thick*qr+blend*arain
            qtrain=tot_rain/(thick+bldtrh*vrain1)
            prloss=-tot_rain/thick
            rqr=rho*qtrain
   !
   !--- rqr - time-averaged rain content (kg/m**3)
   !
            if (rqr .le. rqr_drmin) then
              n0r=max(n0rmin, cn0r_dmrmin*rqr)
              indexr=mdrmin
            else if (rqr .ge. rqr_drmax) then
              n0r=cn0r_dmrmax*rqr
              indexr=mdrmax
            else
              n0r=n0r0
              indexr=max( xmrmin, min(cn0r0*rqr**.25, xmrmax) )
            endif
   !
            if (tc .lt. t_ice) then
              piacr=-prloss
            else
              dwvr=wv-pcond-qsw
              dum=qw+pcond
              if (dwvr.lt.0. .and. dum.le.epsq) then
      !
      !--- rain evaporation
      !
      !    * rfactor - [gammar**.5]*[schmidt**(1./3.)]*[(rho/dynvis)**.5],
      !        where schmidt (schmidt number) =dynvis/(rho*diffus)
      !
      !    * units: rfactor - s**.5/m ;  abw - m**2/s ;  ventr - m**-2 ;
      !             n0r - m**-4 ;  ventr1 - m**2 ;  ventr2 - m**3/s**.5 ;
      !             crevp - unitless
      !
!                rfactor=gammar**.5*(rho/(diffus*diffus*dynvis))**c2
                rfactor=sqrt(gammar)*(rho/(diffus*diffus*dynvis))**c2
                abw=1./(rho*xlv2/therm_cond+1./diffus)
      !
      !--- note that ventr1, ventr2 lookup tables do not include the
      !      1/davg multiplier as in the ice tables
      !
                ventr=n0r*(ventr1(indexr)+rfactor*ventr2(indexr))
                crevp=abw*ventr*dtph
                if (crevp .lt. xratio) then
                  dum=dwvr*crevp
                else
                  dum=dwvr*(1.-exp(-crevp*denomw))/denomw
                endif
                prevp=max(dum, prloss)
              else if (qw .gt. epsq) then
                fwr=cracw*gammar*n0r*accrr(indexr)
                pracw=min(1.,fwr)*qw
              endif           ! endif (dwvr.lt.0. .and. dum.le.epsq)
      !
              if (tc.lt.0. .and. tcc.lt.0.) then
         !
         !--- biggs (1953) heteorogeneous freezing (e.g., lin et al., 1983)
         !
                dum=(exp(abfr*tc)-1.)*(.001*float(indexr))**7
                piacr=min(cbfr*n0r*rrho*dum, qtrain)
                if (qlice .gt. epsq) then
            !
            !--- freezing of rain by collisions w/ large ice
            !
                  dum=gammar*vrain(indexr)
                  dum1=dum-vsnow
            !
            !--- dum2 - difference in spectral fall speeds of rain and
            !      large ice, parameterized following eq. (48) on p. 112 of
            !      murakami (j. meteor. soc. japan, 1990)
            !
!                  dum2=(dum1*dum1+.04*dum*vsnow)**.5
                  dum2=sqrt(dum1*dum1+.04*dum*vsnow)
                  dum1=5.e-12*indexr*indexr+2.e-12*indexr*indexs &
     &                 +.5e-12*indexs*indexs
                  fir=min(1., ciacr*nlice*dum1*dum2)
            !
            !--- future?  should collection by small ice should be included???
            !
                  piacr=min(piacr+fir*qtrain, qtrain)
                endif        ! endif (qlice .gt. epsq)
                dum=prevp-piacr
                if (dum .lt. prloss) then
                  dum1=prloss/dum
                  prevp=dum1*prevp
                  piacr=dum1*piacr
                endif        ! endif (dum .lt. prloss)
              endif          ! endif (tc.lt.0. .and. tcc.lt.0.)
            endif            ! endif (tc .lt. t_ice)
          endif              ! endif (rain_logical)
!
!----------------------------------------------------------------------
!---------------------- main budget equations -------------------------
!----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!--- update fields, determine characteristics for next lower layer ----
!-----------------------------------------------------------------------
!
!--- carefully limit sinks of cloud water
!
          dum1=piacw+praut+pracw-min(0.,pcond)
          if (dum1 .gt. qw) then
            dum=qw/dum1
            piacw=dum*piacw
            piacwi=dum*piacwi
            praut=dum*praut
            pracw=dum*pracw
            if (pcond .lt. 0.) pcond=dum*pcond
          endif
          piacwr=piacw-piacwi          ! tc >= 0c
!
!--- qwnew - updated cloud water mixing ratio
!
          delw=pcond-piacw-praut-pracw
          qwnew=qw+delw
          if (qwnew .le. epsq) qwnew=0.
          if (qw.gt.0. .and. qwnew.ne.0.) then
            dum=qwnew/qw
            if (dum .lt. toler) qwnew=0.
          endif
!
!--- update temperature and water vapor mixing ratios
!
          delt= xlv1*(pcond+pievp+picnd+prevp) &
     &         +xls1*pidep+xlf1*(piacwi+piacr-pimlt)
          tnew=tk+delt
!
          delv=-pcond-pidep-pievp-picnd-prevp
          wvnew=wv+delv
!
!--- update ice mixing ratios
!
!---
!  * tot_icenew - total mass (small & large) ice after microphysics,
!                 which is the sum of the total mass of large ice in the
!                 current layer and the flux of ice out of the grid box below
!  * rimef      - rime factor, which is the mass ratio of total (unrimed &
!                 rimed) ice mass to the unrimed ice mass (>=1)
!  * qinew      - updated mixing ratio of total (large & small) ice in layer
!      -> tot_icenew=qinew*thick+bldtrh*qlicenew*vsnow
!        -> but qlicenew=qinew*flimass, so
!      -> tot_icenew=qinew*(thick+bldtrh*flimass*vsnow)
!  * asnownew   - updated accumulation of snow at bottom of grid cell
!---
!
          deli=0.
          rimef=1.
          if (ice_logical) then
            deli=pidep+pievp+piacwi+piacr-pimlt
            tot_icenew=tot_ice+thick*deli
            if (tot_ice.gt.0. .and. tot_icenew.ne.0.) then
              dum=tot_icenew/tot_ice
              if (dum .lt. toler) tot_icenew=0.
            endif
            if (tot_icenew .le. climit) then
              tot_icenew=0.
              rimef=1.
              qinew=0.
              asnownew=0.
            else
      !
      !--- update rime factor if appropriate
      !
              dum=piacwi+piacr
              if (dum.le.epsq .and. pidep.le.epsq) then
                rimef=rimef1
              else
         !
         !--- rime factor, rimef = (total ice mass)/(total unrimed ice mass)
         !      dum1 - total ice mass, rimed & unrimed
         !      dum2 - estimated mass of *unrimed* ice
         !
                dum1=tot_ice+thick*(pidep+dum)
                dum2=tot_ice/rimef1+thick*pidep
                if (dum2 .le. 0.) then
                  rimef=rfmax
                else
                  rimef=min(rfmax, max(1., dum1/dum2) )
                endif
              endif       ! endif (dum.le.epsq .and. pidep.le.epsq)
              qinew=tot_icenew/(thick+bldtrh*flimass*vsnow)
              if (qinew .le. epsq) qinew=0.
              if (qi.gt.0. .and. qinew.ne.0.) then
                dum=qinew/qi
                if (dum .lt. toler) qinew=0.
              endif
              asnownew=bldtrh*flimass*vsnow*qinew
              if (asnow.gt.0. .and. asnownew.ne.0.) then
                dum=asnownew/asnow
                if (dum .lt. toler) asnownew=0.
              endif
            endif         ! endif (tot_icenew .le. climit)
          endif           ! endif (ice_logical)
!
!--- update rain mixing ratios
!
!---
! * tot_rainnew - total mass of rain after microphysics
!                 current layer and the input flux of rain from above
! * vrain2      - time-averaged fall speed of rain in grid and below
!                 (with air resistance correction)
! * qrnew       - updated rain mixing ratio in layer
!      -> tot_rainnew=qrnew*(thick+bldtrh*vrain2)
!  * arainnew  - updated accumulation of rain at bottom of grid cell
!---
!
          delr=praut+pracw+piacwr-piacr+pimlt+prevp+picnd
          tot_rainnew=tot_rain+thick*delr
          if (tot_rain.gt.0. .and. tot_rainnew.ne.0.) then
            dum=tot_rainnew/tot_rain
            if (dum .lt. toler) tot_rainnew=0.
          endif
          if (tot_rainnew .le. climit) then
            tot_rainnew=0.
            vrain2=0.
            qrnew=0.
            arainnew=0.
          else
   !
   !--- 1st guess time-averaged rain rate at bottom of grid box
   !
            rr=tot_rainnew/(dtph*gammar)
   !
   !--- use same algorithm as above for calculating mean drop diameter
   !      (idr, in microns), which is used to estimate the time-averaged
   !      fall speed of rain drops at the bottom of the grid layer.  this
   !      isn't perfect, but the alternative is solving a transcendental
   !      equation that is numerically inefficient and nasty to program
   !      (coded in earlier versions of gsmcolumn prior to 8-22-01).
   !
            if (rr .le. rr_drmin) then
              idr=mdrmin
            else if (rr .le. rr_dr1) then
              idr=int( 1.123e3*rr**.1947 + .5 )
              idr=max( mdrmin, min(idr, mdr1) )
            else if (rr .le. rr_dr2) then
              idr=int( 1.225e3*rr**.2017 + .5 )
              idr=max( mdr1, min(idr, mdr2) )
            else if (rr .le. rr_dr3) then
              idr=int( 1.3006e3*rr**.2083 + .5 )
              idr=max( mdr2, min(idr, mdr3) )
            else if (rr .le. rr_drmax) then
              idr=int( 1.355e3*rr**.2144 + .5 )
              idr=max( mdr3, min(idr, mdrmax) )
            else
              idr=mdrmax
            endif              ! endif (rr .le. rr_drmin)
            vrain2=gammar*vrain(idr)
            qrnew=tot_rainnew/(thick+bldtrh*vrain2)
            if (qrnew .le. epsq) qrnew=0.
            if (qr.gt.0. .and. qrnew.ne.0.) then
              dum=qrnew/qr
              if (dum .lt. toler) qrnew=0.
            endif
            arainnew=bldtrh*vrain2*qrnew
            if (arain.gt.0. .and. arainnew.ne.0.) then
              dum=arainnew/arain
              if (dum .lt. toler) arainnew=0.
            endif
          endif                ! endif (tot_rainnew .le. climit)
!
          wcnew=qwnew+qrnew+qinew
!
!----------------------------------------------------------------------
!-------------- begin debugging & verification ------------------------
!----------------------------------------------------------------------
!
!--- qt, qtnew - total water (vapor & condensate) before & after microphysics, resp.
!
          qt=thick*(wv+wc)+arain+asnow
          qtnew=thick*(wvnew+wcnew)+arainnew+asnownew
          budget=qt-qtnew
!
!--- additional check on budget preservation, accounting for truncation effects
!
          dbg_logical=.false.
          dum=abs(budget)
          if (dum .gt. toler) then
            dum=dum/min(qt, qtnew)
            if (dum .gt. toler) dbg_logical=.true.
          endif
!
!          dum=(rhgrd+.001)*qsinew
!          if ( (qwnew.gt.epsq .or. qrnew.gt.epsq .or. wvnew.gt.dum)
!     &        .and. tc.lt.t_ice )  dbg_logical=.true.
!
!          if (tc.gt.5. .and. qinew.gt.epsq) dbg_logical=.true.
!
          if ((wvnew.lt.epsq .or. dbg_logical) .and. print_diag) then
   !
            write(6,"(/2(a,i4),2(a,i2))") '{} i=',i_index,' j=',j_index, &
     &                                    ' l=',l,' lmsc=',lmsc
   !
            esw=1000.*fpvs0(tnew)
            qswnew=eps*esw/(pp-esw)
            if (tc.lt.0. .or. tnew .lt. 0.) then
              esi=1000.*fpvs(tnew)
              qsinew=eps*esi/(pp-esi)
            else
              qsi=qsw
              qsinew=qswnew
            endif
            wsnew=qsinew
            write(6,"(4(a12,g11.4,1x))") &
     & '{} tcold=',tc,'tcnew=',tnew-t0c,'p=',.01*pp,'rho=',rho, &
     & '{} thick=',thick,'rhold=',wv/ws,'rhnew=',wvnew/wsnew, &
     &   'rhgrd=',rhgrd, &
     & '{} rhwold=',wv/qsw,'rhwnew=',wvnew/qswnew,'rhiold=',wv/qsi, &
     &   'rhinew=',wvnew/qsinew, &
     & '{} qswold=',qsw,'qswnew=',qswnew,'qsiold=',qsi,'qsinew=',qsinew, &
     & '{} wsold=',ws,'wsnew=',wsnew,'wvold=',wv,'wvnew=',wvnew, &
     & '{} wcold=',wc,'wcnew=',wcnew,'qwold=',qw,'qwnew=',qwnew, &
     & '{} qiold=',qi,'qinew=',qinew,'qrold=',qr,'qrnew=',qrnew, &
     & '{} arainold=',arain,'arainnew=',arainnew,'asnowold=',asnow, &
     &   'asnownew=',asnownew, &
     & '{} tot_rain=',tot_rain,'tot_rainnew=',tot_rainnew, &
     &   'tot_ice=',tot_ice,'tot_icenew=',tot_icenew, &
     & '{} budget=',budget,'qtold=',qt,'qtnew=',qtnew
   !
            write(6,"(4(a12,g11.4,1x))") &
     & '{} delt=',delt,'delv=',delv,'delw=',delw,'deli=',deli, &
     & '{} delr=',delr,'pcond=',pcond,'pidep=',pidep,'pievp=',pievp, &
     & '{} picnd=',picnd,'prevp=',prevp,'praut=',praut,'pracw=',pracw, &
     & '{} piacw=',piacw,'piacwi=',piacwi,'piacwr=',piacwr,'pimlt=', &
     &    pimlt, &
     & '{} piacr=',piacr
   !
            if (ice_logical) write(6,"(4(a12,g11.4,1x))") &
     & '{} rimef1=',rimef1,'gammas=',gammas,'vrimef=',vrimef, &
     &   'vsnow=',vsnow, &
     & '{} indexs=',float(indexs),'flarge=',flarge,'fsmall=',fsmall, &
     &   'flimass=',flimass, &
     & '{} xsimass=',xsimass,'xlimass=',xlimass,'qlice=',qlice, &
     &   'qtice=',qtice, &
     & '{} nlice=',nlice,'nsmice=',nsmice,'piloss=',piloss, &
     &   'emairi=',emairi, &
     & '{} rimef=',rimef
   !
            if (tot_rain.gt.0. .or. tot_rainnew.gt.0.) &
     &        write(6,"(4(a12,g11.4,1x))") &
     & '{} indexr1=',float(indexr1),'indexr=',float(indexr), &
     &   'gammar=',gammar,'n0r=',n0r, &
     & '{} vrain1=',vrain1,'vrain2=',vrain2,'qtrain=',qtrain,'rqr=',rqr, &
     & '{} prloss=',prloss,'volr1=',thick+bldtrh*vrain1, &
     &   'volr2=',thick+bldtrh*vrain2
   !
            if (praut .gt. 0.) write(6,"(a12,g11.4,1x)") '{} qw0=',qw0
   !
            if (pracw .gt. 0.) write(6,"(a12,g11.4,1x)") '{} fwr=',fwr
   !
            if (piacr .gt. 0.) write(6,"(a12,g11.4,1x)") '{} fir=',fir
   !
            dum=pimlt+picnd-prevp-pievp
            if (dum.gt.0. .or. dwvi.ne.0.) &
     &        write(6,"(4(a12,g11.4,1x))") &
     & '{} tfactor=',tfactor,'dynvis=',dynvis, &
     &   'therm_con=',therm_cond,'diffus=',diffus
   !
            if (prevp .lt. 0.) write(6,"(4(a12,g11.4,1x))") &
     & '{} rfactor=',rfactor,'abw=',abw,'ventr=',ventr,'crevp=',crevp, &
     & '{} dwvr=',dwvr,'denomw=',denomw
   !
            if (pidep.ne.0. .and. dwvi.ne.0.) &
     &        write(6,"(4(a12,g11.4,1x))") &
     & '{} dwvi=',dwvi,'denomi=',denomi,'pidep_max=',pidep_max, &
     &   'sfactor=',sfactor, &
     & '{} abi=',abi,'ventil=',ventil,'ventil1=',venti1(indexs), &
     &   'ventil2=',sfactor*venti2(indexs), &
     & '{} ventis=',ventis,'didep=',didep
   !
            if (pidep.gt.0. .and. pcond.ne.0.) &
     &        write(6,"(4(a12,g11.4,1x))") &
     & '{} denomw=',denomw,'denomwi=',denomwi,'denomf=',denomf, &
     &    'dum2=',pcond-piacw
   !
            if (fws .gt. 0.) write(6,"(4(a12,g11.4,1x))") &
     & '{} fws=',fws
   !
            dum=pimlt+picnd-pievp
            if (dum.gt. 0.) write(6,"(4(a12,g11.4,1x))") &
     & '{} sfactor=',sfactor,'ventil=',ventil,'ventil1=',venti1(indexs), &
     &   'ventil2=',sfactor*venti2(indexs), &
     & '{} aievp=',aievp,'dievp=',dievp,'qsw0=',qsw0,'dwv0=',dwv0
   !
          endif
!
!----------------------------------------------------------------------
!-------------- water budget statistics & maximum values --------------
!----------------------------------------------------------------------
!
          if (print_diag) then
            itdx=max( itlo, min( int(tnew-t0c), ithi ) )
            if (qinew .gt. epsq) nstats(itdx,1)=nstats(itdx,1)+1
            if (qinew.gt.epsq .and.  qrnew+qwnew.gt.epsq) &
     &        nstats(itdx,2)=nstats(itdx,2)+1
            if (qwnew .gt. epsq) nstats(itdx,3)=nstats(itdx,3)+1
            if (qrnew .gt. epsq) nstats(itdx,4)=nstats(itdx,4)+1
  !
            qmax(itdx,1)=max(qmax(itdx,1), qinew)
            qmax(itdx,2)=max(qmax(itdx,2), qwnew)
            qmax(itdx,3)=max(qmax(itdx,3), qrnew)
            qmax(itdx,4)=max(qmax(itdx,4), asnownew)
            qmax(itdx,5)=max(qmax(itdx,5), arainnew)
            qtot(itdx,1)=qtot(itdx,1)+qinew*thick
            qtot(itdx,2)=qtot(itdx,2)+qwnew*thick
            qtot(itdx,3)=qtot(itdx,3)+qrnew*thick
  !
            qtot(itdx,4)=qtot(itdx,4)+pcond*thick
            qtot(itdx,5)=qtot(itdx,5)+picnd*thick
            qtot(itdx,6)=qtot(itdx,6)+pievp*thick
            qtot(itdx,7)=qtot(itdx,7)+pidep*thick
            qtot(itdx,8)=qtot(itdx,8)+prevp*thick
            qtot(itdx,9)=qtot(itdx,9)+praut*thick
            qtot(itdx,10)=qtot(itdx,10)+pracw*thick
            qtot(itdx,11)=qtot(itdx,11)+pimlt*thick
            qtot(itdx,12)=qtot(itdx,12)+piacw*thick
            qtot(itdx,13)=qtot(itdx,13)+piacwi*thick
            qtot(itdx,14)=qtot(itdx,14)+piacwr*thick
            qtot(itdx,15)=qtot(itdx,15)+piacr*thick
  !
            qtot(itdx,16)=qtot(itdx,16)+(wvnew-wv)*thick
            qtot(itdx,17)=qtot(itdx,17)+(qwnew-qw)*thick
            qtot(itdx,18)=qtot(itdx,18)+(qinew-qi)*thick
            qtot(itdx,19)=qtot(itdx,19)+(qrnew-qr)*thick
            qtot(itdx,20)=qtot(itdx,20)+(arainnew-arain)
            qtot(itdx,21)=qtot(itdx,21)+(asnownew-asnow)
            if (qinew .gt. 0.) &
              qtot(itdx,22)=qtot(itdx,22)+qinew*thick/rimef
  !
          endif
!
!----------------------------------------------------------------------
!------------------------- update arrays ------------------------------
!----------------------------------------------------------------------
!
          t_col(l)=tnew                           ! updated temperature
!
          qv_col(l)=max(epsq, wvnew/(1.+wvnew))   ! updated specific humidity
          wc_col(l)=max(epsq, wcnew)              ! updated total condensate mixing ratio
          qi_col(l)=max(epsq, qinew)              ! updated ice mixing ratio
          qr_col(l)=max(epsq, qrnew)              ! updated rain mixing ratio
          qw_col(l)=max(epsq, qwnew)              ! updated cloud water mixing ratio
          rimef_col(l)=rimef                      ! updated rime factor
          asnow=asnownew                          ! updated accumulated snow
          arain=arainnew                          ! updated accumulated rain
!
!#######################################################################
!
10      continue         ! ##### end "l" loop through model levels #####
!
!#######################################################################
!
!-----------------------------------------------------------------------
!--------------------------- return to gsmdrive -----------------------
!-----------------------------------------------------------------------
!
      endsubroutine gsmcolumn
!
!#######################################################################
!--------- produces accurate calculation of cloud condensation ---------
!#######################################################################
!
      real function condense (pp, qw, rhgrd, tk, wv)
!
!---------------------------------------------------------------------------------
!------   the asai (1965) algorithm takes into consideration the release of ------
!------   latent heat in increasing the temperature & in increasing the     ------
!------   saturation mixing ratio (following the clausius-clapeyron eqn.).  ------
!---------------------------------------------------------------------------------
!
      integer, parameter :: high_pres=selected_real_kind(15)
      real (kind=high_pres), parameter :: epsq=1.e-12, &
     & rhlimit=.001, rhlimit1=-rhlimit
      real, parameter :: cp=1004.6, rd=287.04, rv=461.5, eps=rd/rv, &
     & rcp=1./cp, rcprv=rcp/rv
      real (kind=high_pres) :: cond, ssat, wcdum
!
!-----------------------------------------------------------------------
!
!--- lv (t) is from bolton (jas, 1980)
!
      xlv=3.148e6-2370.*tk
      xlv1=xlv*rcp
      xlv2=xlv*xlv*rcprv
      tdum=tk
      wvdum=wv
      wcdum=qw
      esw=1000.*fpvs0(tdum)                     ! saturation vapor press w/r/t water
      ws=rhgrd*eps*esw/(pp-esw)                 ! saturation mixing ratio w/r/t water
      dwv=wvdum-ws                              ! deficit grid-scale water vapor mixing ratio
      ssat=dwv/ws                               ! supersaturation ratio
      condense=0.
      do while ((ssat.lt.rhlimit1 .and. wcdum.gt.epsq) &
     &           .or. ssat.gt.rhlimit)
        cond=dwv/(1.+xlv2*ws/(tdum*tdum))       ! asai (1965, j. japan)
        cond=max(cond, -wcdum)                  ! limit cloud water evaporation
        tdum=tdum+xlv1*cond                     ! updated temperature
        wvdum=wvdum-cond                        ! updated water vapor mixing ratio
        wcdum=wcdum+cond                        ! updated cloud water mixing ratio
        condense=condense+cond                  ! total cloud water condensation
        esw=1000.*fpvs0(tdum)                   ! updated saturation vapor press w/r/t water
        ws=rhgrd*eps*esw/(pp-esw)               ! updated saturation mixing ratio w/r/t water
        dwv=wvdum-ws                            ! deficit grid-scale water vapor mixing ratio
        ssat=dwv/ws                             ! grid-scale supersaturation ratio
      enddo
      endfunction condense
!
!#######################################################################
!---------------- calculate ice deposition at t<t_ice ------------------
!#######################################################################
!
      real function deposit (pp, rhgrd, tdum, wvdum)
!
!--- also uses the asai (1965) algorithm, but uses a different target
!      vapor pressure for the adjustment
!
      integer, parameter :: high_pres=selected_real_kind(15)
      real (kind=high_pres), parameter :: rhlimit=.001, &
     & rhlimit1=-rhlimit
      real, parameter :: cp=1004.6, rd=287.04, rv=461.5, xls=2.834e6, &
     & eps=rd/rv, rcp=1./cp, rcprv=rcp/rv, xls1=xls*rcp, &
     & xls2=xls*xls*rcprv
      real (kind=high_pres) :: dep, ssat
!
!-----------------------------------------------------------------------
!
      esi=1000.*fpvs(tdum)                      ! saturation vapor press w/r/t ice
      ws=rhgrd*eps*esi/(pp-esi)                 ! saturation mixing ratio
      dwv=wvdum-ws                              ! deficit grid-scale water vapor mixing ratio
      ssat=dwv/ws                               ! supersaturation ratio
      deposit=0.
      do while (ssat.gt.rhlimit .or. ssat.lt.rhlimit1)
   !
   !--- note that xlvs2=ls*lv/(cp*rv)=lv*ws/(rv*t*t)*(ls/cp*dep1),
   !     where ws is the saturation mixing ratio following clausius-
   !     clapeyron (see asai,1965; young,1993,p.405)
   !
        dep=dwv/(1.+xls2*ws/(tdum*tdum))        ! asai (1965, j. japan)
        tdum=tdum+xls1*dep                      ! updated temperature
        wvdum=wvdum-dep                         ! updated ice mixing ratio
        deposit=deposit+dep                     ! total ice deposition
        esi=1000.*fpvs(tdum)                    ! updated saturation vapor press w/r/t ice
        ws=rhgrd*eps*esi/(pp-esi)               ! updated saturation mixing ratio w/r/t ice
        dwv=wvdum-ws                            ! deficit grid-scale water vapor mixing ratio
        ssat=dwv/ws                             ! grid-scale supersaturation ratio
      enddo
      endfunction deposit
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        endmodule module_moist
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
